C* 93/09/21  K.Fujii         Compare beamstrahlung spectrum of
C*                           JLC standard and that of Yokoya
C*                           in KEK Preprint 91-2.
C*                              CO : JLC standard.
C*                           The difference is essentially due
C*                           to the definition of xi_1.
C--
C  Statement functions.
C--
      U0(X) = ( 1-0.598*X+1.061*X**(5./3.) )/(1+0.922*X**2)
CN      U0(X) = 1/SQRT(1+X**(2./3.))
C--
      H(X)  = SQRT(3/(8*3.14159))*(SQRT(X/3)/(1+0.53/X**(5./6.)))**(3.
     .        /4.) * EXP(4*(X/3)**(3./4.))
C
C==================< Entry Point >======================================
C
C--
C  Beam parameters.
C--
      SGX  = 0.335
      SGY  = 0.00392
      SGZ  = 85.
      E0   = 150.
      EN   = 0.63E10
C--
C  Natural constant.
C--
      ALF0 = 1./137.
      RE   = 2.8179E-9
      AME  = 0.511E-3
C--
C  Calculate N_cl, N_gamma, and xi_1.
C--
      ENCL = 1.06*ALF0*RE*EN*2/(SGX+SGY)
      XI1  = (RE**2*E0*EN/ALF0/AME/SGZ)/(SGX+SGY) * 2
      ENG  = ENCL * U0(XI1)
C--
CN      ENCL = 1.08*ALF0*RE*EN*2/(SGX+SGY)
CN      XI1  = (RE**2*E0*EN/ALF0/AME/SGZ)/(SGX+SGY) * 5./4.
CN      ENG  = ENCL * U0(2*XI1/3)
C--
      PRINT *, ' ENCL = ', ENCL
      PRINT *, ' ENG  = ', ENG
      PRINT *, ' XI1  = ', XI1
C--
C  Plot beamstrahlung spectrum.
C--
      NEPS  = 400
      EPSMN = 0.5
      EPSMX = 1.0
      DEPS  = (EPSMX-EPSMN)/NEPS
      DO 100 IEPS = 0, NEPS
         EPS = EPSMN + IEPS*DEPS
         Y     = (1/EPS-1)/XI1
         EN1   = ( ENCL + XI1*Y*ENG )/(1+XI1*Y)
         PSI   = EXP(-ENG)*EXP(-Y)*H(EN1*Y**(1./3.))
         WRITE(21,*) EPS, PSI
100   CONTINUE
      WRITE(21,*) ' JOIN '
C--
C  That's it.
C--
      STOP
      END
