C*  92/04/12  K.Fujii	FUNC for e+ e- --> f f_bar H.
C*  95/03/29  K.Fujii	Replaced /TTZCNF/ by /FFHCNF/ to store 
C*			fermion type information.
C*
      REAL FUNCTION FUNC*8(Z)
 
      IMPLICIT REAL*4 ( A-H, O-Z )
      REAL*8   Z(23)
      INCLUDE 'FFHCNF.inc'
=EXPAND 'gen_lib/hg/HGCONS.inc'
=EXPAND 'gen_lib/sm/SMCONS.inc'
=EXPAND 'gen_lib/sm/SMPTAB.inc'
      PARAMETER  ( NP = 5, NHEL = 4 )
      REAL   *4   SG, PV(0:3,NP)
C--
      INTEGER*4  IHEL(NP,2*NHEL)
      DATA ( ( IHEL(I,J),I=1,NP ), J= 1,2*NHEL )  /
     .             -1,+1,   -1, -1, 0,
     .             -1,+1,   -1, +1, 0,
     .             -1,+1,   +1, -1, 0,
     .             -1,+1,   +1, +1, 0,
     .             +1,-1,   -1, -1, 0,
     .             +1,-1,   -1, +1, 0,
     .             +1,-1,   +1, -1, 0,
     .             +1,-1,   +1, +1, 0/
C--
      DATA NCALL /0/
C
C========< Entry Point >================================================
C
C--
C  Initialization.
C--
      IF ( NCALL.EQ.0 ) THEN
         NCALL = 1
         IF ( IHGTYP.EQ.1 ) THEN
            AMSHG = AMHL
         ELSE IF ( IHGTYP.EQ.2 ) THEN
            AMSHG = AMHH
         ELSE IF ( IHGTYP.EQ.3 ) THEN
            AMSHG = AMA
         ELSE IF ( IHGTYP.EQ.4 ) THEN
            AMSHG = AMHM
         ENDIF
      ENDIF
C--
C  Set independent variables.
C     Z( 1) : helicity
C      ( 2) : m(f_bar-f)**2
C      ( 3) : cos(theta_H)
C      ( 4) : phi_H
C      ( 5) : cos(theta_f_bar) in f_bar H rest frame
C      ( 6) : phi_f_bar        in f_bar H rest frame
C--
C  First set initial states.
C--
      IDPTCL(1, 1) = 1
      IDPTCL(2, 1) = 2
      IDPTCL(3, 1) = 1
      IDPTCL(1, 2) = 1
      IDPTCL(2, 2) = 2
      IDPTCL(3, 2) = 1
C--
C  Then select final states.
C     IPT = 3 : fbar
C         = 4 : f
C--
      IDPTCL(1, 3) = IGTLQF(1,1)
      IDPTCL(2, 3) = IGTLQF(2,1)
      IDPTCL(3, 3) = IGTLQF(3,1)
      IDPTCL(1, 4) = IGTLQF(1,2)
      IDPTCL(2, 4) = IGTLQF(2,2)
      IDPTCL(3, 4) = IGTLQF(3,2)
C--
C  Select helicity combination.
C--
      HLM   = (1-POLE)/2
      IF ( Z(1).LT.HLM ) THEN
         IOFF = 0
         BH   = Z(1)/HLM
      ELSE
         IOFF = NHEL
         BH   = (Z(1)-HLM)/(1-HLM)
      ENDIF
      JCMB = NHEL*BH
      JCMB = MIN(JCMB+1,NHEL) + IOFF
      WAT  = NHEL
      CALL UVCOPY(NP,IHEL(1,JCMB),IHLCMB(1))
C--
C  Set invariant masses squared.
C--
      AM3   = AMF(IDPTCL(1,3),IDPTCL(2,3),IDPTCL(3,3))
      AM4   = AMF(IDPTCL(1,4),IDPTCL(2,4),IDPTCL(3,4))
      AM5   = AMSHG
C-- f_bar-f.
      Q22MN = ( AM3 + AM4 )**2
      Q22MX = ( ROOTS - AM5 )**2
      Q22   = Q22MN + (Q22MX-Q22MN)*Z(2)
      WAT   = WAT*(Q22MX-Q22MN)
C--
      XPHASE(1,1) = ROOTS*ROOTS
      XPHASE(1,2) = Q22
C--
C  Angular variables.
C--
      DO 100 IB = 1, 2
         XPHASE(2,IB) = -1 + 2*Z(2*IB+1)
         XPHASE(3,IB) = x2PI  *Z(2*IB+2)
         WAT = WAT*2*x2PI
100   CONTINUE
C--
C  Calculate differential cross sections.
C--
      CALL SGFFH(IHGTYP,IDPTCL,IHLCMB,XPHASE,SG,PV)
      FUNC = SG*WAT
C--
C  Save PV's.
C--
      CALL UVCOPY(4*NP,PV(0,1),PVOUT(0,1))
C--
C  Fill hists. and plots.
C--
      EBM   = ROOTS/2
      S     = ROOTS*ROOTS
      CSNH  = XPHASE(2,1)
      PHIH  = XPHASE(3,1)
      COSFB = XPHASE(2,2)
      PHIFB = XPHASE(3,2)
      CMB   = JCMB - 0.9
      CALL XHFILL(  1, DBLE(CSNH)        ,FUNC )
      CALL XHFILL(  2, DBLE(PHIH)*xRD2DG ,FUNC )
      CALL XHFILL(  3, DBLE(COSFB)       ,FUNC )
      CALL XHFILL(  4, DBLE(PHIFB)*xRD2DG,FUNC )
      CALL XHFILL(  5, DBLE(SQRT(Q22))   ,FUNC )
      CALL XHFILL(  6, DBLE(CMB)         ,FUNC )
C--
C  That's it.
C--
      RETURN
      END
