C*  Differential cross section for e+e- --> ZH.
C*    RS = sqrt(s)
C*    Y  = cos(theta)
C*
      IMPLICIT REAL*4 ( A-H, O-Z )
      DATA LOUNIT / 20 /
C--
C  Differential cross section.
C--
      WRITE(LOUNIT,'(''SET FONT DUPLEX'')')
      WRITE(LOUNIT,'(''NEW FRAME'')')
      WRITE(LOUNIT,'(''SET WINDOW X 2 10 Y 2 8'')')
C     WRITE(LOUNIT,'(''SET LIMITS X 0.0 1.0 Y 0.001 10.'')')
      WRITE(LOUNIT,'(''SET LIMITS X -1.0 1.0 Y 1.E-5 1.'')')
      WRITE(LOUNIT,'(''SET SCALE Y LOGARITHMIC'')')
      WRITE(LOUNIT,'(''SET LABELS SIZE 3.0'')')
      WRITE(LOUNIT,'(''SET TITLE  SIZE 3.0'')')
      WRITE(LOUNIT,'(''TITLE   6. 7.5 SIZE 2.5'',
     .            '' '''' e2+3e2-3 --> ZH'')')
      WRITE(LOUNIT,'(''CASE                   '',
     .            '' ''''  X X X X        '')')
      WRITE(LOUNIT,'(''TITLE 5.7 1.2 ''''cosQ'')')
      WRITE(LOUNIT,'(''CASE          ''''   G'')')
      WRITE(LOUNIT,'(''TITLE 0.2 3.7 ANGLE 90.'',
     .                            '' ''''dS/dcosQ (pb)'')')
      WRITE(LOUNIT,'(''CASE          '''' G     G     '')')
      WRITE(LOUNIT,'(''SET ORDER X Y'')')
C--
      AMH  = 95.
C--
      NY   = 100
      YMN  = -1
      YMX  = 1
      DY   = (YMX-YMN)/NY
C--
      RSMN =  200.
      RSMX = 1000.
      NRS  =   8
      DRS  = (RSMX-RSMN)/NRS
C--
      DO 100 IRS = 0, NRS
         RS  = RSMN + IRS*DRS
         SGT = 0
         DO 10 IY = 0, NY
            Y = YMN + IY*DY
            IF ( IY.EQ.0 .OR. IY.EQ.NY ) THEN
               WT = 1
            ELSE IF ( MOD(IY,2).EQ.0 ) THEN
               WT = 2
            ELSE
               WT = 4
            ENDIF
            CALL SGZHNP(RS,AMH,Y,SG)
            WRITE(LOUNIT,'(2F15.5)') Y, SG
C           PRINT *,  Y, SG
            SGT = SGT + WT*SG
10       CONTINUE
         SGT = SGT*DY/3
         PRINT *, ' RS = ', RS, '(GeV)  SGT = ', SGT, '(pb)'
         WRITE(LOUNIT,'(''JOIN'')')
100   CONTINUE
C--
      STOP
      END
