C* (Update Record)
C*   95/03/25  K.Fujii		Modified for BASES V5.1 in FULL.
C*				Use INSMCN instead of CONINT.
C*

      SUBROUTINE USERIN
 
      IMPLICIT REAL*8 (A-H,O-Z)
C--
      PARAMETER (MXDIM = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,IG(MXDIM),NCALL
      COMMON /BPARM2/ ACC1,ACC2,ITMX1,ITMX2
C--
      INCLUDE 'ZHCNSF.inc'
      INCLUDE 'USRPRM.inc'
=EXPAND 'gen_lib/ss/USSPRM.inc'
=EXPAND 'gen_lib/sm/USMPRM.inc'
=EXPAND 'gen_lib/sm/BEMCNS.inc'
C--
C  Local R*4 variables used in subroutine calls.
C--
      REAL*4        ALF
C
C========< Entry Point >================================================
C
C--
C  Check if inputs from FT05 are consistent with those used in the
C  integration step, when NGETBS = 1. Otherwise, Write the inputs 
C  to 'BASES:Inputs'.
C--
      CALL SPPARM
C--
C  Initialize numerical constants and particle table.
C--
      ALF   = 1/ALFI
      CALL INSMCN(ALF,ALFS,AMSW,AMSZ,AMSH,AMST)
      CALL INSSCN(ALF,ALFS,AMSW,AMSZ,AM0,AMU,AM2,TANB,AMA)
C--
C  Set user constants.
C--
      ROOTS  = SQRTS
      SGEBM  = SGMEBM
      POLE   = POLEBM
      PRINT *, ' ******< Job constants >*********** '
      PRINT *, '  '
      PRINT *, '     ROOTS  = ', ROOTS
      PRINT *, '     POLE   = ', POLE
      PRINT *, '     SGEBM  = ', SGEBM
      PRINT *, '  '
      PRINT *, ' ********************************** '
C--
      IF ( ROOTS.LT.AMSH+AMSZ ) THEN
         PRINT *, ' ROOTS is too small. '
         PRINT *, '    AMH = ', AMSH
         PRINT *, '    AMZ = ', AMSZ
      ENDIF
C--
C  Set BASES constants.
C--
             NDIM   = 16
             NWILD  = 9
C>>> For accumulation.
             NCALL  = 20000
             ITMX1  = 5
             ITMX2  = 10
C>>> For test.
CTEST        NCALL = 100
CTEST        ITMX1  = 1
CTEST        ITMX2  = 1
C--
C  Set lower and upper limits.
C--
      DO 100 IX = 1, NDIM
         XL(IX) = 0
         XU(IX) = 1
100   CONTINUE
      IG(16) = 0
C--
C  Define hists. and plots.
C--
      CALL XHINIT( 1,  0.0D0,  1.0D0, 50,'rs/roots     		')
      CALL XHINIT( 2,  0.0D0,  1.0D0, 50,'m(H)/roots   		')
      CALL XHINIT( 3,  0.0D0,  1.0D0, 50,'m(Z)/roots   		')
      CALL XHINIT( 4,  0.0D0,  1.0D0, 50,'miss/roots   		')
      CALL XHINIT( 5, -1.0D0,  1.0D0, 50,'cos(theta_H) 		')
      CALL XHINIT( 6,  0.0D0, 360.0D0, 50,'phi_H       		')
      CALL XHINIT( 7, -1.0D0,  1.0D0, 50,'cos(theta_b) 		')
      CALL XHINIT( 8,  0.0D0, 360.0D0, 50,'phi_b       		')
      CALL XHINIT( 9, -1.0D0,  1.0D0, 50,'cos(theta_mu)		')
      CALL XHINIT(10,  0.0D0,360.0D0, 50,'phi_mu       		')
      CALL XHINIT(11,  1.0D0,  9.0D0,  8,'helicity combination	')
C--
C  That's it.
C--
      RETURN
      END
