C
C  From junpei@minami.kek.jp Tue Feb  4 12:01:20 JST 1997
C  Received: from minami.kek.jp by jlcuxf.kek.jp with SMTP
C  	(1.40.112.4/16.2) id AA020005279; Tue, 4 Feb 1997 12:01:19 +0900
C  Return-Path: <junpei@minami.kek.jp>
C  Received: by minami.kek.jp
C  	(1.38.193.4/16.2) id AA03616; Tue, 4 Feb 1997 11:52:34 +0900
C  From: Junpei Fujimoto <junpei@minami.kek.jp>
C  Subject: W-mass program (fwd)
C  To: fujiik@jlcuxf.kek.jp
C  Date: Tue, 4 Feb 97 11:52:34 JST
C  Mailer: Elm [revision: 70.85]
C  Status: RO
C  
C  
C        MW.FORT77                                                        
C                                                                               
C ** Calculation of Mw and Delta-r (via iteration) **                           
C ---- This program was made at TU-Muenchen in 1994 ----                        
C
C
C
C**********************************************************************
      SUBROUTINE INIMAS
C**********************************************************************
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /ZHMASS/ ZM, SQZM, WM, SQWM, EM, XM, TAM,
     .                UM, DM, CM, SM, TM, BM, PM, DELWM, DELZM,
     .                ZL, ZLM, Y, CS, SN, ALP,
     .                PAI, VC2, VC3, FLM, FUM, FDM
      COMMON /COMWN/  F1, F2, F3, F4
C
C--------------< Entry Point >-----------------------------------------
C--
C  F1,F2,F3,F4 : Fermion Generation
C--
      F1=1D0
      F2=1D0
      F3=1D0
      F4=0D0
C--
C  Fourth Generation fermion masses
C--
      FLM0=50D0
      FUM0=50D0
      FDM0=50D0
      FLM=FLM0**2                                                               
      FUM=FUM0**2                                                               
      FDM=FDM0**2                                                               
C--
C  Charged leptons
C--      
      EM=5.10999D-4**2
      XM=1.056584D-1**2
      TAM=1.777D0**2
C--
C  Quarks
C--      
      UM=5.8D-2**2                                                              
      DM=5.8D-2**2                                                              
      CM=1.5D0**2                                                               
      SM=9.2D-2**2                                                              
      BM=4.7D0**2                                                               
C--
C  That's it.
C-- 
      RETURN
      END


C**********************************************************************
      SUBROUTINE ZHWMAS( DR, WMASS, SSQZM, TM0, PM0)
C**********************************************************************
C*  INPUT:
C*        SSQZM  : Z MASS
C*        TM0    : TOP QUARK MASS
C*        PM0    : HIGGS MASS
C*  OUTPUT:
C*        DR     : RADIATIVE CORECTION TO W MASS
C*        WMASS(1):
C*        WMASS(2):
C*        WMASS(3):
C*        WMASS(4): Like as Sirlin.
C*        WMASS(5): No corection
C*  NOTE:
C*    94/??/??	Z.Hioki		Original version.
C*    97/02/04  K.Fujii		Received from J.Fujimoto.
C*				Modified to accomodate with the
C*				programs using the older version.
C**********************************************************************
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /ZHMASS/ ZM, SQZM, WM, SQWM, EM, XM, TAM,
     .                UM, DM, CM, SM, TM, BM, PM, DELWM, DELZM,
     .                ZL, ZLM, Y, CS, SN, ALP,
     .                PAI, VC2, VC3, FLM, FUM, FDM
      COMMON /COMWN/  F1, F2, F3, F4
      EXTERNAL ACC
      DIMENSION AA(7), WMFUL(7), WMASS(5)
C
C--------------< Entry Point >-----------------------------------------
C--
C  Z mass
C--
      DSQZM=0.0020D0
      SQZM = SSQZM
C--
C  alpha_{QCD}(Mz)
C--
      ALPSMZ=0.118D0
C--
C  EW couplings.
C--
      ALP=1D0/137.0359895D0
      PAI=3.14159D0
      GF=1.16639D-5
C--
C  End of input section.
C--
      WWW=DSQRT(PAI*ALP/GF/DSQRT(2D0))
      
      SQWM0=DSQRT(SQZM*(SQZM+DSQRT(SQZM**2-4D0*WWW**2))/2D0)
      SQWM=SQWM0
C
      SQZM1=SQZM-1D-2                                                           
      SQWM1=DSQRT(SQZM1*(SQZM1+DSQRT(SQZM1**2-4D0*WWW**2))/2D0)                 
      SQZM2=SQZM+1D-2                                                           
      SQWM2=DSQRT(SQZM2*(SQZM2+DSQRT(SQZM2**2-4D0*WWW**2))/2D0)                 
      DSQWM=DABS((SQWM2-SQWM1)/2D-2)*DSQZM                                      
C                                                                               
      DO 1001 I=1,7,1                                                           
      ZM=SQZM**2                                                                
1000  WM=SQWM**2                                                                
      TM=TM0**2                                                                 
      PM=PM0**2                                                                 
      SN=5.62D-2*F1*F2                                                          
      CS=1D0-SN                                                                 
C  DEF OF ZN                                                                    
      ZN=ZM/64D0/WM/(ZM-WM)*((ZM+2D0*WM)/2D0+ZM*DLOG(ZM)+2D0*WM*DLOG(WM)        
     #)                                                                         
C  DEF OF ZL                                                                    
      ZL=ZM*(5D-1+DLOG(WM))/32D0                                                
     #/(ZM-WM)+(ZM-2D0*WM)**2*(5D-1+DLOG(ZM))/64D0/WM/(ZM-WM)                   
C  DEF OF ZLM ( ZL OF MUON )                                                    
      ZLM=ZM*(5D-1+DLOG(WM))/32D0                                               
     #/(ZM-WM)+(ZM-2D0*WM)**2*(5D-1+DLOG(ZM))/64D0/WM/(ZM-WM)                   
C  DEF OF DELZMF                                                                
      DELZMF=ZM*ZM*(ZM*(2D0*(F1+F2+F3+F4)*E(0D0,0D0,ZM)                         
     #+(1D0+(4D0*WM-3D0*ZM                                                      
     #)**2/ZM/ZM)*(E(EM,EM,ZM)*F1+E(XM,XM,ZM)*F2+E(TAM,TAM,ZM)*F3               
     #+E(FLM,FLM,ZM)*F4)+3D0*(                                                  
     #1D0+(8D0*WM-5D0*ZM)**2/9D0/ZM/ZM)*(E(UM,UM,ZM)*F1+E(CM,CM,ZM)*F2+         
     #E(TM,TM,ZM)*F3+E(FUM,FUM,ZM)*F4)                                          
     #+3D0*(1D0+(4D0*WM-ZM)**2/9D0/ZM/ZM)*(E(DM,DM,ZM)*F1                       
     #+E(SM,SM,ZM)*F2+E(BM,BM,ZM)*F3+E(FDM,FDM,ZM)*F4))                         
     #-EM*E0(EM,EM,ZM)*F1-XM*E0(XM,XM,ZM)*F2-                                   
     #TAM*E0(TAM,TAM,ZM)*F3-                                                    
     #FLM*E0(FLM,FLM,ZM)*F4-3D0*(UM*E0(UM,UM,ZM)*F1+DM*E0(DM,DM,ZM)*F1+         
     #CM*E0(CM,CM,ZM)*F2+SM*E0(SM,SM,ZM)*F2+TM*E0(TM,TM,ZM)*F3+BM*E0(BM,        
     #BM,ZM)*F3+FUM*E0(FUM,FUM,ZM)*F4+FDM*E0(FDM,FDM,ZM)*F4))                   
C  DEF OF DELZM                                                                 
      DELZM=-1D0/32D0/WM/(ZM-WM)*(-ZM*(ZM*ZM-2D0*ZM*WM+4D0*WM*WM)/3D0+          
     #ZM*ZM*ZM*DLOG(ZM)/2D0+WM*(ZM*ZM-4D0*ZM*WM+16D0*WM*WM)*DLOG(WM)+           
     #DELZMF+ZM*(ZM*ZM-4D0*ZM*WM+24D0*WM*WM)*E(WM,WM,ZM)+                       
     #WM*(3D0*ZM*ZM-14D0*ZM*WM-16D0*WM*WM)*E0(WM,WM,ZM)+ZM*ZM*ZM*(2D0*E0        
     #(PM,ZM,ZM)-E2(PM,ZM,ZM)))                                                 
      IF(PM.EQ.0D0)GO TO 100                                                    
      DELZM=DELZM-1D0/32D0/WM/(ZM-WM)                                           
     #*(-PM*ZM*ZM*(E1(ZM,PM,ZM)-DLOG(PM)/2D0))                                  
C  DEF OF DELWMF                                                                
100   DELWMF=2D0*WM*(E(0D0,EM,WM)*F1+E(0D0,XM,WM)*F2+E(0D0,TAM,WM)*F3           
     #+E(0D0,FLM,WM)*F4)-                                                       
     #EM*E1(0D0,EM,WM)*F1-XM*E1(0D0,XM,WM)*F2-TAM*E1(0D0,TAM,WM)*F3             
     #-FLM*E1(0D0,FLM,WM)*F4+3                                                  
     #D0*CS*(2D0*WM*E(UM,DM,WM)*F1-DM*E1(UM,DM,WM)*F1-UM*E1(DM,UM,WM)*F1        
     #)+3D0*SN*(2D0*                                                            
     #WM*E(UM,SM,WM)-SM*E1(UM,SM,WM)-UM*E1(SM,UM,WM))+3D0*CS*(2D0*WM*           
     #E(CM,SM,WM)*F2-SM*E1(CM,SM,WM)*F2-CM*E1(SM,CM,WM)*F2)+                    
     #3D0*SN*(2D0*WM*E(CM,DM,WM)-DM*E1(CM,DM,WM)-CM*E1(DM,CM,WM))+3D0*(2        
     #D0*WM*E(TM,BM,WM)*F3-BM*E1(TM,BM,WM)*F3-TM*E1(BM,TM,WM)*F3)               
     #+3D0*(2D0*WM*E(FUM,FDM,WM)*F4-FDM*E1(FUM,FDM,WM)*F4                       
     #-FUM*E1(FDM,FUM,WM)*F4)                                                   
C  DEF OF DELWM                                                                 
      DELWM=-1D0/32D0/(ZM-WM)*(-WM*ZM+7D0*WM*ZM*DLOG(WM)+ZM*(6D0*WM+ZM/2        
     #D0)*DLOG(ZM)+2D0*ZM*DELWMF+(ZM*ZM-20D0*ZM*WM-8D0*WM*WM)*E0(ZM,WM,W        
     #M)+(ZM*ZM+16D0*ZM*WM+4D0*WM*WM)*E1(ZM,WM,WM)-WM*(ZM+20D0*WM)*E2(ZM        
     #,WM,WM)+4D0*WM*(ZM-WM)*(-2D0*E0(0D0,WM,WM)+E1(0D0,WM,WM)-5D0*E2(0D        
     #0,WM,WM))+ZM*WM*(2D0*E0(PM,WM,WM)-E2(PM,WM,WM)))                          
      IF(PM.EQ.0D0)GO TO 200                                                    
      DELWM=DELWM-1D0/32D0/(ZM-WM)                                              
     #*(PM*ZM*(DLOG(PM)/2D0-E1(WM,PM,WM)))                                      
C  DEF OF Y                                                                     
200   Y=-1D0/48D0+7D0*DLOG(WM)/32D0                                             
     #-F1*(DLOG(EM)+DLOG(DM)/3D0+4D0*DLOG(UM)/3D0)/24D0                         
     #-F2*(DLOG(XM)+DLOG(SM)/3D0+4D0*DLOG(CM)/3D0)/24D0                         
     #-F3*(DLOG(TAM)+DLOG(BM)/3D0+4D0*DLOG(TM)/3D0)/24D0                        
     #-F4*(DLOG(FLM)+DLOG(FDM)/3D0+4D0*DLOG(FUM)/3D0)/24D0                      
C  RUNNING COUPLING-CONSTANT                                                    
      SUM=F1*(DLOG(EM/ZM)+DLOG(DM/ZM)/3D0+4D0*DLOG(UM/ZM)/3D0)                  
     #+F2*(DLOG(XM/ZM)+DLOG(SM/ZM)/3D0+4D0*DLOG(CM/ZM)/3D0)                     
     #+F3*(DLOG(TAM/ZM)+DLOG(BM/ZM)/3D0)                                        
      IF(TM.GE.ZM)GO TO 10                                                      
      SUM=SUM+F3*4D0*DLOG(TM/ZM)/3D0                                            
10    IF(FLM.GE.ZM)GO TO 15                                                     
      SUM=SUM+F4*DLOG(FLM/ZM)                                                   
15    IF(FDM.GE.ZM)GO TO 20                                                     
      SUM=SUM+F4*DLOG(FDM/ZM)/3D0                                               
20    IF(FUM.GE.ZM)GO TO 25                                                     
      SUM=SUM+F4*4D0*DLOG(FUM/ZM)/3D0                                           
25    ALPW1=ALP*(1D0-ALP*SUM/3D0/PAI)                                           
      ALPW2=ALP/(1D0+ALP*SUM/3D0/PAI)                                           
C  DEF OF VF0                                                                   
      VF0=(ZM*DLOG(ZM)-WM*DLOG(WM))/(ZM-WM)-1D0                                 
C  DEF OF VC2                                                                   
      VC2=5D0-6D0*DLOG(WM)-2D0*WM/(ZM-WM)*(5D-1+3D0*VF0)                        
     #-ZM*(ZM-2D0*WM)/2D0/WM/(ZM-WM)*(5D-1+DLOG(ZM))                            
     #+16D0*(DELZM/ZM-(DELZM-DELWM)/(ZM-WM)+2D0*Y+ZL+ZN)                        
C  DEF OF VC3                                                                   
      VC3=VC2-16D0*(ZL-ZLM)                                                     
C                                                                               
C  ----------------  Start of Calculation  -----------------------------        
C                                                                               
      AT=-ALP*PAI*ZM/2D0/WM/(ZM-WM)                                             
      CW=WM/ZM                                                                  
      SW=1D0-CW                                                                 
C  -------------------------------------------------------------------          
      DR=ACC(0D0)/AT                                                            
C  ---------------------------------------------------------------------        
      SUM=F1*(DLOG(EM/ZM)+DLOG(DM/ZM)/3D0+4D0*DLOG(UM/ZM)/3D0+40D0/9D0)         
     #   +F2*(DLOG(XM/ZM)+DLOG(SM/ZM)/3D0+4D0*DLOG(CM/ZM)/3D0+40D0/9D0)         
     #   +F3*(DLOG(TAM/ZM)+DLOG(BM/ZM)/3D0+20D0/9D0)                            
      IF(TM.GE.ZM)GO TO 11                                                      
       SUM=SUM+F3*4D0/3D0*(DLOG(TM/ZM)+5D0/3D0)*0D0                             
11    IF(FLM.GE.ZM)GO TO 16                                                     
       SUM=SUM+F4*(DLOG(FLM/ZM)+5D0/3D0)                                        
16    IF(FDM.GE.ZM)GO TO 21                                                     
       SUM=SUM+F4*(DLOG(FDM/ZM)+5D0/3D0)/3D0                                    
21    IF(FUM.GE.ZM)GO TO 26                                                     
       SUM=SUM+F4*4D0*(DLOG(FUM/ZM)+5D0/3D0)/3D0                                
C  -------------------------------------------------------------------          
C  ---------  Two-loop top-quark corrections  ------------------------          
C  -------------------------------------------------------------------          
26    DALP=-ALP/3D0/PAI*SUM                                                     
         XF=TM*GF/8D0/PAI**2/DSQRT(2D0)                                         
         RPH=DSQRT(PM/TM)                                                       
         IF((PM/TM).LT.16D0) RHO2=-0.7392088D0                                  
     #                           +RPH*(-11.5315D0+0.382497D0*DLOG(RPH))         
     #                           +RPH**2*(5.31338D0-3.055D0*DLOG(RPH)           
     #                                   +0.523039D0*(DLOG(RPH))**2)            
         IF((PM/TM).GE.16D0) RHO2=49D0/4D0+PAI*PAI+27D0/2D0*DLOG(TM/PM)         
     #                           +3D0/2D0*(DLOG(TM/PM))**2                      
     #                           +TM/PM/3D0*(2D0-12D0*PAI*PAI                   
     #                                      +12D0*DLOG(TM/PM)                   
     #                                      -27D0*(DLOG(TM/PM))**2)             
     #                           +(TM/PM)**2/48D0*(1613D0-240D0*PAI*PAI         
     #                                      -1500D0*DLOG(TM/PM)                 
     #                                      -720D0*(DLOG(TM/PM))**2)            
      DRLL=DALP-CW/SW*3D0*ALP*TM/16D0/PAI/SW/WM                                 
      DRREM=DR-DRLL                                                             
C  -------------------------------------------------------------------          
C  ---------  Three-loop QCD corrections  ----------------------------          
C  -------------------------------------------------------------------          
      ALPSMT=ALPSMZ/(1D0+23D0/12D0/PAI*ALPSMZ*DLOG(TM/ZM))                      
      DRHO=3D0*XF*(1D0+XF*RHO2)                                                 
     #       *(1D0-0.9103382915869D0*ALPSMT-1.4786842377797D0*ALPSMT**2)        
C **  DRHO=3D0*XF*(1D0+XF*RHO2                                                  
C ** #            -0.9103382915869D0*ALPSMT-1.4786842377797D0*ALPSMT**2)        
C                                                                               
      DALP=DALP-ALP*ALPSMT*328D0*ZM/PAI**2/729D0/TM                             
      DRREM=DRREM+ALP*ALPSMT/SW/PAI**2*((1D0/3D0-1D0/4D0/SW)/2D0                
     #   *DLOG(TM/ZM)+(-2.404D0+2D0/3D0*PAI**2/6D0+1.25D0)/3D0                  
     #   +(0.601D0-PAI**2/6D0/9D0-1D0/8D0)/SW)                                  
     #   -ALP*ALPSMZ/SW/PAI**2*(CW/SW-1D0)*DLOG(CW)/2D0                         
     #   -1.05D-4*PM/1D6                                                        
      RHO=1D0/(1D0-DRHO)                                                        
C  ---                                                                          
         AA(1)=PAI*ALP/DSQRT(2D0)/GF/(1D0-DALP-DRREM)                           
         AA(2)=PAI*ALP/DSQRT(2D0)/GF/(1D0-DALP)*(1D0+DRREM/(1D0+DRLL))          
         AA(3)=PAI*ALP/DSQRT(2D0)/GF/(1D0-DALP)*(1D0+DRREM/(1D0-DRLL))          
         AA(4)=PAI*ALP/DSQRT(2D0)/GF/(1D0-DALP)/(1D0-DRREM/(1D0-DRLL))          
         AA(5)=PAI*ALP/DSQRT(2D0)/GF/(1D0-DALP)*(1D0+DRREM)                     
         AA(6)=PAI*ALP/DSQRT(2D0)/GF/(1D0-DALP)/(1D0-DRREM)                     
         AA(7)=PAI*ALP/DSQRT(2D0)/GF*(1D0/(1D0-DALP)+DRREM*1D0)                 
      WMFUL(I)=SQZM*DSQRT(RHO*(1D0+DSQRT(1D0-4D0*AA(I)/ZM/RHO))/2D0)            
C  ---------------------------------------------------------------------        
      DD=DABS(WMFUL(I)-SQWM)                                                    
      IF(DD.GT.1D-5) SQWM=WMFUL(I)                                              
1001  IF(DD.GT.1D-5) GO TO 1000                                                 
C  ---------------------------------------------------------------------        
      WMMAX=DMAX1(WMFUL(1),WMFUL(2),WMFUL(3),WMFUL(4),WMFUL(5),                 
     #            WMFUL(6),WMFUL(7))                                            
      WMMIN=DMIN1(WMFUL(1),WMFUL(2),WMFUL(3),WMFUL(4),WMFUL(5),                 
     #            WMFUL(6),WMFUL(7))                                            
      WMF=(WMMAX+WMMIN)/2D0                                                     
      DWMF=(WMMAX-WMMIN)/2D0                                                    
C                                                                               
C      WRITE(6,1)F1,F2,F3,F4,TM0,PM0,SQZM,DSQZM,SQWM0,DSQWM,WMF,DWMF,DR          
1     FORMAT(1H //2X,'FERMI1=',F3.0,2X,'FERMI2=',F3.0,2X,'FERMI3=',F3.0,           
     #2X,'FERMI4=',F3.0//2X,'MT=',F7.2,2X,'MHIGGS=',F7.2//3X,'MZ=',F8.4,
     #1X,'+/-',F7.4,3X,'MW0=',F8.4,1X,'+/-',F7.4///3X,              
     #'MW(FULL-CORR.) =',F9.4,1X,'+/-',F7.4//3X,'DELTA-R=',D15.7/)
      
      WMASS(1) = SQWM0
      WMASS(2) = SQWM0
      WMASS(3) = SQWM0
      WMASS(4) = WMF
      WMASS(5) = SQWM0
C--
C  That's it.
C--
      RETURN
      END



C                                                                               
C ** ACC **                                                                     
C                                                                               
      DOUBLE PRECISION FUNCTION ACC(X)                                          
      IMPLICIT REAL*8(A-H,O-Z)                                                  
      COMMON /ZHMASS/ ZM, SQZM, WM, SQWM, EM, XM, TAM,
     .                UM, DM, CM, SM, TM, BM, PM, DELWM, DELZM,
     .                ZL, ZLM, Y, CS, SN, ALP,
     .                PAI, VC2, VC3, FLM, FUM, FDM
C
      ACC=ALP*ALP*ZM/16D0/WM/(ZM-WM)                                            
     #*(-VC2-VC3+2D0*ZM/WM/(ZM-WM)*AW(X)-1D0-2D0*DLOG(WM)                       
     #+(3D0*ZM*ZM-6D0*ZM*WM-2D0*WM*WM)/(ZM-WM)**2*DLOG(ZM/WM))                  
      RETURN                                                                    
      END                                                                       
C                                                                               
C                                                                               
C ** AW **                                                                      
C                                                                               
      DOUBLE PRECISION FUNCTION AW(X)                                           
      IMPLICIT REAL*8(A-H,O-Z)                                                  
      COMMON /ZHMASS/ ZM, SQZM, WM, SQWM, EM, XM, TAM,
     .                UM, DM, CM, SM, TM, BM, PM, DELWM, DELZM,
     .                ZL, ZLM, Y, CS, SN, ALP,
     .                PAI, VC2, VC3, FLM, FUM, FDM

      AW=-(X-WM)/2D0+(-(PM-2D0*WM)*(E0(PM,WM,X)-E0(PM,WM,WM))                   
     #+(AWFL(X)+AWFQ(X))*2D0                                                    
     #+(PM-WM)*(E1(PM,WM,X)-E1(PM,WM,WM))+X*E(PM,WM,X)-WM*E(PM,WM,WM))          
     #/2D0+(ZM-WM)/ZM*(-7D0*WM*((DLOG(WM)-1D0)-E0(0D0,WM,WM))                   
     #-5D0*(X*(DLOG(WM)-1D0)-WM*E0(0D0,WM,WM))                                  
     #+8D0*WM*((DLOG(WM)-1.5D0)/2D0-E0(0D0,WM,WM)+E1(0D0,WM,WM))                
     #+10D0*(X*(DLOG(WM)/6D0-5D0/36D0)-WM*E(0D0,WM,WM)))                        
     #+((4D0*ZM*ZM-10D0*ZM*WM-28D0*WM*WM)                                       
     #*(E0(WM,ZM,X)-E0(WM,ZM,WM))                                               
     #-20D0*WM*(X*E0(WM,ZM,X)-WM*E0(WM,ZM,WM))                                  
     #+(-2D0*ZM*ZM-30D0*ZM*WM+32D0*WM*WM)*(E1(WM,ZM,X)-E1(WM,ZM,WM))            
     #+(2D0*ZM+4D1*WM)*(X*E(WM,ZM,X)-WM*E(WM,ZM,WM)))/4D0/ZM                    
      RETURN                                                                    
      END                                                                       
C                                                                               
C                                                                               
C ** AWFL **                                                                    
C                                                                               
      DOUBLE PRECISION FUNCTION AWFL(X)                                         
      IMPLICIT REAL*8(A-H,O-Z)                                                  
      COMMON /ZHMASS/ ZM, SQZM, WM, SQWM, EM, XM, TAM,
     .                UM, DM, CM, SM, TM, BM, PM, DELWM, DELZM,
     .                ZL, ZLM, Y, CS, SN, ALP,
     .                PAI, VC2, VC3, FLM, FUM, FDM
      COMMON /COMWN/ F1, F2, F3, F4
C
      AWFL=-EM*(E0(0D0,EM,X)-E0(0D0,EM,WM))*F1                                  
     #+EM*(E0(0D0,EM,X)-E1(0D0,EM,X)-E0(0D0,EM,WM)+E1(0D0,EM,WM))*F1            
     #+2D0*(X*E(0D0,EM,X)-WM*E(0D0,EM,WM))*F1                                   
     #-XM*(E0(0D0,XM,X)-E0(0D0,XM,WM))*F2                                       
     #+XM*(E0(0D0,XM,X)-E0(0D0,XM,WM)-E1(0D0,XM,X)+E1(0D0,XM,WM))*F2            
     #+2D0*(X*E(0D0,XM,X)-WM*E(0D0,XM,WM))*F2                                   
     #-TAM*(E0(0D0,TAM,X)-E0(0D0,TAM,WM))*F3                                    
     #+TAM*(E0(0D0,TAM,X)-E0(0D0,TAM,WM)-E1(0D0,TAM,X)+E1(0D0,TAM,WM))*F        
     #3                                                                         
     #+2D0*(X*E(0D0,TAM,X)-WM*E(0D0,TAM,WM))*F3                                 
     #-FLM*(E0(0D0,FLM,X)-E0(0D0,FLM,WM))*F4                                    
     #+FLM*(E0(0D0,FLM,X)-E0(0D0,FLM,WM)-E1(0D0,FLM,X)+E1(0D0,FLM,WM))          
     #*F4                                                                       
     #+2D0*(X*E(0D0,FLM,X)-WM*E(0D0,FLM,WM))*F4                                 
      RETURN                                                                    
      END                                                                       
C                                                                               
C                                                                               
C ** AWFQ **                                                                    
C                                                                               
      DOUBLE PRECISION FUNCTION AWFQ(X)                                         
      IMPLICIT REAL*8(A-H,O-Z)                                                  
      COMMON /ZHMASS/ ZM, SQZM, WM, SQWM, EM, XM, TAM,
     .                UM, DM, CM, SM, TM, BM, PM, DELWM, DELZM,
     .                ZL, ZLM, Y, CS, SN, ALP,
     .                PAI, VC2, VC3, FLM, FUM, FDM
      COMMON /COMWN/  F1, F2, F3, F4
C
      AWFQ=3D0*(                                                                
     #CS*(-DM*(E0(DM,UM,X)-E0(DM,UM,WM))                                        
     #+(DM-UM)*(E1(DM,UM,X)-E1(DM,UM,WM))                                       
     #+2D0*(X*E(DM,UM,X)-WM*E(DM,UM,WM)))*F1                                    
     #+SN*(-SM*(E0(SM,UM,X)-E0(SM,UM,WM))                                       
     #+(SM-UM)*(E1(SM,UM,X)-E1(SM,UM,WM))                                       
     #+2D0*(X*E(SM,UM,X)-WM*E(SM,UM,WM)))                                       
     #+CS*(-SM*(E0(SM,CM,X)-E0(SM,CM,WM))                                       
     #+(SM-CM)*(E1(SM,CM,X)-E1(SM,CM,WM))                                       
     #+2D0*(X*E(SM,CM,X)-WM*E(SM,CM,WM)))*F2                                    
     #+SN*(-DM*(E0(DM,CM,X)-E0(DM,CM,WM))                                       
     #+(DM-CM)*(E1(DM,CM,X)-E1(DM,CM,WM))                                       
     #+2D0*(X*E(DM,CM,X)-WM*E(DM,CM,WM)))                                       
     #-BM*(E0(BM,TM,X)-E0(BM,TM,WM))*F3                                         
     #+(BM-TM)*(E1(BM,TM,X)-E1(BM,TM,WM))*F3                                    
     #+2D0*(X*E(BM,TM,X)-WM*E(BM,TM,WM))*F3                                     
     #-FDM*(E0(FDM,FUM,X)-E0(FDM,FUM,WM))*F4                                    
     #+(FDM-FUM)*(E1(FDM,FUM,X)-E1(FDM,FUM,WM))*F4                              
     #+2D0*(X*E(FDM,FUM,X)-WM*E(FDM,FUM,WM))*F4)                                
      RETURN                                                                    
      END                                                                       
C                                                                               
C                                                                               
C ** E0 **                                                                      
C                                                                               
      DOUBLE PRECISION FUNCTION E0(X,Y,Z)                                       
      IMPLICIT REAL*8(A-H,O-Z)                                                  
        WD=X-Y                                                                  
       IF(WD.NE.0D0) GO TO 1                                                    
        WS=X+Y                                                                  
       IF(WS.NE.0D0) GO TO 2                                                    
       IF(Z.NE.0D0) GO TO 3                                                     
      E0=0D0                                                                    
       RETURN                                                                   
3     E0=DLOG(DABS(Z))-2D0                                                      
       RETURN                                                                   
2      IF(Z) 10,20,30                                                           
10      WX=Z**2/(X**2*(DABS(DLOG(X))))-10D-4                                    
       IF(WX.GE.0D0) GO TO 200                                                  
      E0=DLOG(X)-Z/(6D0*X)                                                      
       RETURN                                                                   
200   E0=DLOG(X)-2D0+DSQRT(1D0-4D0*X/Z)                                         
     #               *DLOG((2D0*X-Z+DSQRT((-Z)*(4D0*X-Z)))/(2D0*X))             
       RETURN                                                                   
20    E0=DLOG(X)                                                                
       RETURN                                                                   
30      WZ=Z-4D0*X                                                              
       IF(WZ.GE.0D0) GO TO 1000                                                 
      E0=DLOG(X)-2D0+2D0*DSQRT((4D0*X-Z)/Z)                                     
     #                    *DATAN(DSQRT(Z/(4D0*X-Z)))                            
       RETURN                                                                   
1000  E0=DLOG(X)-2D0+DSQRT((Z-4D0*X)/Z)                                         
     #                 *DLOG((Z-2D0*X+DSQRT(Z*(Z-4D0*X)))/(2D0*X))              
       RETURN                                                                   
1      IF(X.NE.0D0) GO TO 6                                                     
       IF(Y.NE.Z) GO TO 35                                                      
      E0=DLOG(Z)-2D0                                                            
       RETURN                                                                   
35      RYZ=DABS(Z/Y)-1D-4                                                      
       IF(RYZ.GE.0D0) GO TO 36                                                  
      E0=-1D0+DLOG(Y)-Z/2D0/Y                                                   
       RETURN                                                                   
36    E0=(1D0-Y/Z)*DLOG(DABS(Z-Y))+Y*DLOG(Y)/Z-2D0                              
       RETURN                                                                   
6       WY=Y-Z                                                                  
       IF(WY.NE.0D0) GO TO 40                                                   
        WB=4D0*Z-X                                                              
       IF(WB.GT.0D0) GO TO 300                                                  
       IF(Z/X.GT.1D-5)GO TO 303                                                 
      E0=DLOG(X)-1D0-Z/X*(5D-1+DLOG(Z/X))                                       
     #  -(Z/X)**2*(5D0/3D0+2D0*DLOG(Z/X))                                       
       RETURN                                                                   
303   E0=X*DLOG(X)/(2D0*Z)-(X-2D0*Z)*DLOG(Z)/(2D0*Z)-2D0                        
     #  -DSQRT(X*(X-4D0*Z))*DLOG((X+DSQRT(X*(X-4D0*Z)))**2                      
     #                                       /(4D0*X*Z))/2D0/Z                  
       RETURN                                                                   
300   E0=X*DLOG(X)/(2D0*Z)-(X-2D0*Z)*DLOG(Z)/(2D0*Z)-2D0                        
     #  +DSQRT(X*(4D0*Z-X))*(DATAN((2D0*Z-X)/(DSQRT(X*(4D0*Z-X))))              
     #                       +DATAN(X/(DSQRT(X*(4D0*Z-X)))))/Z                  
       RETURN                                                                   
40      WA=X-Z                                                                  
       IF(WA.NE.0D0) GO TO 50                                                   
        WB=4D0*Z-Y                                                              
       IF(WB.GT.0D0) GO TO 400                                                  
       IF(Z/Y.GT.1D-5)GO TO 404                                                 
      E0=DLOG(Y)-1D0-Z/Y*(5D-1+DLOG(Z/Y))                                       
     #  -(Z/Y)**2*(5D0/3D0+2D0*DLOG(Z/Y))                                       
       RETURN                                                                   
404   E0=Y*DLOG(Y)/(2D0*Z)-(Y-2D0*Z)*DLOG(Z)/(2D0*Z)-2D0                        
     #  -DSQRT(Y*(Y-4D0*Z))*DLOG((Y+DSQRT(Y*(Y-4D0*Z)))**2                      
     #                                              /(4D0*Y*Z))/2D0/Z           
       RETURN                                                                   
400   E0=Y*DLOG(Y)/(2D0*Z)-(Y-2D0*Z)*DLOG(Z)/(2D0*Z)-2D0                        
     #  +DSQRT(Y*(4D0*Z-Y))*(DATAN((2D0*Z-Y)/(DSQRT(Y*(4D0*Z-Y))))              
     #                       +DATAN(Y/(DSQRT(Y*(4D0*Z-Y)))))/Z                  
       RETURN                                                                   
50      WW=(Z/(X-Y))**2-5D-6                                                    
       IF(WW.GE.0D0) GO TO 4000                                                 
       IF(X/Y.GT.1D-6)GO TO 123                                                 
      E0=DLOG(Y)-1D0-(Z/2D0+X*DLOG(X/Y))/Y                                      
       RETURN                                                                   
123    IF(Y/X.GT.1D-6)GO TO 234                                                 
      E0=DLOG(X)-1D0-(Z/2D0+Y*DLOG(Y/X))/X                                      
       RETURN                                                                   
234    AA=X/(Y-X)                                                               
      E0=(X*DLOG(X)-Y*DLOG(Y))/(X-Y)-1D0                                        
     #  -((X+Y)/2D0/(Y-X)-X*Y/(X-Y)**2*DLOG(Y/X))*Z/(Y-X)                       
     #  -(Z/(X-Y))**2*(1D0/6D0+2D0*AA*(AA+1D0)                                  
     #                  -AA*(AA+1D0)*(AA+AA+1D0)*DLOG(Y/X))                     
       RETURN                                                                   
4000    QM1=Z-(DSQRT(X)-DSQRT(Y))**2                                            
        QM2=Z-(DSQRT(X)+DSQRT(Y))**2                                            
       IF(QM1) 5000,5000,7                                                      
7      IF(QM2) 70,5000,5000                                                     
70      CC=(4D0*X*Z-(X-Y+Z)**2)/4D0/Z/Z                                         
        UU=-(X-Y-Z)/2D0/Z                                                       
        DD=-(X-Y+Z)/2D0/Z                                                       
      E0=DLOG(Z)                                                                
     #  +UU*(DLOG(UU**2+CC)-2D0)+2D0*DSQRT(CC)*DATAN(UU/DSQRT(CC))              
     #  -DD*(DLOG(DD**2+CC)-2D0)-2D0*DSQRT(CC)*DATAN(DD/DSQRT(CC))              
       RETURN                                                                   
5000   IF(Z-X-Y) 7000,6000,6000                                                 
6000  E0=((Z-X+Y)*DLOG(Y)+(Z+X-Y)*DLOG(X)-4D0*Z+DSQRT((Z+X-Y)**2                
     #  -4D0*X*Z)*DLOG((Z-X-Y+DSQRT((Z+X-Y)**2-4D0*X*Z))**2                     
     #                                 /(4D0*X*Y)))/(2D0*Z)                     
       RETURN                                                                   
7000  E0=((Z-X+Y)*DLOG(Y)+(Z+X-Y)*DLOG(X)-4D0*Z-DSQRT((Z+X-Y)**2                
     #  -4D0*X*Z)*DLOG((Z-X-Y-DSQRT((Z+X-Y)**2-4D0*X*Z))**2                     
     #                                 /(4D0*X*Y)))/(2D0*Z)                     
       RETURN                                                                   
      END                                                                       
C                                                                               
C                                                                               
C ** E1 **                                                                      
C                                                                               
      DOUBLE PRECISION FUNCTION E1(X,Y,Z)                                       
      IMPLICIT REAL*8(A-H,O-Z)                                                  
        WD=X-Y                                                                  
       IF(WD.NE.0D0) GO TO 1                                                    
        WS=X+Y                                                                  
       IF(WS.NE.0D0) GO TO 2                                                    
       IF(Z.NE.0D0) GO TO 3                                                     
      E1=0D0                                                                    
       RETURN                                                                   
3     E1=(DLOG(DABS(Z))-2D0)/2D0                                                
       RETURN                                                                   
2      IF(Z) 10,20,30                                                           
10      WX=Z**2/(X**2*(DABS(DLOG(X))))-10D-4                                    
       IF(WX.GE.0D0) GO TO 200                                                  
      E1=(DLOG(X)-Z/(6D0*X))/2D0                                                
       RETURN                                                                   
200   E1=(DLOG(X)-2D0+DSQRT(1D0-4D0*X/Z)                                        
     #              *DLOG((2D0*X-Z+DSQRT((-Z)*(4D0*X-Z)))/(2D0*X)))/2D0         
       RETURN                                                                   
20    E1=(DLOG(X))/2D0                                                          
       RETURN                                                                   
30      WZ=Z-4D0*X                                                              
       IF(WZ.GE.0D0) GO TO 1000                                                 
      E1=(DLOG(X)-2D0+2D0*DSQRT((4D0*X-Z)/Z)                                    
     #                     *DATAN(DSQRT(Z/(4D0*X-Z))))/2D0                      
       RETURN                                                                   
1000  E1=(DLOG(X)-2D0+DSQRT((Z-4D0*X)/Z)                                        
     #                 *DLOG((Z-2D0*X+DSQRT(Z*(Z-4D0*X)))/(2D0*X)))/2D0         
       RETURN                                                                   
1      IF(X.NE.0D0) GO TO 6                                                     
       IF(Y.NE.Z) GO TO 35                                                      
      E1=(DLOG(Z)-1D0)*5D-1                                                     
       RETURN                                                                   
35      RYZ=DABS(Z/Y)-1D-4                                                      
       IF(RYZ.GE.0D0) GO TO 36                                                  
      E1=-1D0/4D0+DLOG(Y)/2D0-Z/6D0/Y                                           
       RETURN                                                                   
36    E1=(1D0-Y/Z)**2/2D0*DLOG(DABS(Z-Y))+Y*(2D0*Z-Y)/2D0/Z/Z*DLOG(Y)           
     #  -1D0+Y/(2D0*Z)                                                          
       RETURN                                                                   
6       WY=Y-Z                                                                  
       IF(WY.NE.0D0) GO TO 40                                                   
        WB=4D0*Z-X                                                              
       IF(WB.GT.0D0) GO TO 300                                                  
       IF(Z/X.GT.5D-4)GO TO 303                                                 
      E1=DLOG(X)/2D0-3D0/4D0-Z/X*(5D0/6D0+DLOG(Z/X))                            
     #  -(Z/X)**2*(59D0/24D0+5D0/2D0*DLOG(Z/X))                                 
       RETURN                                                                   
303   E1=(X*X-2D0*X*Z)*DLOG(X)/(4D0*Z*Z)+(2D0*Z*X-X*X+2D0*Z*Z)*DLOG(Z)          
     #                                               /(4D0*Z*Z)-1D0/2D0         
     #  -DSQRT(X*(X-4D0*Z))*DLOG((X+DSQRT(X*(X-4D0*Z)))**2                      
     #                                  /(4D0*X*Z))/4D0/Z/Z*X-X/(2D0*Z)         
       RETURN                                                                   
300   E1=(-2D0*X*Z+X*X)*DLOG(X)/(4D0*Z*Z)+(2D0*Z*X-X*X+2D0*Z*Z)*DLOG(Z)         
     #                                               /(4D0*Z*Z)-1D0/2D0         
     #  +DSQRT(X*(4D0*Z-X))*(DATAN((2D0*Z-X)/(DSQRT(X*(4D0*Z-X))))              
     #                +DATAN(X/(DSQRT(X*(4D0*Z-X)))))/2D0/Z/Z*X-X/2D0/Z         
       RETURN                                                                   
40      WA=X-Z                                                                  
       IF(WA.NE.0D0) GO TO 50                                                   
        WB=4D0*Z-Y                                                              
       IF(WB.GT.0D0) GO TO 400                                                  
       IF(Z/Y.GT.3D-4)GO TO 404                                                 
      E1=DLOG(Y)/2D0-1D0/4D0+Z/3D0/Y                                            
     #  -(Z/Y)**2*(5D0/3D0+2D0*DLOG(Z/Y))                                       
     #  +(Z/Y)**2*(59D0/24D0+5D0/2D0*DLOG(Z/Y))                                 
       RETURN                                                                   
404   E1=Y*DLOG(Y)/(2D0*Z)-(Y-2D0*Z)*DLOG(Z)/(2D0*Z)-2D0                        
     #  -DSQRT(Y*(Y-4D0*Z))*DLOG((Y+DSQRT(Y*(Y-4D0*Z)))**2                      
     #                                        /(4D0*Y*Z))/2D0/Z                 
     #  -(Y*Y-2D0*Y*Z)*DLOG(Y)/(4D0*Z*Z)-(2D0*Z*Y-Y*Y+2D0*Z*Z)*DLOG(Z)          
     #                                               /(4D0*Z*Z)+1D0/2D0         
     #  +DSQRT(Y*(Y-4D0*Z))*DLOG((Y+DSQRT(Y*(Y-4D0*Z)))**2                      
     #                                  /(4D0*Y*Z))/4D0/Z/Z*Y+Y/(2D0*Z)         
       RETURN                                                                   
400   E1=Y*DLOG(Y)/(2D0*Z)-(Y-2D0*Z)*DLOG(Z)/(2D0*Z)-2D0                        
     #  +DSQRT(Y*(4D0*Z-Y))*(DATAN((2D0*Z-Y)/(DSQRT(Y*(4D0*Z-Y))))              
     #                       +DATAN(Y/(DSQRT(Y*(4D0*Z-Y)))))/Z                  
     #  -((-2D0*Y*Z+Y*Y)*DLOG(Y)/(4D0*Z*Z)+(2D0*Z*Y-Y*Y+2D0*Z*Z)*DLOG(Z)        
     #                                                /(4D0*Z*Z)-1D0/2D0        
     #  +DSQRT(Y*(4D0*Z-Y))*(DATAN((2D0*Z-Y)/(DSQRT(Y*(4D0*Z-Y))))              
     #                +DATAN(Y/(DSQRT(Y*(4D0*Z-Y)))))/2D0/Z/Z*Y-Y/2D0/Z)        
       RETURN                                                                   
50      WW=(Z/(X-Y))**2-5D-6                                                    
       IF(WW.GE.0D0) GO TO 4000                                                 
       IF(X/Y.GT.1D-7)GO TO 123                                                 
      E1=DLOG(Y)/2D0-1D0/4D0-(Z/6D0-X/2D0)/Y                                    
       RETURN                                                                   
123    IF(Y/X.GT.1D-7)GO TO 234                                                 
      E1=DLOG(X)/2D0-3D0/4D0-(Z/3D0+Y/2D0+Y*DLOG(Y/X))/X                        
       RETURN                                                                   
234    AA=X/(Y-X)                                                               
      E1=(DLOG(Y)-X*X/(Y-X)**2*DLOG(Y/X)-5D-1+X/(Y-X))/2D0                      
     #  -(2D0*X*X*Y/(Y-X)**3*DLOG(Y/X)+1D0/3D0-X*(X+Y)/(X-Y)**2)                
     #   *Z/(Y-X)/2D0                                                           
     #  -(Z/(X-Y))**2/2D0                                                       
     #     *(1D0/4D0-(AA+1D0)*(5D0/3D0+(5D0*AA+3D0)*(AA-5D-1))                  
     #       +AA*AA*(AA+1D0)*(5D0*AA+3D0)*DLOG(Y/X))                            
       RETURN                                                                   
4000    QM1=Z-(DSQRT(X)-DSQRT(Y))**2                                            
        QM2=Z-(DSQRT(X)+DSQRT(Y))**2                                            
       IF(QM1) 5000,5000,7                                                      
7      IF(QM2) 70,5000,5000                                                     
70      CC=(4D0*X*Z-(X-Y+Z)**2)/4D0/Z/Z                                         
        UU=-(X-Y-Z)/2D0/Z                                                       
        DD=-(X-Y+Z)/2D0/Z                                                       
      E1=DLOG(Z)/2D0                                                            
     #  +((UU*UU+CC)*DLOG(UU*UU+CC)-UU*UU)/2D0                                  
     #  -((DD*DD+CC)*DLOG(DD*DD+CC)-DD*DD)/2D0                                  
     #  -DD*(UU*(DLOG(UU**2+CC)-2D0)+2D0*DSQRT(CC)*DATAN(UU/DSQRT(CC))          
     #      -DD*(DLOG(DD**2+CC)-2D0)-2D0*DSQRT(CC)*DATAN(DD/DSQRT(CC)))         
       RETURN                                                                   
5000   IF(Z-X-Y) 7000,6000,6000                                                 
6000  E1=(2D0*Z**2*DLOG(Y)-((Z+X-Y)**2-2D0*X*Z)*DLOG(Y/X)                       
     #  -4D0*Z**2-2D0*Z*(X-Y)                                                   
     #  +(Z+X-Y)*DSQRT((Z+X-Y)**2-4D0*X*Z)                                      
     # *DLOG((Z-X-Y+DSQRT((Z+X-Y)**2-4D0*X*Z))**2/(4D0*X*Y)))/(4D0*Z**2)        
       RETURN                                                                   
7000  E1=(2D0*Z**2*DLOG(Y)-((Z+X-Y)**2-2D0*X*Z)*DLOG(Y/X)                       
     #  -4D0*Z**2-2D0*Z*(X-Y)                                                   
     #  -(Z+X-Y)*DSQRT((Z+X-Y)**2-4D0*X*Z)                                      
     # *DLOG((Z-X-Y-DSQRT((Z+X-Y)**2-4D0*X*Z))**2/(4D0*X*Y)))/(4D0*Z**2)        
       RETURN                                                                   
      END                                                                       
C                                                                               
C                                                                               
C ** E2 **                                                                      
C                                                                               
      DOUBLE PRECISION FUNCTION E2(X,Y,Z)                                       
      IMPLICIT REAL*8(A-H,O-Z)                                                  
        WD=X-Y                                                                  
       IF(WD.NE.0D0) GO TO 1                                                    
        WS=X+Y                                                                  
       IF(WS.NE.0D0) GO TO 2                                                    
       IF(Z.NE.0D0) GO TO 3                                                     
      E2=0D0                                                                    
       RETURN                                                                   
3     E2=DLOG(DABS(Z))/3D0-13D0/18D0                                            
       RETURN                                                                   
2      IF(Z) 10,20,30                                                           
10      WX=Z**2/(X**2*(DABS(DLOG(X))))-10D-4                                    
       IF(WX.GE.0D0) GO TO 200                                                  
      E2=DLOG(X)/3D0-Z/(20D0*X)                                                 
       RETURN                                                                   
200   E2=DLOG(X)/3D0-13D0/18D0+DSQRT(1D0-4D0*X/Z)                               
     #                   *DLOG((2D0*X-Z+DSQRT((-Z)*(4D0*X-Z)))/(2D0*X))         
     #                                     *(1D0-X/Z)/3D0+2D0*X/(3D0*Z)         
       RETURN                                                                   
20    E2=DLOG(X)/3D0                                                            
       RETURN                                                                   
30      WZ=Z-4D0*X                                                              
       IF(WZ.GE.0D0) GO TO 1000                                                 
       IF(Z/X.GE.1D-5) GO TO 31                                                 
      E2=DLOG(X)/3D0-Z/2D1/X                                                    
       RETURN                                                                   
31    E2=DLOG(X)/3D0-13D0/18D0+2D0*(Z-X)/3D0*DSQRT((4D0*X-Z)/Z)                 
     #                       *DATAN(DSQRT(Z/(4D0*X-Z)))/Z+2D0*X/(3D0*Z)         
       RETURN                                                                   
1000  E2=DLOG(X)/3D0-13D0/18D0+(Z-X)/3D0*DSQRT((Z-4D0*X)/Z)                     
     #      *DLOG((Z-2D0*X+DSQRT(Z*(Z-4D0*X)))/(2D0*X))/Z+2D0*X/(3D0*Z)         
       RETURN                                                                   
1      IF(X.NE.0D0) GO TO 6                                                     
       IF(Y.NE.Z) GO TO 35                                                      
      E2=(3D0*DLOG(Z)-2D0)/9D0                                                  
       RETURN                                                                   
35      RYZ=DABS(Z/Y)-1D-4                                                      
       IF(RYZ.GE.0D0) GO TO 36                                                  
      E2=-1D0/9D0+DLOG(Y)/3D0-Z/12D0/Y                                          
       RETURN                                                                   
36    E2=(1D0-Y/Z)**3*DLOG(DABS(Z-Y))/3D0+Y*(3D0*Z*Z-3D0*Y*Z+Y**2)              
     #          *DLOG(Y)/Z**3/3D0-13D0/18D0+5D0*Y/(6D0*Z)-Y*Y/(3D0*Z*Z)         
       RETURN                                                                   
6       WY=Y-Z                                                                  
       IF(WY.NE.0D0) GO TO 40                                                   
        WB=4D0*Z-X                                                              
       IF(WB.GT.0D0) GO TO 300                                                  
       IF(Z/X.GT.1D-3)GO TO 303                                                 
      E2=DLOG(X)/3D0-11D0/18D0-Z/X*(13D0/12D0+DLOG(Z/X))                        
     #  -(Z/X)**2*(67D0/2D1+3D0*DLOG(Z/X))                                      
       RETURN                                                                   
303   E2=DLOG(Z)/3D0+X**2*(X-3D0*Z)*DLOG(X/Z)/(6D0*Z**3)                        
     #  -2D0/9D0                                                                
     #  -DSQRT(X*(X-4D0*Z))*DLOG((X+DSQRT(X*(X-4D0*Z)))**2                      
     #         /(4D0*X*Z))/(6D0*Z**3)*X*(X-Z)+X*(3D0*Z-2D0*X)/(6D0*Z*Z)         
       RETURN                                                                   
300   E2=DLOG(Z)/3D0+X**2*(X-3D0*Z)*DLOG(X/Z)/(6D0*Z**3)                        
     #  -2D0/9D0                                                                
     #  +DSQRT(X*(4D0*Z-X))*(DATAN((2D0*Z-X)/(DSQRT(X*(4D0*Z-X))))              
     #               +DATAN(X/(DSQRT(X*(4D0*Z-X)))))/(Z**3*3D0)*X*(X-Z)         
     #  +X*(3D0*Z-2D0*X)/(6D0*Z*Z)                                              
       RETURN                                                                   
40      WA=X-Z                                                                  
       IF(WA.NE.0D0) GO TO 50                                                   
        WB=4D0*Z-Y                                                              
       IF(WB.GT.0D0) GO TO 400                                                  
       IF(Z/Y.GT.2D-3)GO TO 404                                                 
      E2=DLOG(Y)/3D0-1D0/9D0+Z/12D0/Y                                           
     #  -(Z/Y)**2*(5D0/3D0+2D0*DLOG(Z/Y))                                       
     #  +2D0*(Z/Y)**2*(59D0/24D0+5D0/2D0*DLOG(Z/Y))                             
     #  -(Z/Y)**2*(67D0/2D1+3D0*DLOG(Z/Y))                                      
       RETURN                                                                   
404   E2=((9D0*Z*Z-6D0*Y*Z+Y*Y)*Y*DLOG(Y)+(2D0*Z**3-9D0*Y*Z*Z                   
     #  +6D0*Y*Y*Z-Y**3)*DLOG(Z)-Z*(22D0*Z*Z-27D0*Y*Z+6D0*Y*Y)/3D0              
     #  -(3D0*Z-Y)*(Z-Y)*DSQRT(Y*(Y-4D0*Z))                                     
     #           *DLOG((Y+DSQRT(Y*(Y-4D0*Z)))**2/(4D0*Y*Z)))/(6D0*Z**3)         
       RETURN                                                                   
400   E2=((9D0*Z*Z-6D0*Y*Z+Y*Y)*Y*DLOG(Y)+(2D0*Z**3-9D0*Y*Z*Z                   
     #  +6D0*Y*Y*Z-Y**3)*DLOG(Z)-Z*(22D0*Z*Z-27D0*Y*Z+6D0*Y*Y)/3D0              
     #  +(3D0*Z-Y)*(Z-Y)*DSQRT(Y*(4D0*Z-Y))                                     
     #            *(DATAN((2D0*Z-Y)/DSQRT(Y*(4D0*Z-Y)))                         
     #              +DATAN(DSQRT(Y/(4D0*Z-Y))))*2D0)/(6D0*Z**3)                 
       RETURN                                                                   
50      WW=(Z/(X-Y))**2-5D-6                                                    
       IF(WW.GE.0D0) GO TO 4000                                                 
       IF(X/Y.GT.1D-7)GO TO 123                                                 
      E2=DLOG(Y)/3D0-1D0/9D0-(Z/12D0-X/6D0)/Y                                   
       RETURN                                                                   
123    IF(Y/X.GT.1D-7)GO TO 234                                                 
      E2=DLOG(X)/3D0-11D0/18D0-(Z/4D0+5D0/6D0*Y+Y*DLOG(Y/X))/X                  
       RETURN                                                                   
234    AA=X/(Y-X)                                                               
      E2=(DLOG(Y)+(X/(Y-X))**3*DLOG(Y/X)-1D0/3D0+X/(Y-X)/2D0                    
     #  -(X/(Y-X))**2)/3D0-(1D0/12D0-AA/6D0+AA*AA/2D0+AA**3                     
     #  -AA**3*(AA+1D0)*DLOG(Y/X))*Z/(Y-X)                                      
     #  -(Z/(X-Y))**2                                                           
     #     *(1D-1-(AA+1D0)                                                      
     #              *(3D0/4D0-(3D0*AA+2D0)*(AA*AA-AA/2D0+1D0/3D0))              
     #  -AA**3*(AA+1D0)*(3D0*AA+2D0)*DLOG(Y/X))                                 
       RETURN                                                                   
4000    QM1=Z-(DSQRT(X)-DSQRT(Y))**2                                            
        QM2=Z-(DSQRT(X)+DSQRT(Y))**2                                            
       IF(QM1) 5000,5000,7                                                      
7      IF(QM2) 70,5000,5000                                                     
70      CC=(4D0*X*Z-(X-Y+Z)**2)/4D0/Z/Z                                         
        UU=-(X-Y-Z)/2D0/Z                                                       
        DD=-(X-Y+Z)/2D0/Z                                                       
      E2=DLOG(Z)/3D0                                                            
     #  +(UU**3*DLOG(UU*UU+CC)-2D0/3D0*UU**3+2D0*CC*UU                          
     #  -2D0*CC*DSQRT(CC)*DATAN(UU/DSQRT(CC)))/3D0                              
     #  -(DD**3*DLOG(DD*DD+CC)-2D0/3D0*DD**3+2D0*CC*DD                          
     #  -2D0*CC*DSQRT(CC)*DATAN(DD/DSQRT(CC)))/3D0                              
     #  -2D0*DD                                                                 
     #      *(((UU*UU+CC)*DLOG(UU*UU+CC)-UU*UU)/2D0                             
     #       -((DD*DD+CC)*DLOG(DD*DD+CC)-DD*DD)/2D0)                            
     #  +DD*DD                                                                  
     #      *(UU*(DLOG(UU**2+CC)-2D0)+2D0*DSQRT(CC)*DATAN(UU/DSQRT(CC))         
     #       -DD*(DLOG(DD**2+CC)-2D0)-2D0*DSQRT(CC)*DATAN(DD/DSQRT(CC)))        
       RETURN                                                                   
5000   IF(Z-X-Y) 7000,6000,6000                                                 
6000  E2=(6D0*Z**3*DLOG(Y)-3D0*(Z+X-Y)*((Z+X-Y)**2-3D0*X*Z)*DLOG(Y/X)           
     #  -4D0*Z**3+12D0*X*Z**2-3D0*Z*(Z+X-Y)*(3D0*Z+2D0*(X-Y))                   
     #  +3D0*((Z+X-Y)**2-X*Z)*DSQRT((Z+X-Y)**2-4D0*X*Z)                         
     #  *DLOG((Z-X-Y+DSQRT((Z+X-Y)**2-4D0*X*Z))**2/4D0/X/Y))/(18D0*Z**3)        
       RETURN                                                                   
7000  E2=(6D0*Z**3*DLOG(Y)-3D0*(Z+X-Y)*((Z+X-Y)**2-3D0*X*Z)*DLOG(Y/X)           
     #  -4D0*Z**3+12D0*X*Z**2-3D0*Z*(Z+X-Y)*(3D0*Z+2D0*(X-Y))                   
     #  -3D0*((Z+X-Y)**2-X*Z)*DSQRT((Z+X-Y)**2-4D0*X*Z)                         
     #  *DLOG((Z-X-Y-DSQRT((Z+X-Y)**2-4D0*X*Z))**2/4D0/X/Y))/(18D0*Z**3)        
       RETURN                                                                   
      END                                                                       
C                                                                               
C                                                                               
C ** E **                                                                       
C                                                                               
      DOUBLE PRECISION FUNCTION E(X,Y,Z)                                        
      IMPLICIT REAL*8(A-H,O-Z)                                                  
      E=E1(X,Y,Z)-E2(X,Y,Z)                                                     
       RETURN                                                                   
      END                                                                       


