CINCLUDE HIOKI
      IMPLICIT REAL*8 (A-H,O-Z)
C--
      REAL   *8  WMASS(5)
C
C========< Entry Point >================================================
C
C--
C  Initialize particle masses.
C--
      CALL INIMAS
      AMZ    =  91.19D0
      AMT    = 170.D0
C--
C  Measurement errors.
C--
      DAMW   =  SQRT( (12.D-3)**2 + (17.D-3)**2 )
C--
C  Prepare topdaw data.
C--
      WRITE(20,'(''NEW FRAME'')')
      WRITE(20,'(''SET FONT DUPLEX'')')
      WRITE(20,'(''(''  )')
      WRITE(20,'(''SET WINDOW X 3 12 Y 2 9'')')
      WRITE(20,'(''SET LIMITS X 150 1000 Y 0 1200'')')
      WRITE(20,'(''SET LABELS SIZE 3'')')
      WRITE(20,'(''(''  )')
      WRITE(20,'(''TITLE 6.5 1 SIZE 4 ''''M0H1 (GeV)'')')
      WRITE(20,'(''CASE               '''' X X      '')')
      WRITE(20,'(''TITLE 1.2 4.2 ANGLE 90 SIZE 4 ''''1-S Bounds'')')
      WRITE(20,'(''CASE                          ''''  G       '')')
      WRITE(20,'(''(''  )')
      WRITE(20,'(''SET ORDER X Y DUMMY DUMMY'')')
C--
C  Loop over M_W.
C--
      AMHMN   = 150
      AMHMX   = 1000
      NMH     = 50
      DMH     = (AMHMX-AMHMN)/NMH
      MODE    = 0
      DO 1000 IMH = 0, NMH
         AMH  = AMHMN + IMH*DMH
C--
C  Calculate center value of M_W.
C--
         CALL ZHWMAS( DR, WMASS, AMZ, AMT, AMH )
         AMW  = WMASS(4)
C--
C  Calculate lower bound to M_H.
C--
         AMWH = AMW + DAMW
         CALL GETAMH( MODE, AMZ, AMT, AMWH, AMHL )
         MODE = 1
C--
C  Calculate higher bound to M_H.
C--
         AMWL = AMW - DAMW
         CALL GETAMH( MODE, AMZ, AMT, AMWL, AMHH )
         WRITE(20,'(4E12.5)') AMH, AMHL, AMHH, AMW
1000  CONTINUE
      WRITE(20,'(''JOIN'')')
      PRINT *, '(END)'
C--
C  That's it.
C--
      STOP
      END
 
      SUBROUTINE GETAMH( MODE, AMZ, AMT, AMW, AMH )
 
      IMPLICIT   REAL*8 (A-H,O-Z)
C--
      INTEGER*4  MODE
      REAL   *8  AMZ, AMT, AMW, AMH
C--
      REAL   *8  WMASS(5)
      PARAMETER  ( NDT = 2000 )
      REAL   *8  AMHDAT(0:NDT), AMWDAT(0:NDT)
C--
      SAVE       AMHDAT, AMWDAT
C
C========< Entry Point >================================================
C
C--
C  Initialization.
C--
      IF ( MODE.EQ.0 ) THEN
         DTMN  = LOG(  50.D0)
         DTMX  = LOG(1500.D0)
         DDT   = (DTMX-DTMN)/NDT
         DO 10 IDT = 0, NDT
            DT = DTMX - IDT*DDT
            CALL ZHWMAS( DR, WMASS, AMZ, AMT, EXP(DT) )
            AMWDAT(IDT) = WMASS(4)
            AMHDAT(IDT) = DT
10       CONTINUE
      ENDIF
C--
C  Get M_H corresponds to M_W.
C--
      AM = AMW
      AM = MIN(AM,AMWDAT(NDT))
      AM = MAX(AM,AMWDAT(  0))
      DO 20 IDT = 1, NDT
         IF ( AM.LE.AMWDAT(IDT) ) THEN
            DT  = AMHDAT(IDT-1) + DDT/(AMWDAT(IDT)-AMWDAT(IDT-1))
     .                             *(AM-AMWDAT(IDT-1))
            AMH = EXP(DT)
                                                 GO TO 30
         ENDIF
20    CONTINUE
C--
C  That's it.
C--
30    RETURN
      END
