      IMPLICIT REAL*4 ( A-H, O-Z )
C
C========< Entry Point >================================================
C
C--
C  Define parameters.
C--
      P   = 0.9
      AMZ = 91.17
      AMW = 80.0
      DMZ = 0.006
      S2W = 0.23
C--
      C2W = 1 - S2W
      T2W = S2W/C2W
      X   = -1 + 4*S2W
      C   = ABS( X*(1+X*X)/(1-X)/(1+X)**2 )
      A   = P* 2*X / ( 1 + X*X )
      DZ2 = (DMZ/AMZ)**2
      PRINT *, ' P = ', P, ' APOL = ', A
C--
C  Set loop control variables.
C--
      DPMN = 0.01
      DPMX = 0.05
      NDP  = 4
      DDP  = (DPMX-DPMN)/NDP
C--
      ENMN = LOG(3.0E3)
      ENMX = LOG(3.0E6)
      NEN  = 50
      DEN  = (ENMX-ENMN)/NEN
C--
C  Prepare topdraw data.
C--
      WRITE(20,'(''NEW FRAME      '')')
      WRITE(20,'(''SET FONT DUPLEX'')')
      WRITE(20,'(''(              '')')
      WRITE(20,'(''SET WINDOW X 3.5 10.5 Y 2.2 9.6'')')
      WRITE(20,'(''SET LIMIT X '',2E15.5)') EXP(ENMN), EXP(ENMX)
      WRITE(20,'(''SET LIMIT Y 0 1.1E-2'')')
      WRITE(20,'(''SET AXIS RIGHT OFF  '')')
      WRITE(20,'(''SET SCALE X LOG  '')')
      WRITE(20,'(''SET LABELS SIZE 3'')')
      WRITE(20,'(''(                '')')
      WRITE(20,'(''TITLE 5.0 1. SIZE 4 ''''# detected Z203''''''''s'')')
      WRITE(20,'(''CASE ''''            X X'')')
      WRITE(20,'(''TITLE 1.0 4. SIZE 4 ANGLE 90 '',
     .           ''''''Dsin223Q0W1/sin223Q0W1'')')
      WRITE(20,'(''CASE ''''F   X XGX X    X XGX X'')')
      WRITE(20,'(''(                '')')
      WRITE(20,'(''TITLE 2.1E5 1.00E-2 DATA SIZE 2.5'',
     .                ''''''DM0Z1 = '',1I1,'' MeV'')') IFIX(1001*DMZ)
      WRITE(20,'(''CASE ''''F X X        '')')
      WRITE(20,'(''TITLE 2.1E5 0.92E-2 DATA SIZE 2.5'',
     .                ''''''P0e1  = '',1I2,'' %'')') IFIX(101*P)
      WRITE(20,'(''CASE '''' X X        '')')
      WRITE(20,'(''(                '')')
      WRITE(20,'(''TITLE 5.4E5 0.56E-2 DATA SIZE 2.5'',
     .                ''''''DP0e1/P0e1(%)'')')
      WRITE(20,'(''CASE ''''F X X  X X   '')')
      WRITE(20,'(''(                '')')
      WRITE(20,'(''SET ORDER DUMMY X Y DUMMY'')')
C--
C  Loop over P_e error and # Z's.
C     DP  = sigma_P_e/P_e
C     ENZ = #Z's
C--
      DO 100 IDP = 0, NDP
         DP = DPMN + IDP*DDP
         WRITE(20,'(''(            '')')
         WRITE(20,'(''( DP = '',1F5.2)') DP
         DO 10 IEN = 0, NEN
            EN   = ENMN + IEN*DEN
            ENZ  = EXP(EN)
            EM   = ENZ
            DA2  = (1/A-1)*(1/A+1)/EM
            DS2  = C*SQRT( DA2 + DP*DP )
            DS2W = DS2*S2W
            DMW  = SQRT( T2W*T2W*DS2**2/4 + DZ2 )*AMW
            WRITE(20,'(4E12.4)') DP, ENZ, DS2, DMW
10       CONTINUE
         WRITE(20,'(''JOIN'')')
         WRITE(20,'(''TITLE'',2E12.2,'' DATA SIZE 2.5 '''''',1I1)')
     .             ENZ/2, DS2+3.5E-4, IFIX(DP*101)
100   CONTINUE
C--
C  Right axis.
C--
      WRITE(20,'(''(              '')')
      WRITE(20,'(''SET WINDOW X 3.5 10.5 Y 2.2 9.6'')')
      WRITE(20,'(''SET LIMIT X '',2E15.5)') EXP(ENMN), EXP(ENMX)
      WRITE(20,'(''SET LIMIT Y 0 13.2E-2'')')
      WRITE(20,'(''SET AXIS ALL OFF    '')')
      WRITE(20,'(''SET LABELS ALL OFF  '')')
      WRITE(20,'(''SET AXIS RIGHT ON   '')')
      WRITE(20,'(''SET LABELS RIGHT ON '')')
      WRITE(20,'(''(              '')')
      WRITE(20,'(''TITLE 12.5 7. SIZE 4 ANGLE -90 ''''DM0W1 (GeV)'')')
      WRITE(20,'(''CASE                           ''''F X X'')')
      WRITE(20,'(''(              '')')
      WRITE(20,'(''SET ORDER X Y; 1.E-5 1.E-5; PLOT'')')
C--
C  That's it.
C--
      STOP
      END
