 
      IMPLICIT REAL*8  ( A-H, O-Z )
      PARAMETER   ( NPT = 2000 )
      REAL*8      RSDATA(0:NPT), RDATA(4,0:NPT,3,0:1,0:1),
     .            SGDATA(0:NPT,10)
      REAL*8      AMF(3,0:1,0:1)
C--
      DATA AMF /  1.D-10      ,   1.D-10    ,   1.D-10,
     .            0.5110034D-3, 105.65946D-3,   1.732D0,
     .            0.04D0      ,   1.5D0     , 175.D0   ,
     .            0.04D0      ,   0.1D0     ,   4.7D0  /
      DATA LOUNIT / 20 /
C
C========< Entry Point >================================================
C
C--
C  Set constants.
C--
      xGV2PB = 3.8937966E8
      PI     = ACOS(-1.D0)
      ALF    = 1/128.D0
      SG0    = (4*PI/3)*ALF**2*xGV2PB
C--
      AMW   = 80.D0
      AMZ   = 91.17D0
      SIN2W = 1 - (AMW/AMZ)**2
      GAMZ  = 2.5D0
      ALFS  = 0.D0
C--
C  Set sqrt(s) data.
C--
      NRS0  = 20
      IOFF  = 0
      RSMN  = 10
      RSMX  = 80
      DRS   = (RSMX-RSMN)/NRS0
      DO 10 IRS = 0, NRS0
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
10    CONTINUE
C-- Z peak
      NRS1  = 240
      IOFF  = NRS0
      RSMN  = RSMX
      RSMX  = 110
      DRS   = (RSMX-RSMN)/NRS1
      DO 11 IRS = 0, NRS1
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
11    CONTINUE
C-- Z to WW
      NRS2  = 10
      IOFF  = IOFF + NRS1
      RSMN  = RSMX
      RSMX  = 2*AMW
      DRS   = (RSMX-RSMN)/NRS2
      DO 12 IRS = 1, NRS2
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
12    CONTINUE
C-- WW threshold to ZZ threshold
      NRS3  = 20
      IOFF  = IOFF + NRS2
      RSMN  = RSMX + 1.D-2
      RSMX  = 2*AMZ
      DRS   = (RSMX-RSMN)/NRS3
      DO 13 IRS = 0, NRS3
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
13    CONTINUE
C-- ZZ threshold
      NRS4  = 20
      IOFF  = IOFF + NRS3
      RSMN  = RSMX + 1.D-2
      RSMX  = RSMN + 20
      DRS   = (RSMX-RSMN)/NRS4
      DO 14 IRS = 0, NRS4
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
14    CONTINUE
C-- ZZ to tt
      NRS5  = 5
      IOFF  = IOFF + NRS4
      RSMN  = RSMX
      RSMX  = 2*AMF(3,0,1)
      DRS   = (RSMX-RSMN)/NRS5
      DO 15 IRS = 1, NRS5
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
15    CONTINUE
C-- tt threshold
      NRS6  = 20
      IOFF  = IOFF + NRS5
      RSMN  = RSMX + 1.D-2
      RSMX  = RSMN + 20
      DRS   = (RSMX-RSMN)/NRS6
      DO 16 IRS = 0, NRS6
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
16    CONTINUE
C-- tt threshold
      NRS7  = 20
      IOFF  = IOFF + NRS6
      RSMN  = RSMX
      RSMX  = RSMX + 100
      DRS   = (RSMX-RSMN)/NRS7
      DO 17 IRS = 0, NRS6
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
17    CONTINUE
C-- tt and above
      NRS8  = 10
      IOFF  = IOFF + NRS7
      RSMN  = RSMX
      RSMX  = 1000
      DRS   = (RSMX-RSMN)/NRS8
      DO 18 IRS = 1, NRS8
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
18    CONTINUE
      NRS   = IOFF + NRS8
C--
C  Calculate cross sections for ff.
C--
      DO 2000 LQ = 0, 1
         DO 200 IT = 0, 1
            T3 = 0.5D0 - IT
            DO 20 IG = 1, 3
               DO 2 IRS = 0, NRS
                  RS = RSDATA(IRS)
                  AM = AMF(IG,IT,LQ)
                  CALL RFFAFF(ALFS,SIN2W,AMZ,GAMZ,RS,LQ,T3,AM,
     .                        RDATA(1,IRS,IG,IT,LQ),AFF)
2              CONTINUE
20          CONTINUE
200      CONTINUE
2000  CONTINUE
C--
C  Calculate cross sections for WW and ZZ.
C--
      YMN = -0.8
      YMX = -YMN
      DO 30 IRS = 0, NRS
         RS = RSDATA(IRS)
         RMM  =   RDATA(1,IRS,2,1,0)
         RQQ  =   RDATA(1,IRS,1,0,1) + RDATA(1,IRS,1,1,1)
     .          + RDATA(1,IRS,2,0,1) + RDATA(1,IRS,2,1,1)
     .                               + RDATA(1,IRS,3,1,1)
         RTT  =   RDATA(1,IRS,3,0,1)
         SGMM =   RMM*SG0/RS/RS
         SGQQ =   RQQ*SG0/RS/RS
         SGTT =   RTT*SG0/RS/RS
         CALL SGTWW(RS,YMN,YMX,SGWW)
         CALL SGTZZ(RS,YMN,YMX,SGZZ)
C--
         SGDATA(IRS,1) = MAX(1.D-20,SGMM  )
         SGDATA(IRS,2) = MAX(1.D-20,SGQQ  )
         SGDATA(IRS,3) = MAX(1.D-20,SGTT  )
         SGDATA(IRS,4) = MAX(1.D-20,SGWW  )
         SGDATA(IRS,5) = MAX(1.D-20,SGZZ/2)
30    CONTINUE
C--
C  Prepare topdraw data.
C--
      DO 400 IRS = 0, NRS
         RS   =   RSDATA(IRS)
         WRITE(LOUNIT,'(6E13.5)') RS, (SGDATA(IRS,I),I=1,5)
400   CONTINUE
C--
C  That's it.
C--
      STOP
      END
 
C*
C*  Rff for e+e- --> ff.
C*    RS = sqrt(S)
C*
 
      SUBROUTINE RFFAFF(ALFS,SIN2W,AMZ,GAMZ,ROOTS,LQ,T3,AMF,RFF,AFF)
 
      IMPLICIT   REAL*8  ( A-H, O-Z )
      REAL   *8  ALFS, SIN2W, AMZ, GAMZ, ROOTS, T3, AMF, RFF(4), AFF
      INTEGER*4  LQ
      COMPLEX*16 ZCHI
      DATA   NF  / 5 /
C
C========< Entry Point >================================================
C
C--
C  Check if threshold is crossed or not.
C--
      IF ( ROOTS.LE.2*AMF ) THEN
         RFF(1) = 0
         RFF(2) = 0
         RFF(3) = 0
         RFF(4) = 0
         RETURN
      ENDIF
C--
C  Calculate numerical constants.
C--
      xPI  = ACOS(-1.D0)
      xHPI = xPI/2
C--
C  Calculate Q.
C--
      QF = T3 + (4.D0*LQ-3)/6
C--
C  Calculate A/V couplings.
C--
      AF = 2*T3
      VF = 2*(T3-2*QF*SIN2W)
      AE = -1.
      VE = 2*(-0.5D0+2*SIN2W)
C--
C  Chi for Z0.
C--
      CALL CHIZ0(SIN2W,AMZ,GAMZ,ROOTS,ZCHI)
      CHI1 = REAL(ZCHI)
      CHI2 = ABS(ZCHI)*ABS(ZCHI)
      CHI3 = IMAG(ZCHI)
C--
C  Calculate CVV, CAA, and CAV.
C--
      CVV  = QF*QF - 2*VE*VF*QF*CHI1 + (VE*VE+AE*AE)*VF*VF*CHI2
      CAA  = (VE*VE+AE*AE)*AF*AF*CHI2
      CAV  = -4*QF*AE*AF*CHI1 + 8*VE*VF*AE*AF*CHI2
      BTF  = SQRT((1-2*AMF/ROOTS)*(1+2*AMF/ROOTS))
C--
C  Calculate Rll and All.
C--
      IF ( LQ.EQ.0 ) THEN
         RFF(1) = (BTF/2)*(3-BTF*BTF)*CVV + BTF**3*CAA
         RFF(2) = (BTF/2)*(3-BTF*BTF)*QF*QF
         RFF(3) = RFF(1) - RFF(2)
         RFF(4) = 0
         AFF    = (3.D0/8)*BTF**2*CAV/RFF(1)
C--
C  Calculate Rqq and Aqq.
C--
      ELSE
         A   = ALFS/xPI
         CV1 = (4*xPI/3)*(xHPI/BTF-((3+BTF)/4)*(xHPI-3/(4*xPI)))
         CA1 = (4*xPI/3)
     .        *(xHPI/BTF-(1.9-22*BTF/5+7*BTF**2/2)*(xHPI-3/(4*xPI)))
         CV2 = 1.986D0 - 0.115D0*NF
         CA2 = CV2
         CV3 = 70.985D0 - 1.2D0*NF - 0.005D0*NF*NF
         CA3 = CV3
 
         RFF(1) = 3*((BTF/2)*(3-BTF**2)*(1+CV1*A+CV2*A**2+CV3*A**3)*CVV
     .                +BTF**3*(1+CA1*A+CA2*A**2+CA3*A**3)*CAA)
     .            - 1.679*QF**2*A**3
         RFF(2) = 3*(BTF/2)*(3-BTF*BTF)*QF*QF
         RFF(4) = 3*(BTF/2)*(3-BTF**2)*(1+CV1*A+CV2*A**2+CV3*A**3)
     .             *QF**2 - 1.679*QF**2*A**3 - RFF(2)
         RFF(3) = RFF(1) - RFF(2) - RFF(4)
         AFF    = (3.D0/8)*3*BTF**2*CAV/RFF(1)
      ENDIF
C--
C  That's it.
C--
      RETURN
      END
 
      SUBROUTINE CHIZ0(SIN2W,AMZ,GAMZ,ROOTS,ZCHI)
 
      IMPLICIT   REAL*8  ( A-H, O-Y ), COMPLEX*16 ( Z )
      REAL*8     SIN2W, AMZ, GAMZ, ROOTS
      COMPLEX*16 ZCHI
      DATA ZI    / (0.D0,1.D0) /
C
C========< Entry Point >================================================
C
C--
C  Calculate Z0 propagator.
C--
      S     = ROOTS*ROOTS
      COS2W = 1 - SIN2W
      ZCHI  = (S/(S-AMZ*AMZ+ZI*AMZ*GAMZ))/(16*SIN2W*COS2W)
C--
C  That's it.
C--
      RETURN
      END
 
C*
C*  Integrated cross section for e+e- --> WW.
C*    RS = sqrt(S)
C*
      SUBROUTINE SGTWW(RS,YMN,YMX,SGT)
      IMPLICIT REAL*8  ( A-H, O-Z )
C
C========< Entry Point >================================================
C
C--
C  Preparation for Simpson's algorithm.
C--
      NY   = 1000
      DY   = (YMX-YMN)/NY
C--
C  Integration over y.
C--
      CALL SGWWNP(RS,YMN,SG0)
      CALL SGWWNP(RS,YMX,SGN)
      SGT = SG0 + SGN
C--
      ALT = -1
      DO 10 IY = 1, NY-1
         Y  = YMN + IY*DY
         WT = 3 - ALT
         CALL SGWWNP(RS,Y,SG)
         SGT = SGT + WT*SG
         ALT = -ALT
10    CONTINUE
      SGT = SGT*DY/3
C     PRINT *, ' RS = ', RS, '(GeV)  SGT = ', SGT, '(pb)'
C--
C  That's it.
C--
      RETURN
      END
 
      SUBROUTINE SGWWNP(RS,Y,SG)
 
      IMPLICIT   REAL*8  ( A-H, O-Z )
      PARAMETER  ( IxPRC = 2 )
      REAL   *8  RS, Y, SG
      DATA NCALL /0/
C
C========< Entry Point >================================================
C
C--
C  Constants.
C--
      IF ( NCALL.EQ.0 ) THEN
         NCALL  = 1
         xPI    = ACOS(-1.D0)
         x2PI   = 2*xPI
         x4PI   = 4*xPI
         xGV2PB = 3.893796623D8
C        xALF   = 1.D0/137.035989561D0
         xALF   = 1.D0/128.D0
C--
         AMZ    = 91.17D0
         GMZ    =  2.5D0
C        GMZ    =  .0D0
         AMW    = 80.0D0
         GMW    =  2.0D0
         AMZ2   = AMZ*AMZ
         AMW2   = AMW*AMW
         AMZ4   = AMZ2*AMZ2
C--
C        xSIN2W = 0.228842366686D0
         xSIN2W = 1 - AMW2/AMZ2
         xCOS2W = 1 - xSIN2W
         xSINW  = SQRT(xSIN2W)
         xCOSW  = SQRT(xCOS2W)
         xCOTW  = xCOSW/xSINW
C--
         C0     = SQRT(x4PI*xALF)
         CV     = C0/(xSINW*xCOSW)*(-0.25D0+xSIN2W)
         CA     = C0/(xSINW*xCOSW)*( 0.25D0 )
         CWWZ   = C0*xCOTW
         CW     = C0/xSINW/2/SQRT(2.D0)
         FAC    =  xGV2PB/(64*xPI**2)
      ENDIF
C--
C  Set independent variables.
C--
      EBM  = RS/2
      BT   = (EBM-AMW)*(EBM+AMW)
      IF ( BT.LE.0.D0 ) THEN
         SG = 0
         RETURN
      ELSE
         BT   = SQRT(BT)/EBM
      ENDIF
      S    = RS*RS
      T    = AMW2 - (S/2)*(1-BT*Y)
      P1P2 = S/2
      P1Q1 = (AMW2-T)/2
C--
C  Set independent variables.
C--
      CALL       TTWWNP(AMZ,GMZ,AMW,GMW,
     .                  C0,CV,CA,CWWZ,CW,
     .                  P1P2,P1Q1,TTA)
      SG = FAC*TTA*BT/S
C--   ds/dcos(theta)
      SG = SG*2*xPI
C--
C  That's it.
C--
      RETURN
      END
 
      SUBROUTINE TTWWNP(AMZ,GMZ,AMW,GMW,
     .                  C0,CV,CA,CWWZ,CW,
     .                  P1P2,P1Q1,TTA)
 
      IMPLICIT REAL*8  ( A-H, O-Z )
C--
C  Statement functions.
C--
      RBW(A,B) =  A-B*B
      BW2(A,B) = (A-B*B)**2+B*B*GMZ*GMZ
C--
C  Ddifferential cross section is given by the follwing.
C     d(sigma)/d(omega) = TTA*(e**2/(sin2w*cos2w))**2*BT/(64*xPI**2*S)
C                       = TTA*(xALF**2/(sin2w*cos2w))**2*BT/(4*S)
C  REDUCE output here.
C--
      TTAGG=C0**4*(-3.*AMW**6*P1P2-6.*AMW**4*P1Q1**2+6.*AMW**4*
     .      P1Q1*P1P2-6.*AMW**4*P1P2**2+4.*AMW**2*P1Q1**2*P1P2-4.*AMW
     .      **2*P1Q1*P1P2**2+3.*AMW**2*P1P2**3-2.*P1Q1**2*P1P2**2+2.*
     .      P1Q1*P1P2**3)/(AMW**4*P1P2**2)
      TTATT=8.*CW**4*(-AMW**6*P1P2-10.*AMW**4*P1Q1**2-2.*AMW**4*
     .      P1Q1*P1P2+8.*AMW**2*P1Q1**3+4.*AMW**2*P1Q1**2*P1P2-8.*
     .      P1Q1**4+8.*P1Q1**3*P1P2)/(AMW**8-4.*AMW**6*P1Q1+4.*AMW**4
     .      *P1Q1**2)
      TTAZG=4.*C0**2*CV*CWWZ*(3.*AMW**6*P1P2+6.*AMW**4*P1Q1**2-
     .      6.*AMW**4*P1Q1*P1P2+6.*AMW**4*P1P2**2-4.*AMW**2*P1Q1**2*
     .      P1P2+4.*AMW**2*P1Q1*P1P2**2-3.*AMW**2*P1P2**3+2.*P1Q1**2*
     .      P1P2**2-2.*P1Q1*P1P2**3)/(2.*AMW**4*P1P2**2-AMW**4*P1P2*
     .      AMZ**2)
      TTAGT=4.*C0**2*CW**2*(-3.*AMW**6*P1P2-6.*AMW**4*P1Q1**2-3.
     .      *AMW**4*P1P2**2+4.*AMW**2*P1Q1**3-2.*AMW**2*P1Q1**2*P1P2+
     .      4.*AMW**2*P1Q1*P1P2**2-4.*P1Q1**3*P1P2+4.*P1Q1**2*P1P2**2)
     .      /(AMW**6*P1P2-2.*AMW**4*P1Q1*P1P2)
      TTAZZ=4.*(CV**2+CA**2)*CWWZ**2*(-3.*AMW**6*P1P2-6.*AMW**4*P1Q1**2+
     .      6.*AMW**4*P1Q1*P1P2-6.*AMW**4*P1P2**2+4.*AMW**2*P1Q1**2*
     .      P1P2-4.*AMW**2*P1Q1*P1P2**2+3.*AMW**2*P1P2**3-2.*P1Q1**2*
     .      P1P2**2+2.*P1Q1*P1P2**3)/(4.*AMW**4*P1P2**2-4.*AMW**4*
     .      P1P2*AMZ**2+AMW**4*AMZ**4)
      TTAZT=8.*(CV-CA)*CW**2*CWWZ*(3.*AMW**6*P1P2+6.*AMW**4*P1Q1**2+
     .      3.*AMW**4*P1P2**2-4.*AMW**2*P1Q1**3+2.*AMW**2*P1Q1**2*P1P2
     .      -4.*AMW**2*P1Q1*P1P2**2+4.*P1Q1**3*P1P2-4.*P1Q1**2*P1P2**2)
     .      /(2.*AMW**6*P1P2-AMW**6*AMZ**2-4.*AMW**4*P1Q1*P1P2+2.*
     .      AMW**4*P1Q1*AMZ**2)
      TTA = TTAZZ + TTAGG + TTATT + TTAZG + TTAZT + TTAGT
C--
C  That's it.
C--
      RETURN
      END
 
C*
C*  Integrated cross section for e+e- --> ZZ.
C*    RS = sqrt(S)
C*
      SUBROUTINE SGTZZ(RS,YMN,YMX,SGT)
      IMPLICIT REAL*8  ( A-H, O-Z )
C
C========< Entry Point >================================================
C
C--
C  Preparation for Simpson's algorithm.
C--
      NY   = 1000
      DY   = (YMX-YMN)/NY
C--
C  Integration over y.
C--
      CALL SGZZNP(RS,YMN,SG0)
      CALL SGZZNP(RS,YMX,SGN)
      SGT = SG0 + SGN
C--
      ALT = -1
      DO 10 IY = 1, NY-1
         Y  = YMN + IY*DY
         WT = 3 - ALT
         CALL SGZZNP(RS,Y,SG)
         SGT = SGT + WT*SG
         ALT = -ALT
10    CONTINUE
      SGT = SGT*DY/3
C     PRINT *, ' RS = ', RS, '(GeV)  SGT = ', SGT, '(pb)'
C--
C  That's it.
C--
      RETURN
      END
 
      SUBROUTINE SGZZNP(RS,Y,SG)
 
      IMPLICIT REAL*8 ( A-H, O-Z )
      REAL*4 RS, Y, SG
      DATA NCALL /0/
C
C========< Entry Point >================================================
C
C--
C  Constants.
C--
      IF ( NCALL.EQ.0 ) THEN
         NCALL  = 1
         xPI    = ACOS(-1.D0)
C        xSIN2W = 0.228842366686D0
         xSIN2W = 0.23D0
         xCOS2W = 1 - xSIN2W
C        xALF   = 1.D0/137.035989561D0
         xALF   = 1.D0/128.D0
         xGV2PB = 3.893796623D8
         AMZ    = 91.17D0
         AMZ2   = AMZ*AMZ
         AMZ4   = AMZ2*AMZ2
         GV     = -0.25D0 + xSIN2W
         GA     =  0.25D0
         FAC    =  xGV2PB*(xALF/xSIN2W/xCOS2W)**2/4
      ENDIF
C--
C  Ddifferential cross section is given by the follwing.
C     d(sigma)/d(omega) = TTA*(e**2/(sin2w*cos2w))**2*BT/(64*xPI**2*S)
C                       = TTA*(xALF**2/(sin2w*cos2w))**2*BT/(4*S)
C--
      EBM  = RS/2
      BT   = (EBM-AMZ)*(EBM+AMZ)
      IF ( BT.LE.0.D0 ) THEN
         SG = 0
         RETURN
      ELSE
         BT   = SQRT(BT)/EBM
      ENDIF
      S    = RS*RS
      T    = AMZ2 - (S/2)*(1-BT*Y)
      U    = 2*AMZ2 - (S+T)
      TT   = T*T
      TU   = T*U
      UU   = U*U
      ANUM = TU - AMZ4
      TTA = 2*( (GV**2+GA**2)**2 + 4*(GV*GA)**2 )
     .       *( ANUM/TT + ANUM/UU + 4*AMZ2*S/TU )
      SG  = FAC*TTA*BT/S
C--   ds/dcos(theta)
      SG  = SG*2*xPI
C--
C  That's it.
C--
      RETURN
      END
