 
C*
C*  Rff for e+e- --> ff.
C*    RS = sqrt(S)
C*
 
      SUBROUTINE RFFAFF(ALFS,SIN2W,AMZ,GAMZ,ROOTS,LQ,T3,AMF,RFF,AFF)
 
      IMPLICIT   REAL*8  ( A-H, O-Z )
      REAL   *8  ALFS, SIN2W, AMZ, GAMZ, ROOTS, T3, AMF, RFF(4), AFF
      INTEGER*4  LQ
      COMPLEX*16 ZCHI
      DATA   NF  / 5 /
C
C========< Entry Point >================================================
C
C--
C  Check if threshold is crossed or not.
C--
      IF ( ROOTS.LE.2*AMF ) THEN
         RFF(1) = 0
         RFF(2) = 0
         RFF(3) = 0
         RFF(4) = 0
         RETURN
      ENDIF
C--
C  Calculate numerical constants.
C--
      xPI  = ACOS(-1.D0)
      xHPI = xPI/2
C--
C  Calculate Q.
C--
      QF = T3 + (4.D0*LQ-3)/6
C--
C  Calculate A/V couplings.
C--
      AF = 2*T3
      VF = 2*(T3-2*QF*SIN2W)
      AE = -1.
      VE = 2*(-0.5D0+2*SIN2W)
C--
C  Chi for Z0.
C--
      CALL CHIZ0(SIN2W,AMZ,GAMZ,ROOTS,ZCHI)
      CHI1 = REAL(ZCHI)
      CHI2 = ABS(ZCHI)*ABS(ZCHI)
      CHI3 = IMAG(ZCHI)
C--
C  Calculate CVV, CAA, and CAV.
C--
      CVV  = QF*QF - 2*VE*VF*QF*CHI1 + (VE*VE+AE*AE)*VF*VF*CHI2
      CAA  = (VE*VE+AE*AE)*AF*AF*CHI2
      CAV  = -4*QF*AE*AF*CHI1 + 8*VE*VF*AE*AF*CHI2
      BTF  = SQRT((1-2*AMF/ROOTS)*(1+2*AMF/ROOTS))
C--
C  Calculate Rll and All.
C--
      IF ( LQ.EQ.0 ) THEN
         RFF(1) = (BTF/2)*(3-BTF*BTF)*CVV + BTF**3*CAA
         RFF(2) = (BTF/2)*(3-BTF*BTF)*QF*QF
         RFF(3) = RFF(1) - RFF(2)
         RFF(4) = 0
         AFF    = (3.D0/8)*BTF**2*CAV/RFF(1)
C--
C  Calculate Rqq and Aqq.
C--
      ELSE
         A   = ALFS/xPI
         CV1 = (4*xPI/3)*(xHPI/BTF-((3+BTF)/4)*(xHPI-3/(4*xPI)))
         CA1 = (4*xPI/3)
     .        *(xHPI/BTF-(1.9-22*BTF/5+7*BTF**2/2)*(xHPI-3/(4*xPI)))
         CV2 = 1.986D0 - 0.115D0*NF
         CA2 = CV2
         CV3 = 70.985D0 - 1.2D0*NF - 0.005D0*NF*NF
         CA3 = CV3
 
         RFF(1) = 3*((BTF/2)*(3-BTF**2)*(1+CV1*A+CV2*A**2+CV3*A**3)*CVV
     .                +BTF**3*(1+CA1*A+CA2*A**2+CA3*A**3)*CAA)
     .            - 1.679*QF**2*A**3
         RFF(2) = 3*(BTF/2)*(3-BTF*BTF)*QF*QF
         RFF(4) = 3*(BTF/2)*(3-BTF**2)*(1+CV1*A+CV2*A**2+CV3*A**3)
     .             *QF**2 - 1.679*QF**2*A**3 - RFF(2)
         RFF(3) = RFF(1) - RFF(2) - RFF(4)
         AFF    = (3.D0/8)*3*BTF**2*CAV/RFF(1)
      ENDIF
C--
C  That's it.
C--
      RETURN
      END
