 
C*
C*  Integrated cross section for e+e- --> ZZ.
C*    RS = sqrt(S)
C*
      SUBROUTINE SGTZZ(RS,YMN,YMX,SGT)
      IMPLICIT REAL*8  ( A-H, O-Z )
C
C========< Entry Point >================================================
C
C--
C  Preparation for Simpson's algorithm.
C--
      NY   = 1000
      DY   = (YMX-YMN)/NY
C--
C  Integration over y.
C--
      CALL SGZZNP(RS,YMN,SG0)
      CALL SGZZNP(RS,YMX,SGN)
      SGT = SG0 + SGN
C--
      ALT = -1
      DO 10 IY = 1, NY-1
         Y  = YMN + IY*DY
         WT = 3 - ALT
         CALL SGZZNP(RS,Y,SG)
         SGT = SGT + WT*SG
         ALT = -ALT
10    CONTINUE
      SGT = SGT*DY/3
C      PRINT *, ' RS = ', RS, '(GeV)  SGT = ', SGT, '(pb)'
C--
C  That's it.
C--
      RETURN
      END
