 
      SUBROUTINE SGWWNP(RS,Y,SG)
 
      IMPLICIT   REAL*8  ( A-H, O-Z )
      PARAMETER  ( IxPRC = 2 )
      REAL   *8  RS, Y, SG
      DATA NCALL /0/
C
C========< Entry Point >================================================
C
C--
C  Constants.
C--
      IF ( NCALL.EQ.0 ) THEN
         NCALL  = 1
         xPI    = ACOS(-1.D0)
         x2PI   = 2*xPI
         x4PI   = 4*xPI
         xGV2PB = 3.893796623D8
C        xALF   = 1.D0/137.035989561D0
         xALF   = 1.D0/128.D0
C--
         AMZ    = 91.17D0
         GMZ    =  2.5D0
C        GMZ    =  .0D0
         AMW    = 80.0D0
         GMW    =  2.0D0
         AMZ2   = AMZ*AMZ
         AMW2   = AMW*AMW
         AMZ4   = AMZ2*AMZ2
C--
C        xSIN2W = 0.228842366686D0
         xSIN2W = 1 - AMW2/AMZ2
         xCOS2W = 1 - xSIN2W
         xSINW  = SQRT(xSIN2W)
         xCOSW  = SQRT(xCOS2W)
         xCOTW  = xCOSW/xSINW
C--
         C0     = SQRT(x4PI*xALF)
         CV     = C0/(xSINW*xCOSW)*(-0.25D0+xSIN2W)
         CA     = C0/(xSINW*xCOSW)*( 0.25D0 )
         CWWZ   = C0*xCOTW
         CW     = C0/xSINW/2/SQRT(2.D0)
         FAC    =  xGV2PB/(64*xPI**2)
      ENDIF
C--
C  Set independent variables.
C--
      EBM  = RS/2
      BT   = (EBM-AMW)*(EBM+AMW)
      IF ( BT.LE.0.D0 ) THEN
         SG = 0
         RETURN
      ELSE
         BT   = SQRT(BT)/EBM
      ENDIF
      S    = RS*RS
      T    = AMW2 - (S/2)*(1-BT*Y)
      P1P2 = S/2
      P1Q1 = (AMW2-T)/2
C--
C  Set independent variables.
C--
      CALL       TTWWNP(AMZ,GMZ,AMW,GMW,
     .                  C0,CV,CA,CWWZ,CW,
     .                  P1P2,P1Q1,TTA)
      SG = FAC*TTA*BT/S
C--   ds/dcos(theta)
      SG = SG*2*xPI
C--
C  That's it.
C--
      RETURN
      END
