 
      SUBROUTINE SGZZNP(RS,Y,SG)
 
      IMPLICIT REAL*8 ( A-H, O-Z )
      REAL*8 RS, Y, SG
      DATA NCALL /0/
C
C========< Entry Point >================================================
C
C--
C  Constants.
C--
      IF ( NCALL.EQ.0 ) THEN
         NCALL  = 1
         xPI    = ACOS(-1.D0)
C        xSIN2W = 0.228842366686D0
         xSIN2W = 0.23D0
         xCOS2W = 1 - xSIN2W
C        xALF   = 1.D0/137.035989561D0
         xALF   = 1.D0/128.D0
         xGV2PB = 3.893796623D8
         AMZ    = 91.17D0
         AMZ2   = AMZ*AMZ
         AMZ4   = AMZ2*AMZ2
         GV     = -0.25D0 + xSIN2W
         GA     =  0.25D0
         FAC    =  xGV2PB*(xALF/xSIN2W/xCOS2W)**2/4
      ENDIF
C--
C  Ddifferential cross section is given by the follwing.
C     d(sigma)/d(omega) = TTA*(e**2/(sin2w*cos2w))**2*BT/(64*xPI**2*S)
C                       = TTA*(xALF**2/(sin2w*cos2w))**2*BT/(4*S)
C--
      EBM  = RS/2
      BT   = (EBM-AMZ)*(EBM+AMZ)
      IF ( BT.LE.0.D0 ) THEN
         SG = 0
         RETURN
      ELSE
         BT   = SQRT(BT)/EBM
      ENDIF
      S    = RS*RS
      T    = AMZ2 - (S/2)*(1-BT*Y)
      U    = 2*AMZ2 - (S+T)
      TT   = T*T
      TU   = T*U
      UU   = U*U
      ANUM = TU - AMZ4
      TTA = 2*( (GV**2+GA**2)**2 + 4*(GV*GA)**2 )
     .       *( ANUM/TT + ANUM/UU + 4*AMZ2*S/TU )
      SG  = FAC*TTA*BT/S
C--   ds/dcos(theta)
      SG  = SG*2*xPI
C--
C  That's it.
C--
      RETURN
      END
