 
      IMPLICIT REAL*8  ( A-H, O-Z )
      PARAMETER   ( NPT = 2000 )
      REAL*8      RSDATA(0:NPT), RDATA(4,0:NPT,3,0:1,0:1),
     .            SGDATA(0:NPT,10)
      REAL*8      AMF(3,0:1,0:1)
C--
      DATA AMF /  1.D-10      ,   1.D-10    ,   1.D-10,
     .            0.5110034D-3, 105.65946D-3,   1.732D0,
     .            0.04D0      ,   1.5D0     , 175.D0   ,
     .            0.04D0      ,   0.1D0     ,   4.7D0  /
      DATA LOUNIT / 20 /
C
C========< Entry Point >================================================
C
C--
C  Set constants.
C--
      xGV2PB = 3.8937966E8
      PI     = ACOS(-1.D0)
      ALF    = 1/128.D0
      SG0    = (4*PI/3)*ALF**2*xGV2PB
C--
      AMW   = 80.D0
      AMZ   = 91.19D0
      SIN2W = 1 - (AMW/AMZ)**2
      GAMZ  = 2.5D0
      ALFS  = 0.D0
C--
C  Set sqrt(s) data.
C--
      NRS0  = 20
      IOFF  = 0
      RSMN  = 10
      RSMX  = 80
      DRS   = (RSMX-RSMN)/NRS0
      DO 10 IRS = 0, NRS0
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
10    CONTINUE
C-- Z peak
      NRS1  = 240
      IOFF  = NRS0
      RSMN  = RSMX
      RSMX  = 110
      DRS   = (RSMX-RSMN)/NRS1
      DO 11 IRS = 0, NRS1
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
11    CONTINUE
C-- Z to WW
      NRS2  = 10
      IOFF  = IOFF + NRS1
      RSMN  = RSMX
      RSMX  = 2*AMW
      DRS   = (RSMX-RSMN)/NRS2
      DO 12 IRS = 1, NRS2
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
12    CONTINUE
C-- WW threshold to ZZ threshold
      NRS3  = 20
      IOFF  = IOFF + NRS2
      RSMN  = RSMX + 1.D-2
      RSMX  = 2*AMZ
      DRS   = (RSMX-RSMN)/NRS3
      DO 13 IRS = 0, NRS3
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
13    CONTINUE
C-- ZZ threshold
      NRS4  = 20
      IOFF  = IOFF + NRS3
      RSMN  = RSMX + 1.D-2
      RSMX  = RSMN + 20
      DRS   = (RSMX-RSMN)/NRS4
      DO 14 IRS = 0, NRS4
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
14    CONTINUE
C-- ZZ to tt
      NRS5  = 5
      IOFF  = IOFF + NRS4
      RSMN  = RSMX
      RSMX  = 2*AMF(3,0,1)
      DRS   = (RSMX-RSMN)/NRS5
      DO 15 IRS = 1, NRS5
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
15    CONTINUE
C-- tt threshold
      NRS6  = 20
      IOFF  = IOFF + NRS5
      RSMN  = RSMX + 1.D-2
      RSMX  = RSMN + 20
      DRS   = (RSMX-RSMN)/NRS6
      DO 16 IRS = 0, NRS6
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
16    CONTINUE
C-- tt threshold
      NRS7  = 20
      IOFF  = IOFF + NRS6
      RSMN  = RSMX
      RSMX  = RSMX + 100
      DRS   = (RSMX-RSMN)/NRS7
      DO 17 IRS = 0, NRS6
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
17    CONTINUE
C-- tt and above
      NRS8  = 10
      IOFF  = IOFF + NRS7
      RSMN  = RSMX
      RSMX  = 1500
      DRS   = (RSMX-RSMN)/NRS8
      DO 18 IRS = 1, NRS8
         RSDATA(IRS+IOFF) = RSMN + IRS*DRS
18    CONTINUE
      NRS   = IOFF + NRS8
C--
C  Calculate cross sections for ff.
C--
      DO 2000 LQ = 0, 1
         DO 200 IT = 0, 1
            T3 = 0.5D0 - IT
            DO 20 IG = 1, 3
               DO 2 IRS = 0, NRS
                  RS = RSDATA(IRS)
                  AM = AMF(IG,IT,LQ)
                  CALL RFFAFF(ALFS,SIN2W,AMZ,GAMZ,RS,LQ,T3,AM,
     .                        RDATA(1,IRS,IG,IT,LQ),AFF)
2              CONTINUE
20          CONTINUE
200      CONTINUE
2000  CONTINUE
C--
C  Calculate cross sections for WW and ZZ.
C--
      YMN = -0.8
      YMX = -YMN
      DO 30 IRS = 0, NRS
         RS = RSDATA(IRS)
         RMM  =   RDATA(1,IRS,2,1,0)
         RQQ  =   RDATA(1,IRS,1,0,1) + RDATA(1,IRS,1,1,1)
     .          + RDATA(1,IRS,2,0,1) + RDATA(1,IRS,2,1,1)
     .                               + RDATA(1,IRS,3,1,1)
         RTT  =   RDATA(1,IRS,3,0,1)
         SGMM =   RMM*SG0/RS/RS
         SGQQ =   RQQ*SG0/RS/RS
         SGTT =   RTT*SG0/RS/RS
         CALL SGTWW(RS,YMN,YMX,SGWW)
         CALL SGTZZ(RS,YMN,YMX,SGZZ)
C--
         SGDATA(IRS,1) = MAX(1.D-20,SGMM  )
         SGDATA(IRS,2) = MAX(1.D-20,SGQQ  )
         SGDATA(IRS,3) = MAX(1.D-20,SGTT  )
         SGDATA(IRS,4) = MAX(1.D-20,SGWW  )
         SGDATA(IRS,5) = MAX(1.D-20,SGZZ/2)
30    CONTINUE
C--
C  Prepare topdraw data.
C--
      DO 400 IRS = 0, NRS
         RS   =   RSDATA(IRS)
         WRITE(LOUNIT,'(6E13.5)') RS, (SGDATA(IRS,I),I=1,5)
400   CONTINUE
C--
C  That's it.
C--
      STOP
      END
