 
 
      SUBROUTINE GTCHI2(MODE,EPIN,SGIN,AMP,AMD,NPOT,A,CHI2)
 
      IMPLICIT   REAL*8 ( A-H, O-Z )
      PARAMETER  ( NA = 3 )
      INTEGER*4  MODE, NPOT
      REAL   *8  EPIN, SGIN, AMP, AMD, A(0:NA), CHI2
C--
      REAL   *8  XYDAT(3,500), EE(0:NA,0:NA), B(0:NA)
      DATA  LIU  /11/
C--
C  Statement function.
C--
      GL(E,SG) = DERFC(-E/SG/SQRT(2.D0))/2
      GH(E,SG) = DERFC( E/SG/SQRT(2.D0))/2
C
C==================< Entry Point >======================================
C
C--
C  Initialization.
C--
      IF ( MODE.EQ.0 ) THEN
         EP  = EPIN
         SG  = SGIN
         FAC = 1
C--
C  Read in data.
C--
         NP  = 0
1        READ(LIU,*,END=2) X, Y, DY
         NP = NP + 1
         XYDAT(1,NP) = X
         XYDAT(2,NP) = Y  *FAC
         XYDAT(3,NP) = DY *FAC
         GO TO 1
C--
2        PRINT *, '>>> GTCHI2 initialization >>>>'
         PRINT *, '  EP = ', EP
         PRINT *, '  # data points = ', NP
         DO 20 IP = 1, NP
            PRINT *, '   ', IP, (XYDAT(K,IP),K=1,3)
20       CONTINUE
         RETURN
      ENDIF
      NPOT = NP
C--
C  Calculate Emin and Emax.
C--
      CALL ELBXT2(EP,AMP,AMD,EMIN,EMAX)
C--
C  Calculate inverse error matrix.
C--
      CALL UVZERO(2*(NA+1)**2,EE)
      CALL UVZERO(2*(NA+1)   , B)
      DO 300 IP = 1, NP
         X   = XYDAT(1,IP)
         Y   = XYDAT(2,IP)
         DY2 = XYDAT(3,IP)**2
         IF ( Y.LE.0. )                          GO TO 300
         G   = GL(X-EMIN,SG)*GH(X-EMAX,SG)
         G2  = G*G
         DO 30 I = 0, NA
            B(I) = B(I) + Y*G*X**I/DY2
            DO 3 J = 0, I
               EE(I,J) = EE(I,J) + G2*X**(I+J)/DY2
               EE(J,I) = EE(I,J)
3           CONTINUE
30       CONTINUE
300   CONTINUE
C--
C  Solve for A.
C--
      CALL UMATIN(NA+1,NA+1,EE,DET,IRET)
      DO 400 I = 0, NA
         A(I) = 0
         DO 40 J = 0, NA
            A(I) = A(I) + EE(I,J)*B(J)
40       CONTINUE
400   CONTINUE
C--
C  Calculate chi**2.
C--
      CHI2 = 0
      DO 500 IP = 1, NP
         X   = XYDAT(1,IP)
         Y   = XYDAT(2,IP)
         DY  = XYDAT(3,IP)
         IF ( Y.LE.0. )                          GO TO 500
         F   = A(NA)
         DO 50 IA = NA-1, 0, -1
            F = F*X + A(IA)
50       CONTINUE
         F    = F*GL(X-EMIN,SG)*GH(X-EMAX,SG)
         CHI2 = CHI2 + ((Y-F)/DY)**2
500   CONTINUE
C--
C  That's it.
C--
      RETURN
      END
