C***********************************************************************
C*
C*====================
C* Subroutine PRUJIN
C*====================
C*
C* (Function)
C*    Job initialization for user analysis.
C* (Input & Output )
C*    none.
C* (Relation)
C*    Called from FLANLI
C* (Update Record)
C*    5/29/87  K.Fujii             Original version.
C*
C***********************************************************************
 
      SUBROUTINE PRUJIN
 
      PARAMETER     ( MXxHPK = 280000 )
      COMMON /PAWC/ M(MXxHPK)
C
C========< Entry Point >================================================
C
C--
C  Write user production version #.
C--
      CALL PRPVRS( 'USER:', 001, 900423)
C--
C  Initialize plot buffer.
C--
      CALL HINIT(MXxHPK)
C--
C  Choose appropriate options.
C--
      CALL DOPT('NCALLS',.TRUE.)
      CALL DOPT('L2ZAUT',.TRUE.)
      CALL DOPT('L2COL',2)
C     CALL DOPT('L2COL',1)
C     CALL DOPT('L2SYM',16)
      CALL DOPT('YZERO',.TRUE.)
      CALL HOPTN('STAT',.TRUE.)
      CALL HOPTN('HOMIT',.TRUE.)
C--
C  Initialize hists and plots.
C--
      CALL HDEF1(  1,'I*4', 20,  0.,1.0     ,  'Cut statistics      @')
      CALL HDEF1(  2,'I*4',200,  0.,1.0     ,  '# combined tracks   @')
      CALL HDEF1(  3,'I*4',150,  0.,1.0     ,  'E_lepton            @')
      CALL HDEF1(  4,'I*4',100,  0.,1.0     ,  '# isolated leptons  @')
      CALL HDEF1(  5,'I*4',150,  0.,1.0     ,  'Pt                  @')
      CALL HDEF1(  6,'I*4',150,  0.,1.0     ,  'm_ll                @')
      CALL HDEF1(  7,'I*4',100, -1.,0.02    ,  'cos(theta_l-)       @')
      CALL HDEF1(  8,'I*4',100, -1.,0.02    ,  'cos(theta_l+)       @')
      CALL HDEF1(  9,'I*4', 90,  0.,2.0     ,  'Acoplanarity        @')
      CALL HDEF1( 21,'I*4',150,  0.,1.0     ,  'm_ll          final @')
      CALL HDEF1( 22,'I*4',100, -1.,0.02    ,  'cos(theta_l-) final @')
      CALL HDEF1( 23,'I*4',100, -1.,0.02    ,  'cos(theta_l+) final @')
      CALL HDEF1( 24,'I*4',150,  0.,1.0     ,  'Pt            final @')
      CALL HDEF1( 25,'I*4', 90,  0.,2.0     ,  'Acoplanarity  final @')
      CALL HDEF1( 26,'I*4',150,  0.,1.0     ,  'E_l-          final @')
      CALL HDEF1( 27,'I*4',150,  0.,1.0     ,  'E_l+          final @')
      CALL HDEF1( 28,'I*4',150,  0.,1.0     ,  'E_lepton      final @')
C--
      CALL HDEF2(201,'I*4',160,100,0.,-100., 2.0,2., '(Evis,Pl)     @')
      CALL HDEF2(221,'I*4',160,100,0.,-100., 2.0,2., '(Evis,Pl)final@')
      CALL HDEF2(222,'I*4', 50, 50,-1., -1.,.04,.04, '(csl1,gn)final@')
      CALL HDEF2(223,'I*4', 50, 50,-1., -1.,.04,.04, '(csl2,gn)final@')
      CALL HDEF2(224,'I*4', 50, 50,-1., -1.,.04,.04, '(csl1,c2)final@')
      CALL HDEF2(225,'I*4', 50, 50,-1., -1.,.04,.04, '(csc,csw)final@')
C--
C  That's it.
C--
      RETURN
      END
