        subroutine beamset(xx,xftau,iflag)
C  this program calulates tau energy distribution from stau, taking care 
C the effect of beamshutrahrung 
C version with approximation
C  final verson of beam distribution , need ap_al
       implicit real*8(a-h,m-z)
       common /masses/ mstau,mchi,mtau
       common /kinstau/ xmax,xmin,vstau
       common /beam/ roots0,del
       common /kinend/ rootsm
       common /x_tau/ xtau
       dimension x(0:200),xf(0:200)
       save x,xf,emax,emin,edel,imax,roots 
       external fstau
       if(iflag.eq.1) goto 1000
       roots=roots0+del
       eps=0.001d0
C  setting cuts for numerical calculation 
       call setphi
       emax=xmax*roots/2.d0
       emin=xmin*roots/2.d0
       etauc=(emax+emin)*dsqrt(1.d0-vstau**2)/2.d0
       ptauc=dsqrt(etauc**2-mtau**2)
C  start to creat energy distribution of tau lepton 
       imax=int((emax-20.d0-emin)/3.d0)
       edel=(emax-25.d0-emin)/imax
       if(edel.le.0) stop
       do 10 i=0,imax+85
          if(i.le.40) then 
             etau=i*0.25d0+emin
          elseif(i.le.imax+40) then 
             etau=(i-40)*edel+emin+10.d0
          elseif(i.le.imax+85) then
             etau=emax-15.d0+(i-imax-40)*1.d0/3.d0
          endif
          xtau=2.d0*etau/roots
          xftau=0.d0
          if(emin.lt.etau.and.etau.lt.emax) then 
               dtau=2.d0*mstau*dsqrt(etau**2*etauc**2-
     &         mtau**2*(etau**2+ptauc**2))
               rootsm=(2.d0*etau*etauc*mstau-dtau)/mtau**2
               rootsm=max(2.d0*mstau,rootsm)
C ysm is the fraction to nominal roots which contribute
C to etau
               ysm=rootsm/roots0
               xsm=0.d0
C get integration region of roots. 
C
C    xsm =\int ^{ysm}_0 beamdistribution 
               call rshdis(xsm,2,ysm)
               call simp2(fstau,xsm,1.d0,xftau,eps,ifail)
C   taking care accoplanality angle
C   This is approximation. 
               call accep(xtau,ifail,xaccep)
C               apal=ap_al(xtau,xmax,xmin)
               apal=1.d0
               xftau=xaccep*xftau*apal
           endif
           x(i)=etau
           xf(i)=xftau
  10  continue
       sum=0.d0
       do 20 i=0,imax+84
       sum=(xf(i+1)+xf(i))/2.d0*(x(i+1)-x(i))/roots*2.d0+sum
   20  continue
       do 30 i=0,imax+85
       xf(i)=xf(i)/sum
   30  continue        
       return
C
 1000  continue
C       do 2 i=0,imax+84
C       etau=(x(i)+x(i+1))/2.d0
       etau=xx*roots/2.d0
       if(etau.lt.emin.or.etau.gt.emax) then 
       xftau=0.d0
       else
          if(etau.le.emin+10.d0) then
            ie=int((etau-emin)*4.d0)
          elseif(etau.le.emax-15.d0) then
            ie=int((etau-emin-10.d0)/edel)+40
          elseif(etau.le.emax) then 
            ie=int((etau-emax+15.d0)*3.d0)+imax+40
          endif
          fp=(xf(ie+1)-xf(ie))/(x(ie+1)-x(ie))
         xftau= xf(ie)+fp*(etau-x(ie))
       endif
       return
       end   
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCc
C  taking care differnce between accoplanality angle cut 
C  and acceptance cut, The numerical value is calcuated 
C  from MC simulation for mstau=150GeV mchi=100 GeV, as a fuction of 
C  E_tau, then rescaled as the function from xmin to xmax
C   function of Etau/E_beam
       real*8 function ap_al(x,xmax,xmin)
       implicit real*8(a-h,m-z)
       dimension f(6)
C       calculate emax,emin for mstau=150GeW and mstau=100GeV
C mass input
       mstau=150.d0
       mchi=100.d0
       mtau=1.78d0
C beam input
       roots0=500.d0
       del=500.d0*0.005d0
C max roots
       roots=roots0+del
C kinematical paramter for tau 
       vstau=dsqrt(1.d0-(2.d0*mstau/roots)**2)
       etauc=(mstau**2+mtau**2-mchi**2)/2.d0/mstau
       ptauc=dsqrt(etauc**2-mtau**2)
       emax0=(etauc+ptauc*vstau)/dsqrt(1.d0-vstau**2)
       emin0=(etauc-ptauc*vstau)/dsqrt(1.d0-vstau**2)
       xmax0 = 2.d0*emax0/roots
       xmin0 =  2.d0*emin0/roots
       if(xmax.ne.xmin.and.xmin.lt.x.and.xmax.gt.x) then
       xnorm=(x-xmin)/(xmax-xmin)*(xmax0-xmin0)+xmin0
       f(1)=1.0853d0
       f(2)=  0.15904d-1
       f(3)= -0.93759d-3
       f(4)= 0.17836e-4
       f(5)=-0.14357d-6
       f(6)=0.41548d-9
       ap_al=0.d0
       xdummy=1.d0
       do 1 i=1,6
       ap_al=f(i)*xdummy+ap_al
       xdummy=xdummy*xnorm*250.d0       
   1   continue
       else
       ap_al=1.d0
       endif
       end
C
      real*8 function  fstau(x)
      implicit real*8(a-h,m-z)
C      common /kinstau/ xmax,xmin,vstau
      common /beam/ roots0,del
      common /masses/ mstau,mchi,mtau
      common /x_tau/ xtau
C     roots0=250.d0
      call RSHDIS(X,1,Y)
      roots=y*roots0
      etau=xtau*(roots0+del)/2.d0
C      write(*,*) accep
C      accep=acol(roots,etau,costheta)  ! neglect boost so that 
C                                      acol approximate acop
       vstau=dsqrt(1.d0-(2.d0*mstau/roots)**2)
       etauc=(mstau**2+mtau**2-mchi**2)/2.d0/mstau
       ptauc=dsqrt(etauc**2-mtau**2)
       emax=(etauc+ptauc*vstau)/dsqrt(1.d0-vstau**2)
       emin=(etauc-ptauc*vstau)/dsqrt(1.d0-vstau**2)
C       xmax=2.d0*emax/roots
C       xmin=2.d0*emin/roots
       ifail=0
       fac=dsqrt(1.d0-vstau**2)*vstau/2.d0
       if(etau.le.emax.and.etau.ge.emin) then
C       xdummy=2.d0*etau/roots
C       if(xdummy.gt.xmax) stop
C          call accep(xdummy,ifail,xaccep)
C              xaccep=1.
C          write(*,*) xaccep,'xaccep'
          fstau= fac/y
          else
C          xaccep=0.d0
          fstau=0.d0
       endif
      end
C
C
C CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  This rouitne calculate acceptance coming from accolinearlity cut
C   kinstau should be given from 
C   the routine calling this 
C  y is Etau/roots
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine accep(y,ifail,xaccep)
      implicit real*8(a-h,m-z)
      external phi
      common /kinstau/ xmax,xmin,vstau
      common /xdummy/ xdum
      common /cut/ pi,tcut1,tcut2,tmin
      ifail=0
      xdum=y
C calculate lab angle from y
       call xtocm(xdum,t1)
       call cmtolab(t1,tlab)
C calculate x1 and x2 from lab angle and tmin
       if(tlab.lt.pi/2.d0) then  
         tx1=abs(tmin-tlab)
         tx2=tmin+tlab
       elseif(tlab.ge.pi/2.d0) then
            if(tlab.ge.pi-tmin) then
            tx2=2.d0*pi-tmin-tlab
            else
            tx2=tlab + tmin
            endif
          tx1=tlab-tmin
       endif
C
       call labtocm(tx1,tx1cm)
       call labtocm(tx2,tx2cm)
       call cmtox(tx1cm,x1)
       call cmtox(tx2cm,x2)
C integrate from x2 and x1
       eps=0.001
       call simp2(phi,x2,x1,xphi,eps,ifail)
C          write(*,*) 'xphi',xphi
       if(tlab.le.pi/2.d0) then 
           if(tlab.le.tmin) then 
              a=(x2-xmin)*pi+xphi
C              write(*,*) 'region of integration is',xmin,x2,x1
           else
              a=(x2-xmin+xmax-x1)*pi+xphi
C              write(*,*) 'region of integraion is',xmin,x2,x1,xmax
           endif
      else
           if(tlab.ge.pi-tmin) then 
             a=(xmax-x1)*pi+xphi 
C             write(*,*) 'region of integration is', x2,x1,xmax
           else
C             write(*,*) 'region of interation is', xmin,x2,x1,xmax
             a=(x2-xmin +xmax-x1)*pi +xphi
           endif
      endif
      xaccep=a/pi/(xmax-xmin)
      return
      end
CXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
C   x---> theta in cm
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       subroutine xtocm(x,tx)
       implicit real*8(a-h,m-z)
       common /kinstau/ xmax,xmin,vstau
       cost1= (2.d0*x-xmax-xmin)/(xmax-xmin)
       if(cost1.gt.1.d0)  cost1 =  1.d0
       if(cost1.lt.-1.d0) cost1 = -1.d0
       tx=acos(cost1)
       end
C*******************************
C  theta in cm -----> x
       subroutine cmtox(tx,x)
       implicit real*8(a-h,m-z)
       common /kinstau/ xmax,xmin,vstau
       cost1=cos(tx)
       x=(cost1*(xmax-xmin)+xmax+xmin)*0.5d0
       end
C*****************************
C  set numerical cuts
C***************************
       subroutine setphi
       implicit real*8(a-h,m-z)
       common /cut/ pi,tcut1,tcut2,tmin
       pi=asin(1.d0)*2.d0
       cosmin=dsqrt(3.d0)/2.d0
       tmin=acos(cosmin)
       tcut1=0.05d-2*pi
       tcut2=0.01d-1*pi
       return
       end      
C*****************************************
C       theta in CM to theta in lab
C*************************************
      subroutine  cmtolab(tcm,tlab)
      implicit real*8(a-h,m-z)
C tcm should be 0 to pi, and tlab should also be 0 to pi
      common /kinstau/ xmax,xmin,vstau
      costc=cos(tcm)
      sintc=sin(tcm)
      sintp= (xmax-xmin)*dsqrt(1.d0-vstau**2)*sintc
      costp=(xmax-xmin)*costc+(xmax+xmin)*vstau**2
      tlab=atan2(sintp,costp)
      return
      end
C*************************************
C theta in lab to theta in cm
C***************************************
      subroutine labtocm(tlab,tcm)
      implicit real*8(a-h,m-z)
      common /kinstau/ xmax,xmin,vstau
      common /cut/ pi,tcut1,tcut2,tmin
      costl=cos(tlab)
      sintl=sin(tlab)
      cdummy=dsqrt(1.d0-vstau**2) *costl
      tp=atan2(sintl,cdummy)
      D=sintl**2 +(1.d0-vstau**2) *costl**2
      D=dsqrt(D)
      fac=(xmax+xmin)/(xmax-xmin)*vstau**2*sintl
      tcm=asin(fac/D) +tp
      if(tcm.lt.0) tcm=tcm+2.d0*pi
      return
      end
C***************************
C  xdum is parameter in 1 jet 
C  x is parameter of 2nd jet
C  phi is the angle that satisfie acolinearlity cut
C*********************************
       real*8 function phi(x)
       implicit real*8(a-h,m-z)
       common /kinstau/ xmax,xmin,vstau
       common /cut/ pi,tcut1,tcut2,tmin
      common /xdummy/ xdum
       tcut0=0.5d-4*pi
       y=xdum
C
C     determin the angle of tau in the CM flame off the boost axis     
       call xtocm(y,t1)
       call cmtolab(t1,t1lab)
       call xtocm(x,t2)
       call cmtolab(t2,t2lab)
C
       if(t1lab.gt.pi/2.d0) then 
       t1lab=pi-t1lab
       t2lab=pi-t2lab
       endif

C
       if(t1lab.lt.tcut0) then 
          if(t2lab.ge.tmin-tcut1) then 
C                  write(*,*) t2lab,tmin
                   phi=pi 
           elseif(t2lab.lt.tmin-tcut1) then 
                   phi=0.d0
C                 write(*,*) t2lab,tmin
           endif
        elseif(t1lab.lt.tcut2) then
           if(t2lab.ge.t1lab+tmin)  then 
              phi=pi
           elseif(t2lab.le.tmin-t1lab) then 
              phi=0.d0
           else
              phi=acos( (tmin-t2lab)/t1lab)
           endif
        elseif(t1lab.le.tmin) then 

           if(t2lab.ge.t1lab+tmin) then 
              phi=pi
           elseif(t2lab.le.tmin-t1lab) then 
              phi=0.d0
           else
              phi=phix(t1lab,t2lab)
           endif   
        elseif(t1lab.le.pi/2.d0) then
           if(t2lab.le.t1lab-tmin) then
               phi=pi
           elseif(t2lab.ge.t1lab+tmin) then
               phi=pi
           else
C               write(*,*) 'where am I' 
               phi=phix(t1lab,t2lab) 
           endif
       endif
C       write(*,*) x,phi
C       dummy=phix(t1lab,t2lab)
C       write(*,*) 'am I defferent?' , dummy
       end
C
       real*8 function phix(t1lab,t2lab)
       implicit real*8(a-h,m-z)
       common /cut/ pi,tcut1,tcut2,tmin
       tcut0=0.5d-4*pi  
       sint1=sin(t1lab)
       cost1=cos(t1lab)
       sint2=sin(t2lab)
       cost2=cos(t2lab)
       phix=-1000
       if(t2lab.lt.tcut0) then
       phix=pi
       write(*,*) 'I am here'
       elseif(t2lab.lt.tcut2.and.(t1lab-tmin).gt.0.d0.and
     & .(t1lab-tmin).lt.t2lab) then 
       cosphi=-(t1lab-tmin)/t2lab
C       write(*,*) cosphi,'cosphi'     
       phix=acos(cosphi)
       else
       cosphi=(cos(pi-tmin)+cost1*cost2)/sint1/sint2
       if(cosphi.lt.-1) cosphi=-1.d0
       if(cosphi.gt.1.d0) cosphi=1.d0
       phix=acos(cosphi)
       endif
       if(phix.lt.0) then 
         write(*,*)  'phix stop'
         stop
       endif
       end

C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C beam data
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  *INCLUDE UDSRCH
C        WRITE(21,'(''NEWFRAME'')')
C        WRITE(21,'(''SET ORDER X Y'')')
C        DO 10 I = 1, 100
C           X = 0.01*I
C           CALL RSHDIS(X,1,Y)
C           WRITE(21,'(2E15.8)') Y, X
C  10    CONTINUE
C        WRITE(21,'(''JOIN'')')
C        END
C*
C* This version for JLC-I X-band(150) parameter as of 93/04/18
C* with the bremsstrahlung:
C*                   _
C*                  / 1
C*    sig_RC(s) =  /   dz b [ z**(b-1)(1+3b/4) - (1-z/2) ] sig((1-z)s)
C*               _/ 0
C* The beam energy spread is assumed to be flat and has FWHM of 1.0%.
C*
      SUBROUTINE RSHDIS(X,ITYP,Y)
 
      IMPLICIT   REAL*8 ( A-H, O-Z )
      INTEGER*4  ITYP
      REAL   *8  X, Y
C--
      DATA   SGEB / 0.005D0 /
      PARAMETER  ( MXxDAT = 81 )
      REAL   *8  BMDATA(2,0:MXxDAT)
      DATA ( BMDATA(I,0),I=1,2) /  2*0.D0 /
      DATA ((BMDATA(I,J),I=1,2),J= 1,20) /
     . 0.46917610D-03, 0.29999997D-01, 0.13529558D-02, 0.89999974D-01,
     . 0.26466998D-02, 0.14999998D+00, 0.42429529D-02, 0.20999998D+00,
     . 0.60631782D-02, 0.26999998D+00, 0.80721080D-02, 0.32999998D+00,
     . 0.10347933D-01, 0.38999999D+00, 0.12878112D-01, 0.44999999D+00,
     . 0.15549790D-01, 0.50999999D+00, 0.18368363D-01, 0.56999999D+00,
     . 0.21337438D-01, 0.63000000D+00, 0.24469260D-01, 0.69000000D+00,
     . 0.27896043D-01, 0.75000000D+00, 0.31481497D-01, 0.80999994D+00,
     . 0.35154924D-01, 0.86999995D+00, 0.39085470D-01, 0.92999995D+00,
     . 0.43139618D-01, 0.98999995D+00, 0.47354035D-01, 0.10499992D+01,
     . 0.51819582D-01, 0.11099997D+01, 0.56467917D-01, 0.11699991D+01/
      DATA ((BMDATA(I,J),I=1,2),J=21,40) /
     . 0.61408285D-01, 0.12299995D+01, 0.66563964D-01, 0.12900000D+01,
     . 0.72005093D-01, 0.13499994D+01, 0.77726722D-01, 0.14099998D+01,
     . 0.83691835D-01, 0.14699993D+01, 0.90102077D-01, 0.15299997D+01,
     . 0.96915781D-01, 0.15899992D+01, 0.10417134D+00, 0.16499996D+01,
     . 0.11192214D+00, 0.17099991D+01, 0.12023985D+00, 0.17699995D+01,
     . 0.12916076D+00, 0.18299999D+01, 0.13856155D+00, 0.18899994D+01,
     . 0.14857507D+00, 0.19499998D+01, 0.15900099D+00, 0.20099993D+01,
     . 0.17000854D+00, 0.20699997D+01, 0.18159306D+00, 0.21299992D+01,
     . 0.19364733D+00, 0.21899996D+01, 0.20635843D+00, 0.22500000D+01,
     . 0.21942562D+00, 0.23099995D+01, 0.23316675D+00, 0.23699999D+01/
      DATA ((BMDATA(I,J),I=1,2),J=41,60) /
     . 0.24709624D+00, 0.24299994D+01, 0.26161265D+00, 0.24899998D+01,
     . 0.27651101D+00, 0.25499992D+01, 0.29204160D+00, 0.26099997D+01,
     . 0.30791533D+00, 0.26699991D+01, 0.32411772D+00, 0.27299995D+01,
     . 0.34084654D+00, 0.27900000D+01, 0.35786092D+00, 0.28499994D+01,
     . 0.37542433D+00, 0.29099998D+01, 0.39330065D+00, 0.29699993D+01,
     . 0.40255284D+00, 0.30149994D+01, 0.41193247D+00, 0.30449991D+01,
     . 0.42150849D+00, 0.30749998D+01, 0.43127674D+00, 0.31049995D+01,
     . 0.44136357D+00, 0.31349993D+01, 0.45166171D+00, 0.31650000D+01,
     . 0.46204972D+00, 0.31949997D+01, 0.47280377D+00, 0.32249994D+01,
     . 0.48384172D+00, 0.32549992D+01, 0.49522501D+00, 0.32849998D+01/
      DATA ((BMDATA(I,J),I=1,2),J=61,80) /
     . 0.50713444D+00, 0.33149996D+01, 0.51948869D+00, 0.33449993D+01,
     . 0.53243959D+00, 0.33750000D+01, 0.54613018D+00, 0.34049997D+01,
     . 0.56078678D+00, 0.34349995D+01, 0.57676947D+00, 0.34649992D+01,
     . 0.59498650D+00, 0.34949999D+01, 0.62124234D+00, 0.35249996D+01,
     . 0.65583831D+00, 0.35549994D+01, 0.69752795D+00, 0.35849991D+01,
     . 0.74486202D+00, 0.36149998D+01, 0.79570866D+00, 0.36449995D+01,
     . 0.84795910D+00, 0.36749992D+01, 0.89336556D+00, 0.37049999D+01,
     . 0.92931241D+00, 0.37349997D+01, 0.95658273D+00, 0.37649994D+01,
     . 0.97634214D+00, 0.37949991D+01, 0.98944020D+00, 0.38249998D+01,
     . 0.99695528D+00, 0.38549995D+01, 0.99987316D+00, 0.38849993D+01/
      DATA ((BMDATA(I,J),I=1,2),J=81,81) /
     . 0.99999988D+00, 0.39150000D+01/
C
C========< Entry Point >================================================
C
C--
      if(ityp.eq.1) then 
C  Decide which bin X belongs to.
C--
      CALL UDSRCH(MXxDAT,2,ityp,BMDATA(1,1),DBLE(X),IP)
C--
C  Calculate Y.
C     FRAC = MAX(1.E-6,1+5*SGEB-FRAC)
C     FRAC = -LOG(FRAC)
C--
      IF ( IP.NE.0 .AND. IP.NE.MXxDAT ) THEN
         XL  = BMDATA(1,IP)
         DX  = BMDATA(1,IP+1) - XL
         DF  = (BMDATA(2,IP+1)-BMDATA(2,IP))/DX
         VAL = BMDATA(2,IP) + (X-XL)*DF
      ELSE
         Val = BMDATA(2,IP)
      ENDIF
      Y   = 1 + 5*SGEB - EXP(-VAL)
      elseif(ityp.eq.2) then 
      val=-log(1.d0+5.d0*sgeb-y)
C      write(*,*) 'y,val',y,val
      call udsrch(MXxDAT,2,ityp,bmdata(1,1),val,ip)
C      write(*,*) 'ip=',ip
C    calculate x
      if(ip.ne.0.and.ip.ne.mxxdat) then 
        vl=bmdata(2,ip)
        dv=bmdata(2,ip+1)-vl
        df=(bmdata(1,ip+1)-bmdata(1,ip))/dv
        x=bmdata(1,ip)+(val-vl)*df
        else
        x=bmdata(1,ip)
      endif
      endif
C--
C  That's it.
C--
      RETURN
      END















