      SUBROUTINE A13PSC(NTRK,LNxPV,MXxPV,QV,IPTOJ,
     .                           NJ,IJI,NPINJ,NCTKJ,ICHGJ,ISC)
      DIMENSION       QV(LNxPV,MXxPV),IPTOJ(MXxPV),
     .                ICHGJ(NJ),NCTKJ(NJ),NPINJ(NJ),IJI(NJ),
     .                ISC(NJ)
C 
C
C  NTRK  :  NUMBER OF JET
C  IPTOJ(NTRK) :  NUMBER OF JET THAT A TRACK BELONG
C  NJ    :  NUMBER OF JET
c  IJI(NJ)   :  NUMBER OF ELEMENT OF QV WHERE JET INFO CONTAINED
C  NCTKJ(NJ) :  NUMBER OF CHARGED TRACK IN A JET
C  NPINJ(NJ) :  NUMBER OF PARTICLE IN A JET, NOT THE SAME
C               ARRAY OF THE MAIN ROUTINE, HAVE TO BE 
C               REDEFINED BEFORE CALLING.
C  ICHGJ(NJ) :  NUMBER OF CHARGED TRACK IN A JET
C  QV(L,1-NTRK)           : TRACK INFO
C  QV(L,IJI(1)-IJI(NJ)) ) : JET INFO 
C  ISC(NJ)   : IDENTIFICATION CODE, Should be set equal to be zero
C                                   before call of 
C                                   the subroutine set.
C      1: a1 3-prong
C      2: a1 1-prong
C      4: rho
C      8: pi
C      if a jet is identified both a1 1 prong and rho, for example, 
C      you get 6 as the return code after calling the selection 
C      subroutines. Probablly, cuts should be chosen so that 1,2,4,8 
C      is maximized, 
C      while other numbers are minimized. 
C--
C  Look at 3-track system, if any.
C--
      DATA AMJCUT     / 3.0  /
C
      DO 600 IJ = 1, NJ
         NNUT = NPINJ(IJ) -  NCTKJ(IJ)               
	 EJET = QV(4,IJI(IJ))
         IF ( NCTKJ(IJ).NE.3 ) GOTO 600
         AMJ = UDOT4(QV(1,IJI(IJ)),QV(1,IJI(IJ)))
         AMJ = SIGN(SQRT(ABS(AMJ)),AMJ)
         CALL HCUM1(31,AMJ,1.)
         IF( AMJ.GT.AMJCUT) GOTO 600
         ISC(IJ)=ISC(IJ)+1
C --- START TO ANALYZE ENERGY DISTRIBUTION OF A JET IDENTIFIED AS A1---
            ICHJ = ICHGJ(IJ)
            EM12 = 9999.
            DO 60 ITK = 1, NTRK
               IF ( IPTOJ(ITK).EQ.IJ ) THEN
                  ICHG = QV(9,ITK)
                  IF ( ICHG.NE.0 .AND. ICHG.NE.ICHJ ) THEN
                     ITK3 = ITK
		     EM3  = QV(4,ITK)
                  ELSE
                     IF ( QV(4,ITK).LT.EM12 ) THEN
                        ITK12 = ITK
                        EM12  = QV(4,ITK)
                     ENDIF
                  ENDIF
               ENDIF
60          CONTINUE
	    CALL HCUM1(29,EJET,1.)
            CALL HCUM2(226,EM3/EBM,EM12/EBM,1.)
	    CALL HCUM2(227,EJET,NNUT+.1,1.)
            CALL HCUM2(229,EM3/EJET,EM12/EJET,1.)
C  --- END OF ENERGY DISTRIBUTION ANALYSIS OF A JET IDENTIFIED AS A1---
600   CONTINUE

      RETURN
      END
