C***********************************************************************
C*
C*====================
C* Subroutine PRUJIN
C*====================
C*
C* (Function)
C*    Job initialization for user analysis.
C* (Input & Output )
C*    none.
C* (Relation)
C*    Called from FLANLI
C* (Update Record)
C*   87/05/29  K.Fujii 		Original version.
C*   95/03/22  M.Nojiri		Added new hists. and plots.
C*
C***********************************************************************
 
      SUBROUTINE PRUJIN
 
      PARAMETER     ( MXxHPK = 280000 )
      COMMON /PAWC/ M(MXxHPK)
C
C========< Entry Point >================================================
C
C--
C  Write user production version #.
C--
      CALL PRPVRS( 'USER:', 001, 900423)
C--
C  Initialize plot buffer.
C--
      CALL HINIT(MXxHPK)
C--
C  Choose appropriate options.
C--
      CALL DOPT('NCALLS',.TRUE.)
      CALL DOPT('L2ZAUT',.TRUE.)
      CALL DOPT('L2COL',2)
C     CALL DOPT('L2COL',1)
C     CALL DOPT('L2SYM',16)
      CALL DOPT('YZERO',.TRUE.)
      CALL HOPTN('STAT',.TRUE.)
      CALL HOPTN('HOMIT',.TRUE.)
C--
C  Initialize hists and plots.
C--
      CALL HDEF1(  1,'I*4', 20,  0.,1.0     ,  'Cut statistics      @')
      CALL HDEF1(  2,'I*4',200,  0.,1.0     ,  '# combined tracks   @')
      CALL HDEF1(  4,'I*4',100,  0.,2.0     ,  '# good tracks       @')
      CALL HDEF1(  7,'I*4',150,  0.,1.0     ,  'Pt                  @')
      CALL HDEF1(  9,'I*4', 90,  0.,2.0     ,  'Acoplanarity        @')
      CALL HDEF1( 10,'I*4', 50,  0.,1.0     ,  'NTRY(y_cut)         @')
      CALL HDEF1( 11,'I*4',100,  0.,2.E-4   ,  'y_cut(2-jet)        @')
      CALL HDEF1( 12,'EFF', 20,  1.,1.0     ,  ' 2-jet fracton      @')
      CALL HDEF1( 13,'EFF', 20,  1.,1.0     ,  ' 3-jet fracton      @')
      CALL HDEF1( 14,'EFF', 20,  1.,1.0     ,  ' 4-jet fracton      @')
      CALL HDEF1( 15,'EFF', 20,  1.,1.0     ,  ' 5-jet fracton      @')
      CALL HDEF1( 23,'I*4',100, -1.,0.02    ,  'cos(theta_J1) final @')
      CALL HDEF1( 24,'I*4',100, -1.,0.02    ,  'cos(theta_J2) final @')
      CALL HDEF1( 25,'I*4',150,  0.,1.0     ,  'Pt final            @')
      CALL HDEF1( 26,'I*4', 90,  0.,2.0     ,  'Acoplanarity final  @')
      CALL HDEF1( 27,'I*4',100,  0.,0.01    ,  'Thrust final-1      @')
      CALL HDEF1( 28,'I*4',100,  0.,2.E-4   ,  'y_cut(2-jet) final  @')
      CALL HDEF1( 29,'I*4',150,  0.,1.0     ,  'Ej(3tk) final       @')
      CALL HDEF1( 30,'I*4',150,  0.,1.0     ,  'Ej(1tk) final       @')
      CALL HDEF1( 31,'I*4', 50,  0.,0.1,    ,  'AMJ 3-truck system  @')
      CALL HDEF1( 32,'I*4', 50,  0.,0.1,    ,  'AMJ rho candidate   @')
      CALL HDEF1( 33,'I*4', 50,  0.,0.1,    ,  'AMJ pi0 from rho    @')
      CALL HDEF2( 34,'I*4',100,  0.,.01,    ,  ' ZC, final          @')
 


C--
      CALL HDEF2(201,'I*4',160,100,0.,-100., 2.0,2., '(Evis,Pl)     @')
      CALL HDEF2(202,'I*4', 10, 10,0.,   0., 1.0,1., '(ICH1,ICH2)   @')
      CALL HDEF2(203,'I*4', 10, 10,0.,   0., 1.0,1., '(NCH1,NCH2)   @')
      CALL HDEF2(204,'I*4', 50, 50,0.,   0., 0.1,.1, '(AMJ1,AMJ2)   @')
      CALL HDEF2(223,'I*4',160,100,0.,-100., 2.0,2., '(Evis,Pl)final@')
      CALL HDEF2(224,'I*4', 50, 50,0.,   0., 0.1,.1, '(AMJ1,AMJ2)fin@')
      CALL HDEF2(225,'I*4',100,100,0.,   0., 2.0,2., '(EJ1,EJ2)final@')
      CALL HDEF2(226,'I*4',100,100,0.,   0.,.01,.005,'(X3,X12)final @')
      CALL HDEF2(227,'I*4',150, 10,0.,   0., 1.0,1., '(EJ1,NUT)3fin @')
      CALL HDEF2(228,'I*4',150, 10,0.,   0., 1.0,1., '(EJ1,NUT)1fin @')
      CALL HDEF2(229,'I*4',100,100,0.,   0.,.01,.005,'(Z3,Z12)final @')
C--
C  That's it.
C--
      RETURN
      END

















