
      SUBROUTINE RHOSC(NTRK,LNxPV,MXxPV,QV,IPTOJ,
     .                           NJ,IJI,NPINJ,NCTKJ,ICHGJ,ISC)
      DIMENSION       QV(LNxPV,MXxPV),IPTOJ(MXxPV),
     .                ICHGJ(NJ),NCTKJ(NJ),NPINJ(NJ),IJI(NJ),
     .                ISC(NJ),QVN(4)
C 
C
C  NTRK  :  NUMBER OF JET
C  IPTOJ(NTRK) :  NUMBER OF JET THAT A TRACK BELONG
C  NJ        :  NUMBER OF JET
c  IJI(NJ)   :  NUMBER OF ELEMENT OF QV WHERE JET INFO CONTAINED
C  NCTKJ(NJ) :  NUMBER OF CHARGED TRACK IN A JET
C  NPINJ(NJ) :  NUMBER OF PARTICLE IN A JET, NOT THE SAME
C               ARRAY OF THE MAIN ROUTINE, HAVE TO BE 
C               REDEFINED BEFORE CALLING.
C  ICHGJ(NJ) :  NUMBER OF CHARGED TRACK IN A JET
C  QV(L,1-NTRK)           : TRACK INFO
C  QV(L,IJI(1)-IJI(NJ)) ) : JET INFO 
C  ISC(NJ)   : IDENTIFICATION CODE, Should be set equal to be zero
C                                   before call of 
C                                   the subroutine set.
C      1: a1 3-prong
C      2: a1 1-prong
C      4: rho
C      8: pi
C      if a jet is identified both a1 1 prong and rho, for example, 
C      you get 6 as the return code after calling the selection 
C      subroutines. Probablly, cuts should be chosen so that 1,2,4,8 
C      is maximized, 
C      while other numbers are minimized. 
C--
C  Look at 1-charged track and 2 neutral track system, if any.
C--
      DATA AMJCUT     / 3.0  /
      DATA AMNCUT     / 2.0  /
C
      DO 600 IJ = 1, NJ
         NNUT = NPINJ(IJ) -  NCTKJ(IJ)               
	 EJET = QV(4,IJI(IJ))
         IF ( NCTKJ(IJ).NE.1) GOTO 600
         IF (NNUT.EQ.0.OR.NNUT.GE.3) GOTO 600
C SET TOTAL NEUTRAL TRUCK MOMENTUM array EQUAL TO ZERO
         CALL UVZERO(4,QVN(1))
C CALCULATE TOTAL NEUTRAL TRUCK MOMENTUM
            DO 1 ITK=1,NTRK
              IF(IPTOJ(ITK).EQ.IJ) THEN              
                ICHG =QV(9,ITK)
                ITYP =QV(10,ITK)
                IF(ICHG.NE.0.AND.ITYP.NE.5) GOTO 600
                IF(ICHG.NE.0) EC=QV(4,ITK)
                IF(ICHG.EQ.0.AND.ITYP.GT.2) GOTO 600
                IF(ICHG.EQ.0) CALL UVADD4(QVN(1),QV(1,ITK),QVN(1))
              ENDIF
 1          CONTINUE
C        ENERGY DISTRIBUTION CUTS
         AMJ = UDOT4(QV(1,IJI(IJ)),QV(1,IJI(IJ)))
         AMJ = SIGN(SQRT(ABS(AMJ)),AMJ)
         CALL HCUM1(32,AMJ,1.)
         IF( AMJ.GT.AMJCUT) GOTO 600

         IF(NNUT.EQ.2) THEN
           AMN=UDOT4(QVN(1),QVN(1))
           AMN=SIGN(SQRT(ABS(AMN)),AMN)
           CALL HCUM1(33,AMN,1.)
           IF( AMN.GT.AMNCUT) GOTO 600
         ENDIF 
C        SELECTION FLAG
            ISC(IJ)=ISC(IJ)+4
C --- ANALYZE ENERGY DISTRIBUTION OF A JET IDENTIFIED AS RHO---
            CALL HCUM1(34, EC/EJET, 1.)
600    CONTINUE

      RETURN
      END
