C--
C  *INCLUDE COUPLSUB
C  *INCLUDE INOMXX
C  *INCLUDE SWPELM
C  *INCLUDE INSUZE
C  *INCLUDE SGTCXX
C  *INCLUDE SGTSEE
C  C--
C  *INCLUDE SGSESE
C  *INCLUDE SGCXXA
C--
      AMER = 141.89
      AMU  = 400
      AM2  = 250
      TNB  = +2
      AM1  = AM2*0.23/(1.-0.23)*(5./3.)
C--
      ISEED = 314179
      NPT   = 0
      DO 1000 I = 1, 50000000
         AMER = 141.89 + 1.43*RANN(ISEED)
         AMU  = 380 + 100*RAN(ISEED)
         AM1  = 120 +  20*RAN(ISEED)
         AM2  = 250 +  30*RAN(ISEED)
         TNB  = 1.5 + 2.5*RAN(ISEED)
C--
         CALL X2M1M2(AMER,AMU,AM1,AM2,TNB,CHI2)
         IF ( CHI2.LT.10. ) THEN
            NPT = NPT + 1
            PRINT *, ' AMU, AM1, AM2, CHI2 = ', AMU, AM1, AM2, CHI2
            WRITE(21,*) AMER, AMU, AM1, AM2, TNB, CHI2
            IF ( NPT.EQ.10000 )                   GO TO 999
         ENDIF
1000  CONTINUE
 
999   STOP
      END
 
      SUBROUTINE X2M1M2(AMER,AMU,AM1,AM2,TNB,CHI2)
 
      IMPLICIT    REAL*4  ( A-H, O-Z, x )
      REAL   *4  AMER, AMU, AM1, AM2, TNB, CHI2
C--
      REAL   *4  ALF, ALFS, S2W, WM, ZM, FM(3),
     .           SFM(7), SWM(2), SZM(4), AM(2)
      COMPLEX*8  GNCW(2,4,2), GCCZ(2,2,2), GNNZ(2,4,4)
      COMPLEX*8  GCESNL(2,2), GCNSEL(2,2), GCNSER(2,2),
     .           GCUSDL(2,2), GCUSDR(2,2), GCDSUL(2,2), GCDSUR(2,2)
      COMPLEX*8  GNNSNL(2,4), GNESEL(2,4), GNESER(2,4),
     .           GNUSUL(2,4), GNUSUR(2,4), GNDSDL(2,4), GNDSDR(2,4)
C
      DATA NCALL /0/
C
C========< Entry Point >================================================
C
C--
C  Calculate masses and couplings.
C--
      IF ( NCALL.EQ.0 ) THEN
         NCALL     = 1
         S2W       = 0.23
         ALF       = 1/128.
         ALFS      = 0.12
         ZM        = 91.17
         WM        = 80.0
         GMZ       = 2.5
         FM(1)     = 0.
         FM(2)     = 0.
         FM(3)     = 0.
         SNM       = 200.
C--
         CS        = 10./12.2
         SN        = SQRT((1-CS)*(1+CS))
         EMER      = 141.89
         DEMERP    = 1.75
         EMX0      = 117.78
         DEMX0P    = 0.21
C--
         EMXC      = 219.28
         DEMXC     = 3.2
C--
         RSXC      = 500.
         POLXC     = +1
         ESGXC     = 1.17E-3
C        DESGXC    = 0.44E-3
         DESGXC    = 0.88E-3
C--
         RSSE      = 350.
         POLSE     = +1
         ESGSE     = 181.3E-3
C        DESGSE    = 5.24E-3
         DESGSE    = 10.48E-3
      ENDIF
C--
C  Calculate masses and couplings.
C--
      CALL INSUZE(AMU,AM1,AM2,TNB,ALF,ALFS,S2W,ZM,FM,
     .            SWM,SZM,
     .            GNCW,GCCZ,GNNZ,
     .            GCESNL,GCNSEL,GCNSER,
     .            GCUSDL,GCUSDR,GCDSUL,GCDSUR,
     .            GNNSNL,GNESEL,GNESER,
     .            GNUSUL,GNUSUR,GNDSDL,GNDSDR )
C--
C  Calculate the contribution from mass measurements.
C--
      X =  CS*(AMER-EMER) + SN*(SZM(1)-EMX0)
      Y = -SN*(AMER-EMER) + CS*(SZM(1)-EMX0)
      CHI2 = (X/DEMERP)**2 + (Y/DEMX0P)**2 + ((EMXC-SWM(1))/DEMXC)**2
CX    PRINT *, ' CHI2A = ', CHI2
C--
C  Calculate the contribution from XCXC cross section.
C--
      CALL SGTCXX(ALF,S2W,ZM,GMZ,SNM,SWM,GCCZ,GCESNL,RSXC,POLXC,SGXC)
      CHI2B = ((SGXC-ESGXC)/DESGXC)**2
      CHI2  = CHI2 + CHI2B
CX    PRINT *, ' SGXC =', SGXC
CX    PRINT *, ' CHI2B = ', CHI2B
C--
C  Calculate the contribution from SESE cross section.
C--
      AM(1) = AMER
      AM(2) = AMER
      CALL SGTSEE(2,ALF,S2W,ZM,SZM,AM,GNESEL,GNESER,RSSE,POLSE,SGSE)
      CHI2C = ((SGSE-ESGSE)/DESGSE)**2
      CHI2 = CHI2 + CHI2C
CX    PRINT *, ' SGSE =', SGSE
CX    PRINT *, ' CHI2C =', CHI2C
C--
C  That's it.
C--
      RETURN
      END
