C*
C*  Total cross section for e+e- --> X+ X-
C*  as a function of  RS = sqrt(S).
C*
C*  5/16/91  K.Fujii       This version can handle X+1 X-2 case.
C*
      SUBROUTINE SGTCXX(ALF,S2W,ZM,GMZ,SNM,SWM,GCCZ,GCESNL,RS,POL,SGT)
 
      IMPLICIT    REAL*8  ( A-H, O-Z, x )
      REAL   *4   ALF, S2W, ZM, GMZ,
     .            SNM, SWM(2), RS, POL, SGT
      COMPLEX*8   GCCZ(2,2,2)
      COMPLEX*8   GCESNL(2,2)
C--
      REAL   *8   GAL(2), GAX(2), GZL(2), GZX(2),
     .            AMSN, GMSN, AMX(2), GMX(2)
      REAL   *8   GSNX(2,2)
      REAL   *8   SG(0:3)
C
      DATA NCALL /0/
C
C========< Entry Point >================================================
C
C--
C  Define constants.
C--
      IF ( NCALL.EQ.0 ) THEN
         x2PI      = 2*ACOS(-1.)
         x4PI      = 2*x2PI
         C2W       = 1 - S2W
C--
C  Select reaction type and parameter set.
C--
         IXM       = 1
         IXP       = 1
C--
C  Couplings of electron to Z and gamma.
C--
         C0        = SQRT(x4PI*ALF)
         CW        = C0/SQRT(S2W)
         CZ        = CW/SQRT(C2W)
         QE        = -1
         T3LE      = -0.5D0
         T3RE      =  0
C--
         GAL(1)    = -C0*QE
         GAL(2)    = -C0*QE
         GZL(1)    = -CZ*(T3LE-QE*S2W)
         GZL(2)    = -CZ*(T3RE-QE*S2W)
      ENDIF
C--
C  Set SUSY parameters.
C--
      AMZ       = ZM
      GAMZ      = GMZ
      AMSN      = SNM
      GMX(1)    = 0
      GMX(2)    = 0
      GMSN      = 0
C--
C  Calculate masses and mixings.
C--
      AMX(1) = SWM(IXM)
      AMX(2) = SWM(IXP)
      QX     = -1
      IF ( IXM.NE.IXP ) QX = 0
C--
C  Coupling of chargino to Z and gamma.
C--
      GAX(1)    = -C0*QX
      GAX(2)    = -C0*QX
      GZX(1)    = GCCZ(1,IXM,IXP)
      GZX(2)    = GCCZ(2,IXM,IXP)
      GSNX(1,1) = GCESNL(1,IXM)
      GSNX(2,1) = GCESNL(2,IXM)
      GSNX(1,2) = CONJG(GCESNL(2,IXP))
      GSNX(2,2) = CONJG(GCESNL(1,IXP))
C--
C  Integration over cos(theta).
C--
      SGT  = 0
      IF ( RS.LT.AMX(1)+AMX(2) ) RETURN
C--
      RSD  = RS
      POLD = POL
      CALL SGCXXA(GAL,GAX,GZL,GZX,GSNX,AMSN,GMSN,AMZ,GAMZ,
     .                 AMX, GMX ,RSD, POLD, SG)
      SGT  = SG(0)
C--
C  That's it.
C--
      RETURN
      END
