C*
C*  Total cross section for e+e- --> se+se-.
C*
C*  8/26/92  K.Fujii       Original version.
C*
      SUBROUTINE SGTSEE(MODE,ALF,S2W,ZM,SZM,AM,GNESEL,GNESER,RS,POL,SGT)
 
      IMPLICIT    REAL*8  ( A-H, O-Z, x )
      INTEGER*4   MODE
      REAL   *4   ALF, S2W, ZM, SZM(4), AM(2),
     .            RS, POL, SGT
      COMPLEX*8   GNESEL(2,2), GNESER(2,2)
C
      REAL   *8  AMSE(2), AMX(4), CGE(2), CZE(2), CGSE(2), CZSE(2)
      COMPLEX*16 CX(2,2,4)
C
      DATA NCALL /0/
C
C========< Entry Point >================================================
C
C--
C  Define mass and coupling parameters.
C--
      IF ( NCALL.EQ.0 ) THEN
         NCALL = 1
         PI    = ACOS(-1.D0)
         C2W   = 1 - S2W
         SW    = SQRT(S2W)
         CW    = SQRT(C2W)
C--
         C0      = SQRT(4*PI*ALF)
         CGE(1)  = C0
         CGE(2)  = C0
         CZE(1)  = -C0/(SW*CW)*(-0.5D0+S2W)
         CZE(2)  = -C0/(SW*CW)*(       S2W)
C--
         CGSE(1) = CGE(1)
         CGSE(2) = CGE(2)
         CZSE(1) = CZE(1)
         CZSE(2) = CZE(2)
      ENDIF
C--
      AMSE(1) = AM(1)
      AMSE(2) = AM(2)
      AMX (1) = SZM(1)
      AMX (2) = SZM(2)
      AMX (3) = SZM(3)
      AMX (4) = SZM(4)
      AMZ     = ZM
C--
      DO 10 IX = 1, 4
         CX(1,1,IX) = GNESEL(1,IX)
         CX(2,1,IX) = GNESEL(2,IX)
         CX(1,2,IX) = GNESER(1,IX)
         CX(2,2,IX) = GNESER(2,IX)
10    CONTINUE
C--
C  Calculate cross section.
C--
      RSEE = RS
      POLE = POL
      CSMX = 1
      CALL SGSESE(MODE,AMZ,AMSE,AMX,CX,CGE,CZE,CGSE,CZSE,
     .               RSEE,POLE, CSMX, SG0)
      SGT  = SG0
C--
C  That's it.
C--
      RETURN
      END
