 
      SUBROUTINE GTCHI2(MODE,EPIN,AMP,AMD,NPOT,A,CHI2)
 
      IMPLICIT   REAL*8 ( A-H, O-Z )
      INTEGER*4  MODE, NPOT
      REAL   *8  EPIN, AMP, AMD, A(0:1), CHI2
C--
      REAL   *8  XYDAT(3,500)
      DATA  LIU  /11/
C
C==================< Entry Point >======================================
C
C--
C  Initialization.
C--
      IF ( MODE.EQ.0 ) THEN
         EP  = EPIN
         FAC = 1
C--
C  Read in data.
C--
         NP  = 0
1        READ(LIU,*,END=2) X, Y, DY
         NP = NP + 1
         XYDAT(1,NP) = X
         XYDAT(2,NP) = Y  *FAC
         XYDAT(3,NP) = DY *FAC
         GO TO 1
C--
2        PRINT *, '>>> GTCHI2 initialization >>>>'
         PRINT *, '  EP = ', EP
         PRINT *, '  # data points = ', NP
         DO 20 IP = 1, NP
            PRINT *, '   ', IP, (XYDAT(K,IP),K=1,3)
20       CONTINUE
         RETURN
      ENDIF
      NPOT = NP
C--
C  Calculate Emin and Emax.
C--
      CALL ELBXTR(EP,AMP,AMD,EMIN,EMAX)
C--
C  Calculate inverse error matrix.
C--
      E11 = 0
      E12 = 0
      E22 = 0
      B1  = 0
      B2  = 0
      NPF = 1
      NPL = NP
      DO 300 IP = 1, NP
         X   = XYDAT(1,IP)
         Y   = XYDAT(2,IP)
         DY2 = XYDAT(3,IP)**2
         IF ( Y.LE.0. )                          GO TO 300
         IF ( X.LT.EMIN ) THEN
            NPF = IP + 1
                                                 GO TO 300
         ENDIF
         IF ( X.GT.EMAX ) THEN
            NPL = IP - 1
                                                 GO TO 350
         ENDIF
         XX  = (X-EMIN)*(EMAX-X)
         XX2 = XX*XX
         E11 = E11 + XX2/DY2
         E12 = E12 + XX2*X/DY2
         E22 = E22 + XX2*X*X/DY2
         B1  = B1  + XX*Y/DY2
         B2  = B2  + XX*X*Y/DY2
300   CONTINUE
350   E21 = E12
      IF ( NPL-NPF.LT.2 ) THEN
         PRINT *, ' >>> Error in GTCHI2 >>>> '
         PRINT *, '    NPF = ', NPF, ' NPL = ', NPL
         PRINT *, '    EP  = ', EP
         PRINT *, '    AMP = ', AMP
         PRINT *, '    AMD = ', AMD
         PRINT *, '    EMN = ', EMIN
         PRINT *, '    EMX = ', EMAX
         CHI2 = (XYDAT(1,1)-EMIN)**2 + (XYDAT(1,NP)-EMAX)**2
         RETURN
      ENDIF
C--
C  Solve for a1 and a2.
C--
      DET  = E11*E22 - E12*E21
      D11  = E22/DET
      D12  =-E21/DET
      D21  = D12
      D22  = E11/DET
      A0   = D11*B1 + D12*B2
      A1   = D21*B1 + D22*B2
C--
      A(0) = A0
      A(1) = A1
C--
C  Calculate chi**2.
C--
      CHI2 = 0
      DO 400 IP = 1, NP
         X   = XYDAT(1,IP)
         Y   = XYDAT(2,IP)
         DY  = XYDAT(3,IP)
         IF ( Y.LE.0. )                          GO TO 400
C>>>
         F = MAX((X-EMIN)*(EMAX-X)*(A0+A1*X),0.)
CX       F = (X-EMIN)*(EMAX-X)*(A0+A1*X)
C>>>
         CHI2 = CHI2 + ((Y-F)/DY)**2
400   CONTINUE
C--
C  That's it.
C--
      RETURN
      END
