C*
C*  This routine draws the best fit curve.
C*
      PROGRAM DRWBST

      IMPLICIT REAL*8 ( A-H, O-Z )
      REAL*8   A(0:1)
      DATA LOU /20/
C
C==================< Entry Point >======================================
C
C--
C  Initialization.
C--
      EP = 125.
      CALL GTCHI2(0,EP,AMP,AMD,NP,A,CHI2)
C--
C  Calculate chi**2.
C--
CT    AMP = 219.3
CT    AMD = 169.3
      AMP = 96.1
      AMD = 44.4
C--
      CALL GTCHI2(1,EP,AMP,AMD,NP,A,CHI2)
      FUNC = CHI2
      PRINT *, ' NP = ', NP, ' CHI2 = ', CHI2
      PRINT *, ' A  = ', A
C--
C  Prepare topdraw data.
C--
      CALL ELBXTR(EP,AMP,AMD,EMIN,EMAX)
      NE = 50
      DE = ( EMAX - EMIN )/NE
      WRITE(LOU,*) 'SET ORDER X Y'
      DO 30 IE = 0, NE
         E = EMIN + IE*DE
         F = (E-EMIN)*(EMAX-E)*(A(0)+A(1)*E)
         WRITE(LOU,*) E, F
30    CONTINUE
      WRITE(LOU,*) 'JOIN'
C--
C  That's it.
C--
      STOP
      END
 
C*
C*
C*
C*
C*
C*
      PROGRAM    MXFIT

      IMPLICIT   REAL*8 ( A-H, O-Z, x )
      PARAMETER ( NCT = 3 )
      REAL   *8  CONTUR(NCT), XYLIM(2,2), XY0(2), DXY0(2),  A(0:1)
 
      REAL   *8  FNCT
      EXTERNAL   FNCT
      DATA LOU   / 20 /
C
C========< Entry Point >================================================
C
C--
C  Initialization.
C--
      EP = 125.
      CALL GTCHI2(0,EP,AMP,AMD,NP,A,CHI2)
C--
C  Allocate output data set.
C--
C     CALL UALCPS(LOU,'TKSF.@.@TOP@.TDR','RENEW','FB',30,IRT)
C--
C  Initialize window parameters.
C--
      XYLIM(1,1) =   80.
      XYLIM(2,1) =  120.
      XYLIM(1,2) =   34.
      XYLIM(2,2) =   54.
C--
C  Give a point within the innermost contour.
C     X0 = AMP
C     Y0 = AMD
C--
C     CHI2MN  = 16.5
C     XY0(1)  = 214.1
C     XY0(2)  = 166.0
      CHI2MN  = 16.1
      XY0(1)  =  96.7
      XY0(2)  =  44.4
      DXY0(1) =   0.05
      DXY0(2) =   0.05
C--
C  Initialize countour parameters.
C--
      CHI1S  = CHI2MN + 1.00
      CHI68  = CHI2MN + 2.28
      CHI90  = CHI2MN + 4.61
C--
      CONTUR(1)  = CHI1S
      CONTUR(2)  = CHI68
      CONTUR(3)  = CHI90
C--
C  Draw contours.
C--
      DO 100 ICT = 1, NCT
         CALL UCONTR(FNCT,1,CONTUR(ICT),XYLIM,XY0,DXY0,LOU)
C>>>
C           WRITE(LOU,*) XY0(1), XY0(2)
C           WRITE(LOU,'('' SYMBOL 9O SIZE 0.5; PLOT'')')
C           WRITE(LOU,'('' SYMBOL 9O SIZE 0.1'')')
C>>>
100   CONTINUE
C--
C  That's it.
C--
      STOP
      END
 
      REAL FUNCTION FNCT*8(AMP,AMD)
 
      IMPLICIT   REAL*8 ( A-H, O-Z )
      REAL   *8  AMP, AMD
      REAL   *8  A(0:1)
C
C==================< Entry Point >======================================
C
C--
C  Calculate chi**2.
C--
      CALL GTCHI2(1,EP,AMP,AMD,NP,A,CHI2)
      FNCT = CHI2
CX    PRINT *, AMP, AMD, CHI2
C--
C  That's it.
C--
      RETURN
      END
 
      SUBROUTINE GTCHI2(MODE,EPIN,AMP,AMD,NPOT,A,CHI2)
 
      IMPLICIT   REAL*8 ( A-H, O-Z )
      INTEGER*4  MODE, NPOT
      REAL   *8  EPIN, AMP, AMD, A(0:1), CHI2
C--
      REAL   *8  XYDAT(3,500)
      DATA  LIU  /11/
C
C==================< Entry Point >======================================
C
C--
C  Initialization.
C--
      IF ( MODE.EQ.0 ) THEN
         EP  = EPIN
         FAC = 1
C--
C  Read in data.
C--
         NP  = 0
1        READ(LIU,*,END=2) X, Y, DY
         NP = NP + 1
         XYDAT(1,NP) = X
         XYDAT(2,NP) = Y  *FAC
         XYDAT(3,NP) = DY *FAC
         GO TO 1
C--
2        PRINT *, '>>> GTCHI2 initialization >>>>'
         PRINT *, '  EP = ', EP
         PRINT *, '  # data points = ', NP
         DO 20 IP = 1, NP
            PRINT *, '   ', IP, (XYDAT(K,IP),K=1,3)
20       CONTINUE
         RETURN
      ENDIF
      NPOT = NP
C--
C  Calculate Emin and Emax.
C--
      CALL ELBXTR(EP,AMP,AMD,EMIN,EMAX)
C--
C  Calculate inverse error matrix.
C--
      E11 = 0
      E12 = 0
      E22 = 0
      B1  = 0
      B2  = 0
      NPF = 1
      NPL = NP
      DO 300 IP = 1, NP
         X   = XYDAT(1,IP)
         Y   = XYDAT(2,IP)
         DY2 = XYDAT(3,IP)**2
         IF ( Y.LE.0. )                          GO TO 300
         IF ( X.LT.EMIN ) THEN
            NPF = IP + 1
                                                 GO TO 300
         ENDIF
         IF ( X.GT.EMAX ) THEN
            NPL = IP - 1
                                                 GO TO 350
         ENDIF
         XX  = (X-EMIN)*(EMAX-X)
         XX2 = XX*XX
         E11 = E11 + XX2/DY2
         E12 = E12 + XX2*X/DY2
         E22 = E22 + XX2*X*X/DY2
         B1  = B1  + XX*Y/DY2
         B2  = B2  + XX*X*Y/DY2
300   CONTINUE
350   E21 = E12
      IF ( NPL-NPF.LT.2 ) THEN
         PRINT *, ' >>> Error in GTCHI2 >>>> '
         PRINT *, '    NPF = ', NPF, ' NPL = ', NPL
         PRINT *, '    EP  = ', EP
         PRINT *, '    AMP = ', AMP
         PRINT *, '    AMD = ', AMD
         PRINT *, '    EMN = ', EMIN
         PRINT *, '    EMX = ', EMAX
         CHI2 = (XYDAT(1,1)-EMIN)**2 + (XYDAT(1,NP)-EMAX)**2
         RETURN
      ENDIF
C--
C  Solve for a1 and a2.
C--
      DET  = E11*E22 - E12*E21
      D11  = E22/DET
      D12  =-E21/DET
      D21  = D12
      D22  = E11/DET
      A0   = D11*B1 + D12*B2
      A1   = D21*B1 + D22*B2
C--
      A(0) = A0
      A(1) = A1
C--
C  Calculate chi**2.
C--
      CHI2 = 0
      DO 400 IP = 1, NP
         X   = XYDAT(1,IP)
         Y   = XYDAT(2,IP)
         DY  = XYDAT(3,IP)
         IF ( Y.LE.0. )                          GO TO 400
C>>>
         F = MAX((X-EMIN)*(EMAX-X)*(A0+A1*X),0.)
CX       F = (X-EMIN)*(EMAX-X)*(A0+A1*X)
C>>>
         CHI2 = CHI2 + ((Y-F)/DY)**2
400   CONTINUE
C--
C  That's it.
C--
      RETURN
      END
 
      SUBROUTINE GTCHI2(MODE,EPIN,AMP,AMD,NPOT,A,CHI2)
 
      IMPLICIT   REAL*8 ( A-H, O-Z )
      INTEGER*4  MODE, NPOT
      REAL   *8  EPIN, AMP, AMD, A(0:1), CHI2
C--
      REAL   *8  XYDAT(3,500)
      DATA  LIU  /11/
C
C==================< Entry Point >======================================
C
C--
C  Initialization.
C--
      IF ( MODE.EQ.0 ) THEN
         EP  = EPIN
         FAC = 1
C--
C  Read in data.
C--
         NP  = 0
1        READ(LIU,*,END=2) X, Y, DY
         NP = NP + 1
         XYDAT(1,NP) = X
         XYDAT(2,NP) = Y  *FAC
         XYDAT(3,NP) = DY *FAC
         GO TO 1
C--
2        PRINT *, '>>> GTCHI2 initialization >>>>'
         PRINT *, '  EP = ', EP
         PRINT *, '  # data points = ', NP
         YSUM     = 0
         DO 20 IP = 1, NP
            PRINT *, '   ', IP, (XYDAT(K,IP),K=1,3)
            YSUM = YSUM + XYDAT(2,IP)
20       CONTINUE
         PRINT *, '  Y_sum  = ', YSUM
         DX   = XYDAT(1,2) - XYDAT(1,1)
         C    = YSUM*DX
         RETURN
      ENDIF
      NPOT = NP
C--
C  Calculate Emin and Emax.
C--
      CALL ELBXTR(EP,AMP,AMD,EMIN,EMAX)
C--
C  Calculate inverse error matrix.
C--
      C1  = - (EMAX**2+EMIN**2)*(EMAX-EMIN)*(EMAX+EMIN)/4
     .      + (EMAX+EMIN)**2*(EMAX-EMIN)/3
     .      - EMIN*EMAX*(EMAX-EMIN)*(EMAX+EMIN)/2
      C0  = - (EMAX-EMIN)*(EMAX**2+EMAX*EMIN+EMIN**2)/3
     .      + (EMAX+EMIN)**2*(EMAX-EMIN)/2
     .      - EMIN*EMAX*(EMAX-EMIN)
      D0  = C0/C1
      D   = C/C1
      E1  = 0
      B1  = 0
      DO 300 IP = 1, NP
         X   = XYDAT(1,IP)
         Y   = XYDAT(2,IP)
         DY2 = XYDAT(3,IP)**2
         XX  = (X-EMIN)*(EMAX-X)
         XX2 = XX*XX
         DD  = 1 - D0*X
         DD2  = DD*DD
         E1  = E1  + XX2*DD2/DY2
         B1  = B1  + XX*(Y-XX*D*X)*DD/DY2
300   CONTINUE
C--
C  Solve for a1 and a2.
C--
      A0   = B1/E1
      A1   = -D0*A0 + D
C--
      A(0) = A0
      A(1) = A1
C--
C  Calculate chi**2.
C--
      CHI2 = 0
      DO 400 IP = 1, NP
         X   = XYDAT(1,IP)
         Y   = XYDAT(2,IP)
         DY  = XYDAT(3,IP)
         IF ( Y.LE.0. )                          GO TO 400
C>>>
         F = MAX((X-EMIN)*(EMAX-X)*(A0+A1*X),0.)
CX       F = (X-EMIN)*(EMAX-X)*(A0+A1*X)
C>>>
         CHI2 = CHI2 + ((Y-F)/DY)**2
400   CONTINUE
C--
C  That's it.
C--
      RETURN
      END
 
CC**********************************************************************
C*
C*==============================---------==
C* Subroutine ELBXTR(EP,AMP,AMD,EMIN,EMAX)
C*==============================---------==
C*
C* (Purpose)
C*    Calculate the minimum and maximum of the energy of the
C*    2-body system from the 3-body decay:
C*        P --> D + 1 + 2
C*    where the parent( P ) and the dauter( D ) have fixed masses
C*    while the 2-body system consisting of the massless daughers
C*    ( 1 and 2 ) does not.
C* (Inputs)
C*    EP    :(R*8): the parent E in the lab. frame.
C*    AMP   :(R*8): the parent mass.
C*    AMD   :(R*8): the fixed daughter mass.
C* (Outputs)
C*    EMIN  :(R*8): the minimum E of the (1+2) in the lab. frame.
C*    EMAX  :(R*8): the maximum E of the (1+2) in the lab. frame.
C* (Update Record)
C*    92/06/26  K.Fujii                Original version.
C*
CC**********************************************************************
 
      SUBROUTINE ELBXTR(EP,AMP,AMD,EMIN,EMAX)
 
      IMPLICIT   REAL*8 ( A-H, O-Z )
      REAL*8     EP, AMP, AMD, EMIN, EMAX
C
C==================< Entry Point >======================================
C
C--
C  Calculate beta and gamma.
C--
      GM   = EP/AMP
      BT   = SQRT( (GM-1)*(GM+1) )/GM
      X    = AMD/AMP
      PMX  = (AMP/2)*(1-X)*(1+X)
      EMX  = SQRT( PMX*PMX + AMD*AMD )
C--
C  Calculate Emin.
C--
      EMIN = EP - GM*( EMX + BT*PMX )
C--
C  Calculate Emax.
C--
      TEST = ( 1 + X*X )/2/X
      IF ( GM.LT.TEST ) THEN
         EMAX = EP - AMD
      ELSE
         EMAX = EP - GM*( EMX - BT*PMX )
      ENDIF
C--
C  That's it.
C--
      RETURN
      END
 
CC********************************************************************CC
C*                                                                    *C
C*==========================================================          *C
C* Subroutine UCONTR(FNCT,NCT,CONTUR,XYLIM,XY0,DXY0,LOUNIT)           *C
C*==========================================================          *C
C*                                                                    *C
C* (Purpose)                                                          *C
C*     Produce TOPDRAW data for a contour plot. FNCT is a             *C
C*     external function of R*4 variables (X,Y).                      *C
C* (Inputs)                                                           *C
C*     FNCT       : (R*4) ; a R*4 function of R*4 (X,Y).              *C
C*     NCT        : (I*4) ; # contours to draw.                       *C
C*     CONTUR(I)  : (R*4) ; FNCT value corresponding to I-th contour. *C
C*     XYLIM(1,1) : (R*4) ; X-min --+                                 *C
C*          (2,1) : (R*4) ; X-max   +-- of the window.                *C
C*          (1,2) : (R*4) ; Y-min   !                                 *C
C*          (2,2) : (R*4) ; Y-max --+                                 *C
C*     XY0(1)     : (R*4) ; X --+--- of a point in the window.        *C
C*        (2)     : (R*4) ; Y --+                                     *C
C*     DXY0(1)    : (R*4) ; X-error.                                  *C
C*         (2)    : (R*4) ; Y-error.                                  *C
C*     LOUNIT     : (I*4) ; logical unit number for TDR data.         *C
C* (Output)                                                           *C
C*    TOPDRAW data is output to LOUNIT.                               *C
C* (Relation)                                                         *C
C*    Calls UGRADX.                                                   *C
C* (Update Record)                                                    *C
C*    02/25/90  K.Fujii            Original version.                  *C
C*                                                                    *C
CC********************************************************************CC
 
      SUBROUTINE UCONTR(FNCT,NCT,CONTUR,XYLIM,XY0,DXY0,LOUNIT)
 
      IMPLICIT   REAL*8 ( A-H, O-Z, x )
      INTEGER*4  NCT
      REAL*8     CONTUR(NCT), XYLIM(2,2), XY0(2), DXY0(2)
      REAL*8     SKL(2), XY(2), DXY(2), DF(2)
C
C     EPS for controlling maximum scaled step size.
C     EPSL for convergence check.
C     DFIMN is the minimum d(phi)/d(step).
C     DFIMX is the maximum d(phi)/d(step).
C     STEPMN is the minimum scaled step length.
C
      DATA       EPS    / 5.D-1 /   EPSL  / 5.D-5 /
      DATA       DFIMN  / 1.D-1 /   DFIMX / 5.D-1 /
     .           STEPMN / 2.D-2 /
      DATA       NITCUT / 10 /
      DATA       MXxPNT / 2000 /
      DATA       NCALL  / 0    /
      EXTERNAL   FNCT
C
C========< Entry Point >================================================
C
C--
C  Initialize constants.
C--
      IF ( NCALL.EQ.0 ) THEN
         NCALL = 1
         xPI   = ACOS(-1.E0)
         x2PI  = 2*xPI
      ENDIF
C--
C  Define window of the contour plot.
C--
      XMN    = XYLIM(1,1)
      XMX    = XYLIM(2,1)
      YMN    = XYLIM(1,2)
      YMX    = XYLIM(2,2)
      XSKL   = ABS(XYLIM(2,1)-XYLIM(1,1))
      YSKL   = ABS(XYLIM(2,2)-XYLIM(1,2))
      SKL(1) = XSKL
      SKL(2) = YSKL
C>>> 91/06/01
      STEPMX = SQRT((DXY0(1)/XSKL)**2 + (DXY0(2)/YSKL)**2)
C>>>
C--
C  Start find contours.
C--
      WRITE(LOUNIT,*) 'SET LIMIT X ', XMN, XMX
      WRITE(LOUNIT,*) 'SET LIMIT Y ', YMN, YMX
C--
      DO 5000 ICT = 1, NCT
         NTRTOT = 0
C--
         WRITE(LOUNIT,*) '( ICT =', ICT
         WRITE(LOUNIT,*) 'SET ORDER X Y'
         PRINT *, ' Start drawing ', ICT, '-th contour.'
C--
C  Decide starting point.
C--
         FCT    = CONTUR(ICT)
         XY(1)  = XY0(1)
         XY(2)  = XY0(2)
         DXY(1) = DXY0(1)
         DXY(2) = DXY0(2)
         F0     = FNCT(XY(1),XY(2))
C>>> 91/05/30
C        FTEST  = EPSL*ABS(FCT-F0)
         FTEST  = MAX(EPSL*ABS(FCT-F0),EPSL)
C>>>
         NIT0   = 0
1        CALL UGRADX(FNCT,FCT,FTEST,SKL,XY,DXY,DF,NTRY)
         NTRTOT = NTRTOT + IABS(NTRY)
C--
         IF ( NTRY.LT.0 .OR. XY(1).LT.XMN .OR. XY(1).GT.XMX .OR.
     .        XY(2).LT.YMN .OR. XY(2).GT.YMX ) THEN
            NIT0   = NIT0 + 1
            XY(1)  = XY0(1) + DXY(1)
            XY(2)  = XY0(2) + DXY(2)
            DXY(1) = DXY(1)/2
            DXY(2) = DXY(2)/2
            IF ( NIT0.LT.10 )                    GO TO 1
            PRINT *, ' Failed to get starting point.'
            PRINT *, ' STOP in CONT.'
C           STOP
                                                 GO TO 5000
         ENDIF
         PRINT *, ' NTRY = ', NTRY, ' to get starting point.'
C--
C  Starting point decided. Now decide step size.
C--
         X0     = XY(1)
         Y0     = XY(2)
         DFX    = DF(1)*XSKL
         DFY    = DF(2)*YSKL
         FI0    = MOD(ATAN2(DFY,DFX)+4*x2PI,x2PI)
         STEP0  = EPS*SQRT(((X0-XY0(1))/XSKL)**2
     .                   + ((Y0-XY0(2))/YSKL)**2 )
C>>> 91/05/30
         DFI    = 0
         STEP0  = MAX(STEP0,STEPMN)
C>>>
C--
C  Now trace this contour.
C--
         ITRY  = 0
2        ITRY  = ITRY + 1
C--
C  Recall starting point.
C--
         XY(1) = X0
         XY(2) = Y0
         FI    = FI0
C--
         WRITE(LOUNIT,*) XY(1), XY(2)
C--
C  Looping starts here.
C--
         STEP   = STEP0
         NPNT   = 0
         DELFI  = 0
         NIT1   = 0
         NIT2   = 0
C--
3        NPNT   = NPNT + 1
C--
         XS     = XY(1)
         YS     = XY(2)
         DFXS   = DFX
         DFYS   = DFY
         FIS    = FI
C--
         ADF    = SQRT(DFX**2+DFY**2)
C>>> 91/06/01
C        IF ( ITRY.EQ.1 ) THEN
C          DELX   =-XSKL*STEP*DFY/ADF
C          DELY   = YSKL*STEP*DFX/ADF
C        ELSE
C          DELX   = XSKL*STEP*DFY/ADF
C          DELY   =-YSKL*STEP*DFX/ADF
C        ENDIF
C
         IF ( ITRY.EQ.1 ) THEN
           DELX   =-STEP*DFY/ADF
           DELY   = STEP*DFX/ADF
         ELSE
           DELX   = STEP*DFY/ADF
           DELY   =-STEP*DFX/ADF
         ENDIF
         DELX = DELX - DFIDS*STEP/2*DELY
         DELY = DELY + DFIDS*STEP/2*DELX
         DELX = XSKL*DELX
         DELY = YSKL*DELY
C>>>
         XY(1)  = XY(1) + DELX
         XY(2)  = XY(2) + DELY
C>>> 91/05/30
C        PRINT '(F12.5,4F12.3)', STEP, XY(1), XY(2), DELX, DELY
C>>>
         DXY(1) = DELX
         DXY(2) = DELY
         CALL UGRADX(FNCT,FCT,FTEST,SKL,XY,DXY,DF,NTRY)
         NTRTOT = NTRTOT + IABS(NTRY)
         IF ( IABS(NTRY).GT.10 ) THEN
CX          PRINT *, ' NPNT = ', NPNT, ' NTRY = ', NTRY
         ENDIF
C--
C  Check if this step is reasonalble.
C--
         DFX    = XSKL*DF(1)
         DFY    = YSKL*DF(2)
C>>> 91/05/30
CX       IF ( DFX.LE.1.D-50 .AND. DFY.LE.1.D-50 ) THEN
CX          DFX = DFXS
CX          DFY = DFYS
CX       ENDIF
         ADF    = SQRT(DFX**2+DFY**2)
         IF ( ADF.GT.1.D-50 ) THEN
            FI     = MOD(ATAN2(DFY,DFX)+4*x2PI,x2PI)
         ENDIF
C>>>
         DFI    = MOD(FI-FIS+4*x2PI,x2PI)
         IF ( DFI.GT.xPI ) DFI = DFI - x2PI
C>>> 91/05/30
C        ADFI   = ABS(DFI)
         ADFI   = MAX(ABS(DFI),1.D-50)
         DFIDS  = DFI/STEP
C>>>
C        PRINT *, ' ADFI NTRY NIT1 NIT2 = ', ADFI, NTRY, NIT1, NIT2
C>>>
         IF ( ADFI.GT.DFIMX .OR. NTRY.LT.0 ) THEN
            NIT1  = NIT1 + 1
            IF ( NIT1.GT.NITCUT ) THEN
               IF ( NTRY.LT.0 ) THEN
                  PRINT *, ' BLACK HOLE at NPNT = ', NPNT, ' in CONT.'
                  PRINT *, '    NIT1, NIT2 = ', NIT1, NIT2
                  PRINT *, ' Give up continuing and STOP.'
C>>> 91/05/30
C                 STOP
                  WRITE(LOUNIT,*) 'PLOT'
                  WRITE(LOUNIT,*) 'JOIN'
                  IF ( ITRY.LT.2 )               GO TO 2
                  RETURN
C>>>
               ELSE
                                                 GO TO 4
               ENDIF
            ENDIF
            XY(1) = XS
            XY(2) = YS
            DFX   = DFXS
            DFY   = DFYS
            FI    = FIS
            NPNT  = NPNT - 1
            STEP  = MAX(STEP*MIN(0.3,DFIMX/ADFI),STEPMN)
C>>> 91/06/01
C           PRINT *, ' Reduce STEP = ', STEP
C>>>
                                                 GO TO 3
         ELSE IF ( ADFI.LT.DFIMN .AND. NIT2.LT.NITCUT .AND.
     .             ABS(STEP-STEP0).GT.1.D-20 ) THEN
            NIT2  = NIT2 + 1
            XY(1) = XS
            XY(2) = YS
            DFX   = DFXS
            DFY   = DFYS
            FI    = FIS
            NPNT  = NPNT - 1
C>>> 91/06/01
C           STEP  = MIN(STEP*MAX(3.,DFIMN/ADFI),STEP0)
            STEP  = MIN(STEP*MAX(3.,DFIMN/ADFI),STEPMX)
C           PRINT *, ' Increase STEP = ', STEP
C>>>
                                                 GO TO 3
         ENDIF
C--
C  Point accepted.
C--
4        NIT1 = 0
         NIT2 = 0
C>>> 91/05/30
C        PRINT '(F12.5,4F12.3)', STEP, XY(1), XY(2), XS, YS
C        WRITE(LOUNIT,*) XY(1), XY(2)
         EXMX = ABS(XYLIM(2,1)-XYLIM(1,1))/10
         EYMX = ABS(XYLIM(2,2)-XYLIM(1,2))/10
         IF ( XY(1).GE.XMN-EXMX .AND. XY(1).LE.XMX+EXMX .AND.
     .        XY(2).GE.YMN-EYMX .AND. XY(2).LE.YMX+EYMX .AND.
     .        NTRY.GT.0 ) THEN
            WRITE(LOUNIT,*) XY(1), XY(2)
         ENDIF
C>>>
C--
C  Boundary check.
C--
         IF ( XY(1).LT.XMN .OR. XY(1).GT.XMX .OR.
     .        XY(2).LT.YMN .OR. XY(2).GT.YMX ) THEN
            IF ( ITRY.GE.2 )                     GO TO 40
            WRITE(LOUNIT,*) 'PLOT'
            WRITE(LOUNIT,*) 'JOIN'
                                                 GO TO 2
         ENDIF
C--
C  Check if this loop is completed.
C--
         DELFI  = DELFI + DFI
CX       IF ( ABS(DELFI).GT.x2PI + 1.E-4 )       GO TO 40
         DIST   = SQRT(((XY(1)-X0)/XSKL)**2+((XY(2)-Y0)/YSKL)**2)
         IF ( ABS(DELFI).GT.x2PI + 1.E-4 .AND.
     .        DIST.LT.STEP0 )                    GO TO 40
C--
C  If not, try next point.
C--
         IF ( NPNT.LT.MXxPNT )                   GO TO 3
         PRINT *, ' Step size too small in CONT.'
         PRINT *, ' NPNT = ', NPNT, ' > MXxPNT = ', MXxPNT
C--
C  Contour completed.
C--
40       WRITE(LOUNIT,*) 'PLOT'
         WRITE(LOUNIT,*) 'JOIN'
         PRINT *, ICT, '-th contour completed. NTRTOT = ', NTRTOT
5000  CONTINUE
C--
C  That's it.
C--
      RETURN
      END
 
CC********************************************************************CC
C*                                                                    *C
C*=======================================================             *C
C* Subroutine UGRADX(FNCT,FCT,FTEST,SKL,XY,DXY,DF,NTRY)               *C
C*=======================================================             *C
C*                                                                    *C
C* (Purpose)                                                          *C
C*    UGRADX looks for (X,Y) at which ABS(FNCT(X,Y)-FCT)<FTEST,       *C
C*    moving along the gradient vector from (XY(1),XY(2)).            *C
C*    (DXY(1),DXY(2)) gives initial step size.                        *C
C*    When such (X,Y) is found, the coordinates are saved in          *C
C*    XY, the last step in (DXY), and the gradient vector at          *C
C*    (X,Y) in DF.                                                    *C
C* (Inputs)                                                           *C
C*     FNCT       : (R*4) ; a R*4 function of R*4 (X,Y).              *C
C*     FCT        : (I*4) ; function value on the contour.            *C
C*     FTEST      : (R*4) ; TOLERANCE ON THE FUNCTION VALUE.          *C
C*     SKL(1)     : (R*4) ; X-scale.                                  *C
C*        (2)     : (R*4) ; Y-scale.                                  *C
C*     XY (1)     : (R*4) ; X of the current position.                *C
C*        (2)     : (R*4) ; Y of the current position.                *C
C*     DXY(1)     : (R*4) ; X step.                                   *C
C*        (2)     : (R*4) ; Y step.                                   *C
C* (Outputs)                                                          *C
C*     XY (1)     : (R*4) ; X of the next position.                   *C
C*        (2)     : (R*4) ; Y of the next position.                   *C
C*     DXY(1)     : (R*4) ; accepted X step.                          *C
C*        (2)     : (R*4) ; accepted Y step.                          *C
C*     DF (1)     : (R*4) ; @F/@X at the next position.               *C
C*        (2)     : (R*4) ; @F/@Y at the next position.               *C
C* (Relation)                                                         *C
C*    Calls no subroutines.                                           *C
C* (Update Record)                                                    *C
C*    02/25/90   K.Fujii                 Original version.            *C
C*                                                                    *C
CC********************************************************************CC
 
      SUBROUTINE UGRADX(FNCT,FCT,FTEST,SKL,XY,DXY,DF,NTRY)
 
      IMPLICIT   REAL*8 ( A-H, O-Z, x )
      INTEGER*4  NTRY
      REAL*8     FCT, FTEST, SKL(2), XY(2), DXY(2), DF(2)
C
C     EPS for derivative estimate.
C     DAMP for stabilization of Newton's method.
C     MXxITR is the maximum number of iterations.
C     DELDMX is the maximum step length.
C
      DATA       EPS    / 1.D-1 /  DAMP /1.D-4 /  MXxITR / 100 /
     .           DELDMX / 5.D-2 /
      EXTERNAL   FNCT
C>>>
      DATA NZERO /0/
C>>>
C
C========< Entry Point >================================================
C
C--
C  Initialization.
C--
      X     = XY(1)
      Y     = XY(2)
      DELX  = DXY(1)
      DELY  = DXY(2)
      XS    = X
      YS    = Y
      DELXS = DELX
      DELYS = DELY
      XSKL  = SKL(1)
      YSKL  = SKL(2)
      DTXMN = 1.D-4*ABS(XSKL)
      DTYMN = 1.D-4*ABS(YSKL)
      DTXMX = 1.D-2*ABS(XSKL)
      DTYMX = 1.D-2*ABS(YSKL)
      ADLF  = 1.D20
C--
C  Follow gradient vector to the point where FNCT(X,Y) = FCT.
C--
      NTRY  = 0
      DMP   = DAMP
1     NTRY  = NTRY + 1
      F     = FNCT(X,Y)
      DELF  = FCT - F
      ADLFS = ADLF
      ADLF  = ABS(DELF)
      DTX   = MAX(EPS*ABS(DELX),DTXMN)
      DTY   = MAX(EPS*ABS(DELY),DTYMN)
      DTX   = MIN(DTX,DTXMX)
      DTY   = MIN(DTY,DTYMX)
      DFX   = (FNCT(X+DTX,Y)-F)*XSKL/DTX
      DFY   = (FNCT(X,Y+DTY)-F)*YSKL/DTY
      IF ( ADLF.LE.FTEST )                       GO TO 10
C--
C  Decide next step.
C--
      ADF   = SQRT(DFX**2+DFY**2)
C>>> 91/05/30
      IF ( ADF.LE.1.D-20 ) THEN
         IF ( NZERO.LT.50 ) THEN
            NZERO = NZERO + 1
            PRINT *, ' >>>> ADF ZERO  ADF = ', ADF
         ENDIF
         X    = XS
         Y    = YS
         DELX = DELXS/2
         DELY = DELYS/2
         IF ( NTRY.LT.MXxITR )                   GO TO 1
                                                 GO TO 9
      ENDIF
C>>> 91/06/03
      IF ( ADLF.LT.ADLFS ) THEN
         DMP   = DMP/10
         XS    = X
         YS    = Y
         DELXS = DELX
         DELYS = DELY
C>>>
      ELSE
         DMP = DMP*10
      ENDIF
C>>>
      DELD  = MIN(DELF/ADF/(1+DMP),DELDMX)
      DELX  = DELD*XSKL*DFX/ADF
      DELY  = DELD*YSKL*DFY/ADF
C--
      X     = X + DELX
      Y     = Y + DELY
C--
      IF ( NTRY.LT.MXxITR )                      GO TO 1
9     PRINT *, ' Failed to get crossing point.'
CX    PRINT *, ' NTRY = ', NTRY, ' reached MXxITR in UGRADX.'
CX    PRINT *, '     ADLF = ', ADLF, ' FTEST = ', FTEST
CX    PRINT *, ' Restore XY, DXY.'
      XY(1)  = XS
      XY(2)  = YS
      DXY(1) = DELXS
      DXY(2) = DELYS
      NTRY   = - NTRY
C--
C  Now save (X,Y), (DELX,DELY), and (DFX,DFY)
C--
10    XY(1)  = X
      XY(2)  = Y
      DXY(1) = DELX
      DXY(2) = DELY
      DF(1)  = DFX/XSKL
      DF(2)  = DFY/YSKL
C--
C  That's it.
C--
      RETURN
      END
