 
      SUBROUTINE GTCHI2(MODE,EPIN,AMP,AMD,NPOT,A,CHI2)
 
      IMPLICIT   REAL*8 ( A-H, O-Z )
      INTEGER*4  MODE, NPOT
      REAL   *8  EPIN, AMP, AMD, A(0:1), CHI2
C--
      REAL   *8  XYDAT(3,500)
      DATA  LIU  /11/
C
C==================< Entry Point >======================================
C
C--
C  Initialization.
C--
      IF ( MODE.EQ.0 ) THEN
         EP  = EPIN
         FAC = 1
C--
C  Read in data.
C--
         NP  = 0
1        READ(LIU,*,END=2) X, Y, DY
         NP = NP + 1
         XYDAT(1,NP) = X
         XYDAT(2,NP) = Y  *FAC
         XYDAT(3,NP) = DY *FAC
         GO TO 1
C--
2        PRINT *, '>>> GTCHI2 initialization >>>>'
         PRINT *, '  EP = ', EP
         PRINT *, '  # data points = ', NP
         YSUM     = 0
         DO 20 IP = 1, NP
            PRINT *, '   ', IP, (XYDAT(K,IP),K=1,3)
            YSUM = YSUM + XYDAT(2,IP)
20       CONTINUE
         PRINT *, '  Y_sum  = ', YSUM
         DX   = XYDAT(1,2) - XYDAT(1,1)
         C    = YSUM*DX
         RETURN
      ENDIF
      NPOT = NP
C--
C  Calculate Emin and Emax.
C--
      CALL ELBXTR(EP,AMP,AMD,EMIN,EMAX)
C--
C  Calculate inverse error matrix.
C--
      C1  = - (EMAX**2+EMIN**2)*(EMAX-EMIN)*(EMAX+EMIN)/4
     .      + (EMAX+EMIN)**2*(EMAX-EMIN)/3
     .      - EMIN*EMAX*(EMAX-EMIN)*(EMAX+EMIN)/2
      C0  = - (EMAX-EMIN)*(EMAX**2+EMAX*EMIN+EMIN**2)/3
     .      + (EMAX+EMIN)**2*(EMAX-EMIN)/2
     .      - EMIN*EMAX*(EMAX-EMIN)
      D0  = C0/C1
      D   = C/C1
      E1  = 0
      B1  = 0
      DO 300 IP = 1, NP
         X   = XYDAT(1,IP)
         Y   = XYDAT(2,IP)
         DY2 = XYDAT(3,IP)**2
         XX  = (X-EMIN)*(EMAX-X)
         XX2 = XX*XX
         DD  = 1 - D0*X
         DD2  = DD*DD
         E1  = E1  + XX2*DD2/DY2
         B1  = B1  + XX*(Y-XX*D*X)*DD/DY2
300   CONTINUE
C--
C  Solve for a1 and a2.
C--
      A0   = B1/E1
      A1   = -D0*A0 + D
C--
      A(0) = A0
      A(1) = A1
C--
C  Calculate chi**2.
C--
      CHI2 = 0
      DO 400 IP = 1, NP
         X   = XYDAT(1,IP)
         Y   = XYDAT(2,IP)
         DY  = XYDAT(3,IP)
         IF ( Y.LE.0. )                          GO TO 400
C>>>
         F = MAX((X-EMIN)*(EMAX-X)*(A0+A1*X),0.)
CX       F = (X-EMIN)*(EMAX-X)*(A0+A1*X)
C>>>
         CHI2 = CHI2 + ((Y-F)/DY)**2
400   CONTINUE
C--
C  That's it.
C--
      RETURN
      END
