C*
C*  This routine draws the best fit curve.
C*
      PROGRAM PLTBST

      IMPLICIT    REAL*8 ( A-H, O-Z )
      PARAMETER   ( NA = 1 )
      REAL*8      A(0:NA)
      DATA LOU    /20/
      DATA SG     / 0.17D0 /
      DATA SG0    / 0.01D0 /
      DATA ENSG   / 1.0D0  /
      DATA XSKL   / 0.98D0 /
      DATA DXL    / 2.00D0 /
C--
C  Statement function.
C--
      GL(E,SG) = DERFC(-E/SG/SQRT(2.D0))/2
      GH(E,SG) = DERFC( E/SG/SQRT(2.D0))/2
C
C==================< Entry Point >======================================
C
C--
C  Initialization.
C--
      EP = 125.
C350      EP = 175.
      CALL GTCHI2(0,EP,SG,ENSG,XSKL,DXL,AMP,AMD,NP,A,CHI2)
C--
C  Calculate chi**2.
C--
C      AMP = 96.7
C      AMD = 44.4
C--
      AMP = 96.14
      AMD = 44.17
C250      AMP = 97.8
C250      AMD = 41.6
C350      AMP = 93.5
C350      AMD = 41.5
C--
      CALL GTCHI2(1,EP,SG,ENSG,XSKL,DXL,AMP,AMD,NP,A,CHI2)
      FUNC = CHI2
      PRINT *, ' NP = ', NP, ' CHI2 = ', CHI2
      PRINT *, ' A  = ', A
C--
C  Prepare topdraw data.
C--
      CALL ELBXTR(EP,AMP,AMD,EMIN,EMAX)
      PRINT *, ' EMN EMX = ', EMIN, EMAX
      EMIN = EMIN + DXL
      SGL  = SQRT(SG**2/EMIN + SG0**2)*EMIN
      SGH  = SQRT(SG**2/EMAX + SG0**2)*EMAX
      PRINT *, ' SGL SGH = ', SGL, SGH
      NE   = 50
      EL   = EMIN - 5*SGL
      EH   = EMAX + 5*SGH
      DE   = (EH-EL)/NE
      WRITE(LOU,*) 'SET ORDER X Y'
      DO 30 IE = 0, NE
         E = EL + IE*DE
         F = A(NA)
         DO 3 IA = NA-1, 0, -1
            F = F*E + A(IA)
3        CONTINUE
         F    = F*GL(E-EMIN,SGL)*GH(E-EMAX,SGH)
     .           *(E-EMIN+ENSG*SGL)*(EMAX+ENSG*SGH-E)
         WRITE(LOU,*) E/XSKL, F
30    CONTINUE
      WRITE(LOU,*) 'JOIN'
C--
C  That's it.
C--
      STOP
      END
