C**********************************************************************
C*
C*  For the analysis of Debug track.
C*
C*  A. Miyamoto  20-May-1990  Original version.
C*
C**********************************************************************
C*
C* -----------------
C* Subroutine PRUSER( IDREC, LEVEL, IDEBUG, NRET )
C* -----------------
C*
C*(Function)
C*   Event analysis.
C*
C*(Input)
C*   IDREC ; Record ID.  ( = 1 for event record.)
C*   LEVEL ; Level flag. ( no meaning )
C*   IDEBUG; Debug flag. ( no meaning.)
C*
C*(Output)
C*   NRET  ; Return code. = 0 to output this record.
C*                        =-1 to skip this events.
C*
C*(Author)
C*  A. Miyamoto.  20-May-1990   Original version.
C*
C**********************************************************************
C*
      SUBROUTINE PRUSER( IDREC, LEVEL, IDEBUG, NRET )
C
      COMMON /SSWORK/ NOELM(500), GENTRK(20,500)
C
C------------< Entry Point >-----------------------------------------
C
C -------------------------------------------------------------------
C (1) Some initialization.
C -------------------------------------------------------------------
C
      NRET = -1
      NRET = 0
      IF( IDREC .NE. 1 ) RETURN
      CALL SPBLST(6)
      CALL TBNOEL(1,'Generator:Particle_List',NGEN,GENTRK)
      DO 100 IG = 1, NGEN
        CALL TBGET(1,'Generator:Particle_List',IG,NW,GENTRK(1,IG),
     >             IR )
100   CONTINUE
      CALL PRTTRK('Generator:Particle_List',NGEN,GENTRK)
 
      CALL PRTCMB(6,'Production:CDC;Track_Parameter')
      CALL PRTCMB(6,'Production:EMC;Cluster')
      CALL PRTCMB(6,'Production:HDC;Cluster')
      CALL CLTMAT(-2,IR)
      CALL PRTCMB(6,'Production:Combined_Track')
      PRINT *,' End of PRINT Production:Combined_Track'
      CALL DBGANL(-1, IR)
C
      RETURN
      END
C**********************************************************************
C*
C* -----------------
C* Subroutine DBGANL( NPED, NRET )
C* -----------------
C*
C*(Function)
C*   Histogram Generator data, etc.
C*   For study detector signal
C*(Input)
C*   NPED > 0 for HDEFs
C*        < 0 for HCUM
C*
C*(Output)
C*   NRET  ;
C*
C*
C*(Author)
C*  A. Miyamoto.  26-Jun-1990   Original version.
C*
C**********************************************************************
C*
      SUBROUTINE DBGANL( NPD, NRET )
C
      PARAMETER (LNxPRT=500)
      PARAMETER (LNxLST=20 )
      PARAMETER (MXxBUF=200 )
      COMMON /SSWORK/ NOELM(LNxPRT),
     >  QV(10,100),SPRTRK(20,20),GENTRK(LNxLST, LNxPRT),
     >  CDCTRK(100,LNxPRT), EMCCLS(50,LNxPRT),HDCCLS(50,LNxPRT)
C
      DATA  IPD/0/
C
C------------< Entry Point >-----------------------------------------
C
C
C -------------------------------------------------------------------
C (1) HDEFs
C -------------------------------------------------------------------
C
      IF( NPD .LT. 0 ) GO TO 200
      IPD = NPD
      EB  = 150.
      RS  = 2.*EB
      EBO100 = EB/100.
C
      CALL HDEF1(IPD+ 1,'I*4 ',100,0.,1.,'#CDC@')
      CALL HDEF1(IPD+ 2,'I*4 ',100,0.,1.,'#EMC@')
      CALL HDEF1(IPD+ 3,'I*4 ',100,0.,1.,'#HDC@')
C
      CALL HDEF2(IPD+21,'I*4 ',100,100,0.,-10.,EBO100,0.2,
     >    'G.Mom vs Mom.Res(CDC)@')
      CALL HDEF2(IPD+22,'I*4 ',100,100,0.,-10.,EBO100,0.2,
     >    'G.Mom vs Kap.Res(CDC)*10.^-4@')
      CALL HDEF2(IPD+23,'I*4 ',100,100,-1.,-50.,0.02, 1.,
     >    'G.Ang vs Ang.Res(CDC)(mrad)@')
 
C
      CALL HDEF2(IPD+41,'I*4 ',100,100,0., -0.10,EBO100,0.002,
     >    'G.Mom vs Eng.Res(EMC)@')
      CALL HDEF2(IPD+42,'I*4 ',100,100,0., -1.0,EBO100,0.02,
     >    'G.Mom vs Eng.Res(EMC)*RS(E)@')
      CALL HDEF2(IPD+43,'I*4 ',100,100,-1.,-500.,0.02,10.,
     >    'G.Ang vs Ang.Res(EMC)(mrad)@')
C
      CALL HDEF2(IPD+61,'I*4 ',100,100,0.,-1.0,EBO100,0.02,
     >    'G.Mom vs Eng.Res(HDC)@')
      CALL HDEF2(IPD+62,'I*4 ',100,100,0.,-1.0,EBO100,0.02,
     >    'G.Mom vs Eng.Res(HDC)*RS(E)@')
      CALL HDEF2(IPD+63,'I*4 ',100,100,-1.,-500.,0.02,10.,
     >    'G.Ang vs Ang.Res(HDC)(mrad)@')
 
      NRET = 300
      RETURN
C
C -------------------------------------------------------------------
C (2) Study Spring:Parton_List data.
C -------------------------------------------------------------------
C
200   CONTINUE
      NRET = -1
 
      CALL TBGET(1,'Spring:Parton_List',1,NW,SPRTRK(1,1),IR)
 
      CALL TBNOEL(1,'Production:CDC;Track_Parameter',NCDC,NOELM)
      DO 210 IT = 1, NCDC
        CALL TBGET(1,'Production:CDC;Track_Parameter',
     >               NOELM(IT), NW, CDCTRK(1,IT),IR)
210   CONTINUE
      CALL TBNOEL(1,'Production:EMC;Cluster',NEMC,NOELM)
      DO 230 IT = 1, NEMC
        CALL TBGET(1,'Production:EMC;Cluster',
     >               NOELM(IT), NW, EMCCLS(1,IT),IR)
230   CONTINUE
      CALL TBNOEL(1,'Production:HDC;Cluster',NHDC,NOELM)
      DO 250 IT = 1, NHDC
        CALL TBGET(1,'Production:HDC;Cluster',
     >               NOELM(IT), NW, HDCCLS(1,IT),IR)
250   CONTINUE
C
      CALL HCUM1(IPD+1, FLOAT(NCDC), 1. )
      CALL HCUM1(IPD+2, FLOAT(NEMC), 1. )
      CALL HCUM1(IPD+3, FLOAT(NHDC), 1. )
C
C
C     CALL TBNOEL(1,'Generator:Particle_List',NGEN, NOELM )
C     DO 254 IG = 1, NGEN
C       CALL TBGET(1,'Generator:Particle_List',IG,NW, GENTRK(1,IG),
C    >             IRET )
C254   CONTINUE
C      CALL PRTTRK('Generator:Track',NGEN, GENTRK )
C      CALL SPBLST(6)
      PTGEN  = SQRT(SPRTRK(5,1)**2+SPRTRK(6,1)**2)
      PGEN   = SQRT(SPRTRK(5,1)**2+SPRTRK(6,1)**2+SPRTRK(7,1)**2)
      CSGEN  = SPRTRK(7,1)/PGEN
C     PRINT *,' PGEN, PTGEN =',PGEN,PTGEN
      IF( NCDC.EQ.1 ) THEN
        PTCDC  = SQRT(CDCTRK(1,1)**2+CDCTRK(2,1)**2)
        PCDC   = SQRT(CDCTRK(1,1)**2+CDCTRK(2,1)**2+CDCTRK(3,1)**2)
C        PRINT *,' PTCDC=',PTCDC,' PCDC=',PCDC
C        PRINT *,'CDCTRK=',(CDCTRK(K,1),K=1,4)
C        PRINT *,'SPRTRK=',(SPRTRK(K,1),K=5,8)
        PDIF   = PCDC-PGEN
        DELKAP = (PTCDC-PTGEN)/PTGEN/PTGEN*1.E4
        CALL HCUM2(IPD+21, PGEN, PDIF, 1. )
        CALL HCUM2(IPD+22, PGEN, DELKAP, 1. )
CC      DELCS  = UDOT3(CDCTRK(1,1), SPRTRK(5,1))/PGEN/PCDC
        ANG  = ATAN( (CDCTRK(2,1)*SPRTRK(5,1)-CDCTRK(1,1)*SPRTRK(6,1))/
     >                (CDCTRK(2,1)*SPRTRK(5,1)+CDCTRK(1,1)*SPRTRK(6,1)))
        ANG    = ANG*1.E3
        CALL HCUM2(IPD+23, CSGEN, ANG  , 1. )
C       PRINT *,' PDIF =',PDIF,' DELKAP=',DELKAP,' ANG=',ANG
      ENDIF
C
      IF( NEMC.GT.0 ) THEN
        DO 300 J = 1, 4
          QV(J,1) = 0
          DO 310 IC = 1, NEMC
             QV(J,1) = QV(J,1) + EMCCLS(J,IC)
310       CONTINUE
300     CONTINUE
        PEMC  = SQRT( QV(1,1)**2 + QV(2,1)**2 + QV(3,1)**2 )
        PDIFE = PEMC - PGEN
        DELE  = PDIFE/PGEN
        CALL HCUM2(IPD+41, PGEN, DELE,1. )
        DELRSE= DELE*SQRT(PGEN)
        CALL HCUM2(IPD+42, PGEN, DELRSE,1. )
C       DELCSE= UDOT3(QV(1,1), SPRTRK(5,1))/PGEN/PEMC
C       ANG   = ACOS(DELCSE)*1.E3
        ANG    = ATAN((QV(2,1)*SPRTRK(5,1)-QV(1,1)*SPRTRK(6,1))/
     >                (QV(2,1)*SPRTRK(5,1)+QV(1,1)*SPRTRK(6,1)))
        ANG    = ANG*1.E3
        CALL HCUM2(IPD+43, CSGEN, ANG, 1. )
      ENDIF
 
C
C     PRINT *,' NHDC=',NHDC
      IF( NHDC.GT.0 ) THEN
        DO 320 J = 1, 4
          QV(J,2) = 0
          DO 330 IC = 1, NHDC
             QV(J,2) = QV(J,2) + HDCCLS(J,IC)
330       CONTINUE
320     CONTINUE
        PHDC  = SQRT( QV(1,2)**2 + QV(2,2)**2 + QV(3,2)**2 )
        PDIFH = PHDC - PGEN
        DELE  = PDIFH/PGEN
C       PRINT *,' PHDC=',PHDC,' PDIFH =',PDIFH,' DELE=',DELE
        CALL HCUM2(IPD+61, PGEN, DELE, 1. )
        DELRSE= DELE*SQRT(PGEN)
        CALL HCUM2(IPD+62, PGEN, DELRSE,1. )
CC      DELCSH= UDOT3(QV(1,2), SPRTRK(5,1))/PGEN/PHDC
CC      ANG   = ACOS(DELCSH)*1.E3
        ANG    = ATAN((QV(2,2)*SPRTRK(5,1)-QV(1,2)*SPRTRK(6,1))/
     >                (QV(2,2)*SPRTRK(5,1)+QV(1,2)*SPRTRK(6,1)))
        ANG    = ANG*1.E3
        CALL HCUM2(IPD+63, CSGEN, ANG, 1. )
      ENDIF
C     PRINT  *,' End of DBGANL '
 
      RETURN
      END
C**********************************************************************
C*
C* -----------------
C* Subroutine PRTTRK(NUMTRK, GENTRK )
C* -----------------
C*(Function)
C*   Print Informations in Generator:Particle_List
C*
C*(Author)
C*  A. Miyamoto.  20-May-1990   Original version.
C*
C**********************************************************************
 
      SUBROUTINE PRTTRK(COMENT, NUMTRK, GENTRK )
      CHARACTER*(*) COMENT
      DIMENSION GENTRK(20,NUMTRK)
      DATA  LU/6/
C
C======< Entry Point >==================================================
C
      WRITE(LU,200) COMENT, NUMTRK
200   FORMAT(1H ,A,I4,' tracks',/,
     >' Ser#  PID     Mass Chg        Px        Py        Pz  ',
     >'      E         PT    Costh #Dau 1Dau Par  Hel. Col.')
C
      DO 300 I = 1, NUMTRK
        COSTH = GENTRK(7,I)/SQRT(GENTRK(5,I)**2+GENTRK(6,I)**2+
     >                           GENTRK(7,I)**2)
        PT    = SQRT(GENTRK(5,I)**2+GENTRK(6,I)**2)
        WRITE(LU,320) (GENTRK(K,I),K=1,8),
     >                 PT, COSTH,
     >                (GENTRK(K2,I),K2=12,14),
     >                (GENTRK(K3,I),K3=17,19)
320     FORMAT(1X,F4.0,F6.0,F8.3,F4.0,6F10.4,6F4.0)
300   CONTINUE
      RETURN
      END
C**********************************************************************
C*
C* -----------------
C* Subroutine PRURIN( LEVEL, IDEBUG )
C* -----------------
C*
C*(Function)
C*   Run initialization
C*
C*(Author)
C*  A. Miyamoto.  20-May-1990   Original version.
C*
C**********************************************************************
C*
      SUBROUTINE PRURIN( LEVEL, IDEBUG )
C
C
C------------< Entry Point >-----------------------------------------
C
      CALL PRDIS( 1 )
      CALL CLTMAT(-1, IR)
C
      RETURN
      END
C**********************************************************************
C*
C* -----------------
C* Subroutine PRUJIN
C* -----------------
C*
C*(Function)
C*   Job initialization.  Clear counter.
C*
C*(Author)
C*  A. Miyamoto.  20-May-1990   Original version.
C*
C**********************************************************************
C*
      SUBROUTINE PRUJIN
C
C
      PARAMETER  (MHxSIZ=400 000 )
      COMMON /HCOM/ M(MHxSIZ)
C
C------------< Entry Point >-----------------------------------------
C
C
C--
C  Initialize plot buffer.
C--
      CALL HINIT(MHxSIZ)
C--
C  Choose appropriate options.
C--
      CALL DOPT('NCALLS',.TRUE.)
      CALL DOPT('L2ZAUT',.TRUE.)
      CALL DOPT('L2COL',2)
      CALL DOPT('YZERO',.TRUE.)
      CALL HOPTN('STAT',.TRUE.)
      CALL PRDIS( -1 )
C--
C  Initialize hists and plots.
C--
C
      IPD = 0
      CALL DBGANL( IPD, NUMHST )
      IPD = NUMHST
      CALL CLTMAT(IPD, NUMHST  )
C
C
      RETURN
      END
C**********************************************************************
C*
C* -----------------
C* Subroutine PRUJTM
C* -----------------
C*
C*(Function)
C*   Job termination; Output histogram
C*
C*(Author)
C*  A. Miyamoto.  20-May-1990   Original version.
C*
C**********************************************************************
C*
      SUBROUTINE PRUJTM
C
      CHARACTER*44  DISFIL
      CHARACTER*44  TEMPNM
      COMMON /IOFILE/ DISFIL
 
C
C------------< Entry Point >-----------------------------------------
C
C ... Output Histogram; file is allocated dynamically.
C
      DO 100 I = 1, 80
        IF(DISFIL(I:I).NE.' ') THEN
          TEMPNM = DISFIL(I:)
          GO TO 150
        ENDIF
100   CONTINUE
      PRINT *,'Dis file not specified... Writeen to temp file.'
      TEMPNM = 'TAYM.@.DIS.TEMP'
150   CONTINUE
      ILDIS = INDEX(TEMPNM,' ') - 1
C
      CALL UALCPS( 20, TEMPNM(:ILDIS), 'RENEW', 'VBS', 10, IRET )
      CALL HWRITE('ALL',20)
      PRINT *,'Complete HWRITE to a file ',TEMPNM(:ILDIS)
C
      RETURN
      END
CC********************************************************************CC
C*                                                                    *C
C*====================                                                *C
C* Subroutine PRUCOM                                                  *C
C*====================                                                *C
C*                                                                    *C
C*(Function)                                                          *C
C*   Reads HWRITE file name.                                          *C
C*(Author)                                                            *C
 
C*                                                                    *C
CC********************************************************************CC
C
C ==========================
      SUBROUTINE PRUCOM
C ==========================
C
      CHARACTER*72 INPUT
      CHARACTER*44  DISFIL
      COMMON /IOFILE/ DISFIL
C
      DISFIL = '?'
      INPUT = ' '
      CALL TITRD('DIS file :',INPUT  )
      DISFIL = INPUT
 
      INPUT = ' '
      CALL TITRD('EXIT ?:', INPUT )
C
      RETURN
      END
