 
      SUBROUTINE SGSSM(GAL,GAX,GZL,GZX,AMZ,GMZ,
     .                 AMX, POLE, RS, CSTH, PHI, SG)
 
      IMPLICIT   REAL*4  ( A-H, O-Z )
      REAL   *4  GAL(2), GAX, GZL(2), GZX,
     .           AMZ, GMZ, AMX(2)
      REAL   *4  POLE, RS, CSTH, PHI, SG
C--
      INTEGER*4  IHEL(2,2)
      DATA IHEL  / -1, +1,
     .             +1, -1 /
      REAL   *4  PV(0:3,4)
      DATA NCALL / 0 /
C--
C  Statement function.
C--
      BETA(X1,X2) = SQRT( 1 - 2*(X1+X2) + (X1-X2)**2 )
C
C========< Entry Point >================================================
C
C--
C  Constants.
C--
      IF ( NCALL.EQ.0 ) THEN
         NCALL  = 1
         NHL    = 2
         SPIN   = NHL
         NB     = 1
         xGV2PB = 3.893796623D8
         xPI    = ACOS(-1.D0)
         x2PI   = 2*xPI
         x4PI   = 2*x2PI
         FACT   = xGV2PB*x2PI/(x4PI**(3*NB))/SPIN
         AME    = 0.511E-3
      ENDIF
C--
C  Set 4-momenta.
C--
      CALL UVZERO(16,PV)
C
C-- e+ + e- --> CM.
C
      S       = RS*RS
      EBM     = RS/2
      PBM     = SQRT((EBM-AME)*(EBM+AME))
      BT0     = PBM/EBM
      PV(0,1) = EBM
      PV(3,1) = PBM
      CALL PMIRRx(PV(0,1),PV(0,2))
C
C-- CM --> X- + X+.
C
      BT1 = BETA(AMX(1)**2/S,AMX(2)**2/S)
      PX  = EBM*BT1
      EX1 = SQRT(AMX(1)**2+PX**2)
      EX2 = SQRT(AMX(2)**2+PX**2)
      CALL MOMNTx(EX1,AMX(1), CSTH,PHI,PV(0,3))
      CALL PMIRRx(PV(0,3),PV(0,4))
      PV(0,4) = EX2
C--
C  Calculate phase space weight.
C--
      WAT = FACT*BT1/(2*S*BT0)
C--
C  Calculate amplitude squared.
C--
      CALL TTASSM(GAL,GAX,GZL,GZX,AMZ,GMZ,IHEL(1,1), PV, SGL)
      CALL TTASSM(GAL,GAX,GZL,GZX,AMZ,GMZ,IHEL(1,2), PV, SGR)
C--
C  Differenctial cross section.
C--
      PL   = (1-POLE)/2
      PR   = (1+POLE)/2
      SG = (PL*SGL+PR*SGR)*WAT
C--
C  That's it.
C--
      RETURN
      END
