C* (Update Record)
C*   95/03/21  K.Fujii		Modified for BASES V5.1 in FULL.
C*   95/04/04  K.Fujii		Added ISRB flag.
C*

      SUBROUTINE USERIN
 
      IMPLICIT REAL*8 (A-H,O-Z)
C--
      PARAMETER (MXDIM = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,IG(MXDIM),NCALL
      COMMON /BPARM2/ ACC1,ACC2,ITMX1,ITMX2
C--
      INCLUDE 'XCXCCN.inc'
      INCLUDE 'USRPRM.inc'
=EXPAND 'gen_lib/ss/USSPRM.inc'
=EXPAND 'gen_lib/sm/USMPRM.inc'
=EXPAND 'gen_lib/sm/BEMCNS.inc'
=EXPAND 'BASESV51/BSHUFL.inc'
=EXPAND 'BASESV51/BSITPR.inc'
C--
C  Local R*4 variables used in subroutine calls.
C--
      REAL*4        ALF
C
C========< Entry Point >================================================
C
C--
C  Check if inputs from FT05 are consistent with those used in the
C  integration step, when NGETBS = 1. Otherwise, Write the inputs 
C  to 'BASES:Inputs'.
C--
      CALL SPPARM
C--
C  Initialize numerical constants and particle table.
C--
      ALF   = 1/ALFI
      CALL INSMCN(ALF,ALFS,AMSW,AMSZ,AMSH,AMST)
      CALL INSSCN(ALF,ALFS,AMSW,AMSZ,AM0,AMU,AM2,TANB,AMA)
C--
      IF ( GAMSW1.GT.0.0 ) THEN
         CALL MODGAM('SW',1,GAMSW1)
      ENDIF
C--
C  Set user constants.
C--
      ROOTS  = SQRTS
      SGEBM  = SGMEBM
      POLE   = POLEBM
      ISRBM  = ISRB
      PRINT *, ' ******< Job constants >*********** '
      PRINT *, '  '
      PRINT *, '     ROOTS  = ', ROOTS
      PRINT *, '     SGEBM  = ', SGEBM
      PRINT *, '     POLE   = ', POLE
      PRINT *, '     GAMSW1 = ', GAMSW1
      PRINT *, '     ISRBM  = ', ISRBM
      PRINT *, '  '
      PRINT *, ' ********************************** '
C--
C  Set BASES constants.
C--
      IF ( ISRBM.EQ.1 ) THEN
         NDIM   = 17
         NWILD  = 7
         IOFF   = 3
      ELSE IF ( ISRBM.EQ.2 ) THEN
         NDIM   = 18
         NWILD  = 8
         IOFF   = 2
      ELSE IF ( ISRBM.EQ.3 ) THEN
         NDIM   = 22
         NWILD  = 10
         IOFF   = 0
      ELSE
         PRINT *, ' >>> USERIN : Invalid ISRBM = ', ISRBM
         PRINT *, '   Will STOP immediately. '
         STOP
      ENDIF
C>>>
C      NOIG = NWILD + 1
      NOIG = 999
C>>>
C--
      NZZ = NDIM
C--
      NCALL  = NCAL
      ITMX1  = ITM1
      ITMX2  = ITM2    
C--
C  Set lower and upper limits.
C--
      DO 100 IX = 1, NDIM
         XL(IX) = 0
         XU(IX) = 1
         IF ( IX.GE.NOIG ) IG(IX) = 0
         ISHUFL(IX) = IX + IOFF
100   CONTINUE
C--
C  Define hists. and plots.
C--
      PTMX = ROOTS/2
      QMX  = ROOTS/2
      CALL XHINIT( 1, -1.0D0, 1.0D0, 50,'cos(theta_X-)      ')
      CALL XHINIT( 2,  0.0D0,360.D0, 50,'phi_X-             ')
      CALL XHINIT( 3, -1.0D0, 1.0D0, 50,'cos(theta_a+)      ')
      CALL XHINIT( 4,  0.0D0,360.D0, 50,'phi_b+             ')
      CALL XHINIT( 5, -1.0D0, 1.0D0, 50,'cos(theta_a-)      ')
      CALL XHINIT( 6,  0.0D0,360.D0, 50,'phi_a-             ')
      CALL XHINIT( 7,  0.0D0,   QMX, 50,'M_ab+              ')
      CALL XHINIT( 8,  0.0D0,   QMX, 50,'M_ac+              ')
      CALL XHINIT( 9,  0.0D0,  PTMX, 50,'Missing PT         ')
      CALL XHINIT(10,  0.0D0,180.D0, 50,'Acop               ')
      CALL XHINIT(11,  0.0D0,   QMX, 50,'M_ab-              ')
      CALL XHINIT(12,  0.0D0,   QMX, 50,'M_ac-              ')
      CALL XHINIT(13,  1.0D0, 33.D0, 32,'Hel. comb.         ')
      CALL XHINIT(14,  0.0D0,   QMX, 50,'E_e/mu             ')
      CALL XHINIT(15, -1.0D0, 1.0D0, 50,'cos(theta_l-)      ')
      CALL XHINIT(16,  0.0D0,   QMX, 50,'E_qqbar            ')
      CALL XHINIT(17, -1.0D0, 1.0D0, 50,'cos(theta_J-)      ')
      CALL XHINIT(18,  1.0D0,  4.D0,  3,'Topology (LL,LJ,JJ)')
      CALL XHINIT(19,  1.0D0, 13.D0, 12,'Decay mode( X+ )   ')
      CALL XHINIT(20,  1.0D0, 13.D0, 12,'Decay mode( X- )   ')
      CALL XHINIT(21,   .0D0,  1.D0, 50,'sqrt(rs)/sqrt(root)')
      CALL XHINIT(23, -1.0D0, 1.0D0, 50,'cos(theta_fdbar)   ')
      CALL XHINIT(24, -1.0D0, 1.0D0, 50,'cos(theta_fd)      ')
      CALL XHINIT(25,  0.0D0,   QMX, 50,'M_X+               ')
      CALL XHINIT(26,  0.0D0,   QMX, 50,'M_X-               ')
      CALL XHINIT(27, -1.0D0, 1.0D0, 50,'cos(theta_l+)_35   ')
      CALL XHINIT(28, -1.0D0, 1.0D0, 50,'cos(theta_l-)_68   ')
C--
C  That's it.
C--
      RETURN
      END
