C* (Update Record)
C*   92/06/09  K.Fujii	FUNC for e+ e- --> X+ X- full amplitudes.
C*   95/03/21  K.Fujii	REAL*4 --> REAL*8 for
C*				Q*MN, Q#MX, TH*MN, TH*MX, TH*
C*			with * = 3, 4.
C*  			QED vtx correction ( 1+3*BTE/4 ) and
C*                      ( 1 + 2*ALF0/PI * ( PI**2/6 - 1/4 ) )
C*                      included.
C*   95/04/04  K.Fujii	Added an option to shuffle integration
C*			variables.
C*   95/04/06  K.Fujii	Changed integration variables.
C*   96/02/16  K.Fujii  LSP=snu version.
C*

      REAL FUNCTION FUNC*8(ZZ)
 
      IMPLICIT REAL*4 ( A-H, O-Z )
      REAL*8   ZZ(50), Z(50)
=EXPAND 'gen_lib/sm/SMPTAB.inc'
=EXPAND 'gen_lib/ss/SSPTAB.inc'
      INCLUDE 'XCXCCN.inc'
=EXPAND 'gen_lib/sm/SMCONS.inc'
=EXPAND 'BASESV51/BSHUFL.inc'
C--
      PARAMETER  ( NP = 6 )
      REAL   *4   SG, PV(0:3,NP), QV(0:3,10)
      REAL   *8   Q3MN, Q3MX, TH3MN, TH3MX, TH3, Q32, Q3,
     .		  Q4MN, Q4MX, TH4MN, TH4MX, TH4, Q42, Q4, WAT
      INTEGER*4   IHEL(NP,2)
      DATA        ((IHEL(I,J),I=1,NP),J=1,2)/
     .                   -1,+1,    0,+1,    0,-1,
     .                   +1,-1,    0,+1,    0,-1/
C--
      DATA GMSWMN / 5.E-3 /
C
C========< Entry Point >================================================
C
C--
C  Set some variables.
C--
      IF ( NCALL.EQ.0 ) THEN
         NCALL  = 1
C--
	 IF ( GMSW(1).LT.GMSWMN ) THEN
	    FWIDTH  = (GMSWMN/GMSW(1))**2
	    GMSW(1) = GMSWMN
	 ELSE
	    FWIDTH  = 1
	 ENDIF         
C--
         AMXM   = SWM(1)
         GMXM   = GMSW(1)
         AMGXM  = AMXM*GMXM
         AMXM2  = AMXM*AMXM
         AMGXM2 = AMGXM*AMGXM
C--
         AMXP   = SWM(1)
         GMXP   = GMSW(1)
         AMGXP  = AMXP*GMXP
         AMXP2  = AMXP*AMXP
         AMGXP2 = AMGXP*AMGXP
C--
         AME   = AMF(1,2,1)
         xALF0 = 1/137.0359895E0
      ENDIF
C--
C  Shuffle integration variables.
C--
      DO 100 I = 1, NZZ
         Z(ISHUFL(I)) = ZZ(I)
100   CONTINUE 
C--
C  Set independent variables.
C     Z( 1) : e- beam
C      ( 2) : e+ beam
C      ( 3) : bremsstrahlng
C      ( 4) : e- helicity
C      ( 5) : m(X+)**2
C      ( 6) : m(X-)**2
C      ( 7) : cos(theta_X-)
C      ( 8) : phi_X-
C      ( 9) : cos(theta_l+)    in X+ rest frame
C      (10) : phi_l+           in X+ rest frame
C      (11) : cos(theta_l-)    in X- rest frame
C      (12) : phi_l-           in X- rest frame
C      (13) : X+ decay mode
C      (14) : X- decay mode
C      (15) : e- beam energy spread
C      (16) : e+ beam energy spread
C--
C  Reset event weight.
C--
      WAT = 1
C--
C  Beam energy.
C--
      BMENGY(0) = ROOTS/2
      BMENGY(1) = BMENGY(0)
      BMENGY(2) = BMENGY(0)
      BMENGY(3) = BMENGY(0)
      BMENGY(4) = BMENGY(0)
      DPDEBM    = 1
      RS        = ROOTS
      EMBM      = RS/2
      EPBM      = RS/2
      QED       = 1
C--
C  First decide e- and e+ energy.
C--
      IF ( ISRBM.EQ.3 ) THEN
         EBM = ROOTS/2
         CALL PROBEB(REAL(Z(15)),REAL(Z(1)),EBM,EMBM,EMBM0,PEM)
         CALL PROBEB(REAL(Z(16)),REAL(Z(2)),EBM,EPBM,EPBM0,PEP)
         RS  = 2*SQRT(EMBM*EPBM)
         IF ( RS.LT.5. ) THEN
            FUNC = 0
            RETURN
         ENDIF
         BMENGY(0) = EBM
         BMENGY(1) = EMBM0
         BMENGY(2) = EPBM0
         BMENGY(3) = EMBM
         BMENGY(4) = EPBM
         DPDEBM    = PEM*PEP
      ENDIF
C--
C  Then decide reduced sqrt(s) after bremsstrahlung.
C--
      IF ( ISRBM.GE.2 ) THEN
         BTE = (2*xALF0/xPI)*(2*LOG(RS/AME)-1)
         QED = ( 1 + 3*BTE/4 )*( 1 + 2*xALF0/xPI*( xPI**2/6 - 1/4.D0 ) )
         ZG  = Z(3)**(1/BTE)
         RS  = SQRT(1-ZG)*RS
         IZE = Z(16)*1.E4
         IF ( MOD(IZE,2).EQ.0 ) THEN
            EMBM = (1-ZG)*EMBM
         ELSE
            EPBM = (1-ZG)*EPBM
         ENDIF
      ENDIF
C--      
      S      = RS*RS
C--
C  First set initial states.
C--
      IDPTCL(1, 1) = 1
      IDPTCL(2, 1) = 2
      IDPTCL(3, 1) = 1
      IDPTCL(1, 2) = 1
      IDPTCL(2, 2) = 2
      IDPTCL(3, 2) = 1
C--
C  Then select final states.
C--
C-- l+ from X+.
      IMD = 3*Z(13) + 1
      IMD = MIN(IMD,3)
C--
      IDPTCL(1, 4) = IMD
      IDPTCL(2, 4) = 2
      IDPTCL(3, 4) = 1
      IMD1         = IMD
      WAT	   = WAT*3
C-- l- from X-.
      IMD = 3*Z(14) + 1
      IMD = MIN(IMD,3)
C--
      IDPTCL(1, 6) = IMD
      IDPTCL(2, 6) = 2
      IDPTCL(3, 6) = 1
      IMD2         = IMD
      WAT	   = WAT*3
C--
C  Select helicity combination.
C--
      HLM   = (1-POLE)/2
      IF ( Z(4).LT.HLM ) THEN
         ICMB = 1
      ELSE
         ICMB = 2
      ENDIF
      CALL UVCOPY(NP,IHEL(1,ICMB),IHLCMB(1))
C--
C  Set invariant masses squared.
C--
      AM3   = SFM(1)
      AM4   = AMF(IDPTCL(1,4),IDPTCL(2,4),IDPTCL(3,4))
      AM5   = SFM(1)
      AM6   = AMF(IDPTCL(1,6),IDPTCL(2,6),IDPTCL(3,6))
C-- X-.
      Q3MN  = AM3 + AM4
      Q3MX  = RS - (AM5+AM6)
      TH3MN = ATAN((Q3MN-AMXM)*(Q3MN+AMXM)/AMGXM)
      TH3MX = ATAN((Q3MX-AMXM)*(Q3MX+AMXM)/AMGXM)
      TH3   = TH3MN + (TH3MX-TH3MN)*Z(5)
      Q32   = AMGXM*TAN(TH3) + AMXM2
      Q3    = SQRT(Q32)
      WAT   = WAT*(TH3MX-TH3MN)*( (Q32-AMXM2)**2 + AMGXM2 )/AMGXM
C-- X+.
      Q4MN  = AM5 + AM6
      Q4MX  = RS - Q3
      TH4MN = ATAN((Q4MN-AMXP)*(Q4MN+AMXP)/AMGXP)
      TH4MX = ATAN((Q4MX-AMXP)*(Q4MX+AMXP)/AMGXP)
      TH4   = TH4MN + (TH4MX-TH4MN)*Z(6)
      Q42   = AMGXP*TAN(TH4) + AMXP2
      Q4    = SQRT(Q42)
      WAT   = WAT*(TH4MX-TH4MN)*( (Q42-AMXP2)**2 + AMGXP2 )/AMGXP
C--
      XPHASE(1,1) = RS*RS
      XPHASE(1,2) = Q32
      XPHASE(1,3) = Q42
C--
C  Angular variables.
C--
      DO 400 IB = 1, 3
         XPHASE(2,IB) = -1 + 2*Z(2*IB+5)
         XPHASE(3,IB) = x2PI  *Z(2*IB+6)
         WAT = WAT*2*x2PI
400   CONTINUE
C--
C  Calculate differential cross sections.
C--
      CALL SGCXXF(IDPTCL,IHLCMB,XPHASE,SG,PV)
      SG     = SG*QED*FWIDTH
      FUNC   = SG*WAT
      DSGMDX = SG
C--      
      IF ( FUNC.LE.0.D0 ) RETURN
C--
C  Boost everything to laboratroy frame.
C--
      QV(0,1) = EMBM + EPBM
      QV(1,1) = 0
      QV(2,1) = 0
      QV(3,1) = EMBM - EPBM
      IF ( ABS(QV(3,1)).GT.1.E-3 ) THEN
         DO 500 IP = 1, NP
            CALL BOOSTx(PV(0,IP),QV(0,1),PVOUT(0,IP))
500      CONTINUE
      ELSE
         CALL UVCOPY(4*NP,PV(0,1),PVOUT(0,1))
      ENDIF
C--
C  Fill hists. and plots.
C--
      CALL UVCOPY(4*NP,PVOUT(0,1),PV(0,1))
C--
      ELM   = PV(0,4)
      ELP   = PV(0,6)
      CALL PSUMxx(PV(0,3),PV(0,5),QV(0,1))
      PTOP  = SQRT( QV(1,1)**2 + QV(2,1)**2 )
      COSLM =  PV(3,4)/UABSV3(PV(1,4))
      COSLP = -PV(3,6)/UABSV3(PV(1,6))
      COSLA = (COSLM+COSLP)/2
      PT4   = MAX(SQRT( PV(1,4)**2 + PV(2,4)**2 ),.1)
      PT6   = MAX(SQRT( PV(1,6)**2 + PV(2,6)**2 ),.1)
      ACOP  = ( PV(1,4)*PV(1,6) + PV(2,4)*PV(2,6) )/PT4/PT6
      IF ( ABS(ACOP).GT.1. ) ACOP = SIGN(1.,ACOP)
      ACOP  = xPI - ACOS(ACOP)
      COSSE = XPHASE(2,1)
      PHISE = XPHASE(3,1)
      COSEM = XPHASE(2,2)
      PHIEM = XPHASE(3,2)
      COSEP = XPHASE(2,3)
      PHIEP = XPHASE(3,3)
      CALL XHFILL(  1, DBLE(COSSE)       ,FUNC )
      CALL XHFILL(  2, DBLE(PHISE)*xRD2DG,FUNC )
      CALL XHFILL(  3, DBLE(COSEM)       ,FUNC )
      CALL XHFILL(  4, DBLE(PHIEM)*xRD2DG,FUNC )
      CALL XHFILL(  5, DBLE(COSEP)       ,FUNC )
      CALL XHFILL(  6, DBLE(PHIEP)*xRD2DG,FUNC )
      CALL XHFILL(  7, DBLE(SQRT(Q32))   ,FUNC )
      CALL XHFILL(  8, DBLE(SQRT(Q42))   ,FUNC )
      CALL XHFILL(  9, DBLE(PTOP)        ,FUNC )
      CALL XHFILL( 10, DBLE(ACOP)*xRD2DG ,FUNC )
      CALL XHFILL( 11, DBLE(ELM)         ,FUNC )
      CALL XHFILL( 12, DBLE(ELP)         ,FUNC )
      CALL XHFILL( 13, DBLE(COSLM)       ,FUNC )
      CALL XHFILL( 14, DBLE(COSLP)       ,FUNC )
      CALL XHFILL( 15, DBLE(COSLA)       ,FUNC )
      CALL XHFILL( 16, DBLE(IMD1+.1)     ,FUNC )
      CALL XHFILL( 17, DBLE(IMD2+.1)     ,FUNC )
C--
C  That's it.
C--
      RETURN
      END
