CC********************************************************************CC
C*                                                                    *C
C*=================                                                   *C
C* Subroutine FLANLI                                                  *C
C*=================                                                   *C
C*    Example for SPRING + Hadronize                                  *C
C*                                                                    *C
C*(Purpose)                                                           *C
C*    Define analysis program.                                        *C
C*(Relation)                                                          *C
C*    Called by PRMAIN.                                               *C
C*(Author)                                                            *C
C*   17-May-1990  A. Miyamoto  For Full system                        *C
C*                                                                    *C
CC********************************************************************CC
C
      SUBROUTINE FLANLI
C
=EXPAND 'T#PR.FULL.FORT/fldscr.inc'
C     INCLUDE (@FLDSCR)
C
C
C======< ENTRY POINT >==================================================
C
C ----------------------------------------------------------------------
C (1) Declare version number of Full module.
C ----------------------------------------------------------------------
C
      CALL PRPDSC( 'Z-Z-gamma', 101, 900528)
C
C ----------------------------------------------------------------------
C (2) Reset counters.
C ----------------------------------------------------------------------
C
      NPROG = 0
      NENTR = 0
      NHIST = 0
C
C ----------------------------------------------------------------------
C (3) Define analysis routine and calling sequence.
C ----------------------------------------------------------------------
C
C                     Define SPRING generator.
CSPRG       CALL DSSPRG
C                     Define Lund Hadronizer.
CLHAD       CALL DSLHAD
C                     Define Swimmer  routine.
CSWIM       CALL DSCSWM
C                     Define Smearing routine.
CSMEAR       CALL DSCSMR
C                     Define recover routine
CRCV         CALL DSRCOV
C                     Define User routine.
CUSER       CALL DSCUSR
C                     Define squeez routine.
CSQZ         CALL DSSQUZ
 
      RETURN
      END
