C***********************************************************************
C*
C*====================
C* Subroutine PRUJIN
C*====================
C*
C* (Function)
C*    Job initialization for user analysis.
C* (Input & Output )
C*    none.
C* (Relation)
C*    Called from FLANLI
C* (Update Record)
C*    5/29/87  K.Fujii             Original version.
C*
C***********************************************************************
 
      SUBROUTINE PRUJIN
 
      PARAMETER     ( MXxHPK = 280000 )
      COMMON /HCOM/ M(MXxHPK)
C
      COMMON /PRUCUT/ CUTPT, CUTEVS, EVISPL, ENGVET, THTVET
 
C========< Entry Point >================================================
 
C
C--
C  Write user production version #.
C--
      CALL PRPVRS( 'USER:', 001, 900423)
C--
C  Initialize plot buffer.
C--
      CALL HINIT(MXxHPK)
C--
C  Choose appropriate options.
C--
      CALL DOPT('NCALLS',.TRUE.)
      CALL DOPT('L2ZAUT',.TRUE.)
      CALL DOPT('L2COL',2)
C     CALL DOPT('L2COL',1)
C     CALL DOPT('L2SYM',16)
      CALL DOPT('YZERO',.TRUE.)
      CALL HOPTN('STAT',.TRUE.)
      CALL HOPTN('HOMIT',.TRUE.)
C--
C  Initialize hists and plots.
C--
      CALL HDEF1(  1,'I*4', 20,  0.,1.0     ,  'Cut statistics      @')
      CALL HDEF1(  2,'I*4',100,  0.,2.0     ,  '# all tracks        @')
      CALL HDEF1(  3,'I*4',100,  0.,1.0     ,  '# charged tracks    @')
      CALL HDEF1(  4,'I*4',100,  0.,1.0     ,  '# EM clusters       @')
      CALL HDEF1(  5,'I*4',100,  0.,1.0     ,  '# HD clusters       @')
      CALL HDEF1(  6,'I*4',100,  0.,1.0     ,  '# combinations      @')
      CALL HDEF1(  7,'I*4',150,240.,5.0     ,  'm(t-t_bar) w/cuts   @')
      CALL HDEF1(  8,'I*4',100,  0.,2.0     ,  'Pt                  @')
      CALL HDEF1(  9,'I*4', 50,  0.,1.0     ,  'NTRY(y_cut)         @')
CCC   CALL HDEF1( 10,'I*4',100,  0.,4.E-5   ,  'y_cut(6-jet)        @')
      CALL HDEF1( 10,'I*4',200,  0.,8.E-5   ,  'y_cut(6-jet)        @')
      CALL HDEF1( 11,'I*4',100,  0.,1.0     ,  '# tt combinations   @')
C     CALL HDEF1( 12,'EFF', 30,  1.,1.0     ,  ' 2-jet fracton      @')
C     CALL HDEF1( 13,'EFF', 30,  1.,1.0     ,  ' 3-jet fracton      @')
C     CALL HDEF1( 14,'EFF', 30,  1.,1.0     ,  ' 4-jet fracton      @')
      CALL HDEF1( 15,'EFF', 30,  1.,1.0     ,  ' 5-jet fracton      @')
      CALL HDEF1( 16,'EFF', 30,  1.,1.0     ,  ' 6-jet fracton      @')
      CALL HDEF1( 17,'EFF', 30,  1.,1.0     ,  ' 7-jet fracton      @')
      CALL HDEF1( 18,'EFF', 30,  1.,1.0     ,  ' 8-jet fracton      @')
      CALL HDEF1( 19,'EFF', 30,  1.,1.0     ,  ' 9-jet fracton      @')
      CALL HDEF1( 20,'EFF', 30,  1.,1.0     ,  '10-jet fracton      @')
      CALL HDEF1( 21,'I*4',100, 60.,0.5     ,  'm(W) final          @')
      CALL HDEF1( 23,'I*4',150,240.,5.0     ,  'm(t-t_bar) BEST     @')
      CALL HDEF1( 24,'I*4',100, -1.,0.02,  'cos(theta_t) LAB.  BEST @')
      CALL HDEF1( 25,'I*4',100,  0.,2.0     ,  'Pt BEST             @')
      CALL HDEF1( 26,'I*4',100,  0.,0.5     ,  'Chi**2 BEST         @')
      CALL HDEF1( 27,'I*4',100,  9.,1.     ,  'veto effect@' )
      CALL HDEF1( 28,'I*4',100, -1.,0.02   ,  'cos(t.t_bar)@' )
      CALL HDEF1( 29,'I*4',150,240.,5.0     ,  'm(t-t_bar) veto @')
      CALL HDEF1( 30,'I*4',150,240.,5.0     ,  'm(t-t_bar) Ev+pL@')
      CALL HDEF1( 31,'I*4',150,240.,5.0     ,  'm(t-t_bar) Evis.@')
      CALL HDEF1( 32,'I*4',150,240.,5.0     ,  'm(t-t_bar) pT   @')
      CALL HDEF1( 33,'I*4',200,  0.,8.E-5   ,  'y_cut(6-jet) final  @')
      CALL HDEF1( 34,'I*4',100, -1.,0.02 ,
     &  'cos(p_miss.b/b_bar) final @')
      CALL HDEF1( 35,'I*4',100, -1.,0.02 ,
     &  'cos(p_miss.b/b_bar)inXY@ final')
      CALL HDEF1( 36,'I*4',100, -1.,0.02 ,
     &  'cos(p_miss.b/b_bar) ttft_cut@')
      CALL HDEF1( 37,'I*4',100, -1.,0.02 ,
     &  'cos(p_miss.b/b_bar)inXY@ ttft_cut')
      CALL HDEF1( 38,'I*4',100, 0.,0.01 ,
     &  'max cos(jet) in each event final@')
      CALL HDEF1( 51,'I*4',100,-2.,0.04 , 'cos(miss.neut) @')
      CALL HDEF1( 52,'I*4',100,-2.,0.04 , 'cos(miss.neut)XY@')
      CALL HDEF1( 53,'I*4',100,-2.,0.04 , 'cos(miss.neut)ttft_cut @')
      CALL HDEF1( 54,'I*4',100,-2.,0.04 , 'cos(miss.neut)XY ttft_cut@')
      CALL HDEF1( 55,'I*4',250,  0.,5.0     ,  'm(t-t_bar) final    @')
      CALL HDEF1( 41,'I*2',50,20. ,2.0,  'pT cut@')
      CALL HDEF1( 42,'I*2',50,500.,10.,  'Evis cut@')
      CALL HDEF1( 43,'I*2',50,500.,10.,  'Evis+!pL! cut@')
      CALL HDEF1( 44,'I*2',50,  0., 5.,  'E_veto@')
      CALL HDEF1( 45,'I*2',50,  0., 0.01,  'theta_veto@')
      CALL HDEF1( 46,'I*4',100, -1.,0.02 , 'cos(theta_t) CM  BEST@')
      CALL HDEF1( 47,'I*4',100, -1.,0.02,  'cos(theta_t) LAB. FINAL@')
      CALL HDEF1( 48,'I*4',100, -1.,0.02 , 'cos(theta_t) CM  FINAL@')
      CALL HDEF1( 49,'I*4',100, -1.,0.02, 'cos(t.t_bar) FINAL@' )
      CALL HDEF1( 60,'I*4',100, -1.,0.02, 'cos(t.t_bar)XY BEST@' )
      CALL HDEF1( 61,'I*4',100, -1.,0.02, 'cos(t.t_bar)XY FINAL@' )
      CALL HDEF1( 62,'I*4',100, -1.,0.02, 'cos(tt-system) BEST@' )
      CALL HDEF1( 63,'I*4',100, -1.,0.02, 'cos(tt-system) FINAL@' )
      CALL HDEF1( 64,'I*4',100, 0.,5., 'E of GEN.neutrino FINAL@' )
      CALL HDEF1( 65,'I*4',100, 0.,5., 'Pt of GEN.neutrino FINAL@' )
      CALL HDEF1( 66,'I*4',100, 0.,5.,
     &  'E of nu & nu_bar (final parton) @' )
      CALL HDEF1( 67,'I*4',100, 0.,5.,
     &  'Pt of nu & nu_bar (final parton) @' )
      READ(8,*) CUTPT
      READ(8,*) CUTEVS
      READ(8,*) EVISPL
      READ(8,*) ENGVET
      READ(8,*) THTVET
      WRITE(6,*) '**************'
      WRITE(6,*) ' CUTPT =',CUTPT
      WRITE(6,*) ' CUTEVS=',CUTEVS
      WRITE(6,*) ' EVISPL=',EVISPL
      WRITE(6,*) ' ENGVET=',ENGVET
      WRITE(6,*) ' THTVET=',THTVET
      WRITE(6,*) '**************'
      CALL HCUM1( 41, CUTPT, 1. )
      CALL HCUM1( 42, CUTEVS, 1. )
      CALL HCUM1( 43, EVISPL, 1. )
      CALL HCUM1( 44, ENGVET, 1. )
      CALL HCUM1( 45, THTVET, 1. )
C--
CXXX  CALL HDEF2(201,'I*4',100,100, 80., 80.,2.,2., '(AMT,AMT)      @')
CXXX  CALL HDEF2(202,'I*4',100,100,30.,30., 1.0,1., '(AMW,AMW)      @')
C     CALL HDEF2(204,'I*4',160,100,0.,-500.,10.0,10.,'(Evis,Pl)     @')
CXXX  CALL HDEF2(221,'I*4',100,100, 80., 80.,2.,2., '(AMT,AMT) best @')
      CALL HDEF2(223,'I*4',160,100,0.,-500.,10.0,10.,'(Evis,Pl) best@')
C     CALL HDEF2(224,'I*4', 50,150,  0.,240.,.5,2., '(CH2,AMT) best @')
C     CALL HDEF2(225,'I*4',100,150,  0.,240.,2.,2., '(PT ,AMT) best @')
C     CALL HDEF2(226,'I*4', 50,150,  0.,240.,.5,2., '(CH2,AMT) 2-nd @')
C     CALL HDEF2(227,'I*4', 60, 60,240.,240.,5.,5., '(AMTT1,AMTT2)  @')
C     CALL HDEF2(228,'I*4', 60, 60,-60.,240.,2.,5.,'(DEPL,AMTT) best@')
CXXX  CALL HDEF2(229,'I*4',100,100,30.,30., 1.0,1., '(AMW,AMW) best @')
C     CALL HDEF2(230,'I*4', 100, 50, 0., 0., 0.005, 2.,
C    &      'E_EM(>10GeV)/sqrt(s) vs. theta(deg) @')
C     CALL HDEF2(231,'I*4',100,100,0.,-500.,2.,10., '(PT ,PL) best @')
C     CALL HDEF2(232,'I*4',100,160,0.,0.,2.,10., '(PT ,Evis)best @')
C     CALL HDEF2(233,'I*4',160,130,0.,0.,10.,10.,
C    &   '(Evis, Evis+!PL!)best @')
CC    CALL HDEF2(234,'I*4',50,70,-1.,0.,0.04,20.,
CC   &   '(cos(t.t_bar), Evis+!PL!)best @')
CXXX
CXXX  CALL HDEF2(235,'I*4',100, 50, 250.,0., 10.,20.,
CXXX &   '(m(t.t_bar), Evis+!pL!) best @')
CXXX  CALL HDEF2(236,'I*4',100, 50, 250.,0., 10.,20.,
CXXX &   '(m(t.t_bar), Evis) best @')
CXXX  CALL HDEF2(237,'I*4',100, 50, 250.,0., 10.,10.,
CXXX &   '(m(t.t_bar), pT) best @')
CXXX  CALL HDEF2(238,'I*4',100, 50, 250.,0., 10.,20.,
CXXX &   '(m(t.t_bar), Evis+!pL!) best before EvisPL cut@')
CXXX  CALL HDEF2(239,'I*4',100, 50, 250.,0., 10.,20.,
CXXX &   '(m(t.t_bar), Evis) best before Evis cut@')
CXXX  CALL HDEF2(240,'I*4',100, 50, 250.,0., 10.,10.,
CXXX &   '(m(t.t_bar), pT) best before pT cut@')
CXXX  CALL HDEF2(241,'I*4',100, 50, 250.,0., 10.,20.,
CXXX &   '(m(t.t_bar), Evis+!pL!) best all cut@')
CXXX  CALL HDEF2(242,'I*4',100, 50, 250.,0., 10.,20.,
CXXX &   '(m(t.t_bar), Evis) best all cut@')
CXXX  CALL HDEF2(243,'I*4',100, 50, 250.,0., 10.,10.,
CXXX &   '(m(t.t_bar), pT) best all cut@')
 
C     CALL HDEF2(244,'I*4',50,70,-1.,0.,0.04,20.,
C    &   '(cos(t.t_bar), Evis+!PL!)best all cut@')
      CALL HDEF2(245,'I*4',100,100, 80., 80.,2.,2., '(AMT,AMT) ttft0@')
      CALL HDEF2(246,'I*4',100,100, 80., 80.,2.,2., '(AMT,AMT) ttft1@')
 
      CALL HDEF2(247,'I*4', 50,120,0.,0.,10.,10., '(PT ,Evis)best @')
      CALL HDEF2(248,'I*4',120,120,0.,0.,10.,10.,
     &   '(Evis, Evis+!PL!)best @')
      CALL HDEF2(249,'I*4', 50,120,0.,0.,10.,10.,
     &   '(pT, Evis+!PL!)best @')
 
      CALL HDEF2(250,'I*4', 50,120,0.,0.,10.,10., '(PT ,Evis)all cut@')
      CALL HDEF2(251,'I*4',120,120,0.,0.,10.,10.,
     &   '(Evis, Evis+!PL!)all cut @')
      CALL HDEF2(252,'I*4', 50,120,0.,0.,10.,10.,
     &   '(pT, Evis+!PL!)all cut @')
 
      CALL HDEF2(253,'I*4', 50,100,0.,-1.,10.,0.02,
     &   '(pT, cos(pmis.b/b_bar)before pT cut @')
      CALL HDEF2(254,'I*4',100,100,0.,-1.,5.,0.02,
     &   '(sqrt(mt1**2+mt2**2), cos(pmis.b/b_bar)before cut @')
      CALL HDEF2(255,'I*4',100,100,0.,-1.,5.,0.02,
     &   '(sqrt(mt1**2+mt2**2), cos(pmis.b/b_bar)before cospmis cut @')
 
      CALL HDEF2(256,'I*4',100,100,-1.,0., 0.02, 5.,
     &   ' cos(th) of t/t_bar (ttCM) vs. Pt_mis. FINAL@')
      CALL HDEF2(257,'I*4',100,100,0.,0., 10., 5.,
     &   ' E_vis vs. Pt_mis. FINAL@')
      CALL HDEF2(258,'I*4',100,100,-1., 0., 0.02, 5.,
     &   ' cos(th) of t.t-bar in Lab_XY  vs. Pt_mis. FINAL@')
      CALL HDEF2(259,'I*4',100,100,0.,-1., 10., 0.02,
     &   ' E_vis vs. cos(th) of P_mis. FINAL@')
C--
C  That's it.
C--
      RETURN
      END
