C***********************************************************************
C*
C*======================================----==
C* Subroutine PRUSER(IDREC,LEVEL,IDEBUG,IRET)
C*======================================----==
C*
C* (Function)
C*     User Event analysis routine.
C* (Input)
C*     IDREC   :  Record ID.
C*     ILEVEL  :  Level of analysis.
C*     IDEBUG  :  Debug flag.
C* (Output)
C*     IRET    :  Return flag.
C* (Update Record)
C*   4/23/90  K.Fujii             Original version.
C*
C***********************************************************************
 
      SUBROUTINE PRUSER( IDREC, LEVEL, IDEBUG, IRET )
 
      CHARACTER*64    BKNAME(-3:3)
      DATA BKNAME  / 'Spring:Header',
     .               'Spring:Parton_List',
     .               'Generator:Header',
     .               'Generator:Particle_List' ,
     .               'Production:CDC;Track_Parameter',
     .               'Production:EMC;CLUSTER' ,
     .               'Production:HDC;CLUSTER' /
CCC  .               'Production:EMC;Hit_Cell' ,
CCC  .               'Production:HDC;Hit_Cell' /
C--
      PARAMETER      ( LNxDT = 100, MXxPT = 5000, LNxPV = 10,
     .                 MXxPV = 500, MXxJET = 100, MXxYCT = 30 )
      COMMON /SSWORK/ IELM(MXxPT,-3:3), RDATA(LNxDT,MXxPT),
     .                PV(LNxPV,MXxPV), QV(LNxPV,MXxPV),
     .                NJCLS(MXxYCT), NPINJ(MXxJET), IPTOJ(MXxPV),
     .                PVJET(4,MXxPV), XHDATA(20,500)
      REAL   *4       RBUF(MXxPT)
      INTEGER*2       HBUF(2*MXxPT)
      INTEGER*4       IDATA(LNxDT,MXxPT), NTK(0:3), IBUF(MXxPT)
      EQUIVALENCE    (IDATA,RDATA), (RBUF,IBUF,HBUF)
      REAL*4          PMISS(4)
C--
      REAL*4          YCUT(0:MXxYCT)
C     DATA   YCUT     / 4.0E-4,
C    .                  6.4E-4, 6.8E-4, 7.2E-4, 7.6E-4, 8.0E-4,
C    .                  8.4E-4, 8.8E-4, 9.2E-4, 9.6E-4,10.0E-4,
C    .                 10.4E-4,10.8E-4,11.2E-4,11.6E-4,12.0E-4,
C    .                 12.4E-4,12.8E-4,13.2E-4,13.6E-4,14.0E-4,
C    .                 14.4E-4,14.8E-4,15.2E-4,15.6E-4,16.0E-4,
C    .                 16.4E-4,16.8E-4,17.2E-4,17.6E-4,18.0E-4 /
      DATA   YCUT     /10.0E-4,
     .                 11.0E-4,12.0E-4,13.0E-4,14.0E-4,15.0E-4,
     .                 16.0E-4,17.0E-4,18.0E-4,19.0E-4,20.0E-4,
     .                 21.0E-4,22.0E-4,23.0E-4,24.0E-4,25.0E-4,
     .                 26.0E-4,27.0E-4,28.0E-4,29.0E-4,30.0E-4,
     .                 31.0E-4,32.0E-4,33.0E-4,34.0E-4,35.0E-4,
     .                 36.0E-4,37.0E-4,38.0E-4,39.0E-4,40.0E-4/
      INTEGER*4       IUSFLG(MXxJET), IJTCMB(2,4,1000)
C>>>
C     DATA NOMYCT     /   5  /
      DATA NOMYCT     /   1  /
CCC   DATA DYMIN      / 1.E-6/
      DATA DYMIN      / 1.E-5/
      DATA DYMAX      / 1.E-2/
      DATA NTRYMX     /  50  /
      DATA ECUT       /  0.1 /
C     DATA PTCUT      /  70. /
      DATA PTCUT      / 1.E6 /
      DATA PLCUT      / 1.E6 /
C  E_vis cut ( roots - delta )
C  diff. from root(s) (GeV)
C     DATA DEVSCT     /  50. /
      DATA DEVSCT     / 1.E6 /
C   W-jet mass cut
      DATA AMJCUT     / 15.0 /
C   top-jet mass cut
      DATA RMTCUT     / 50.0 /
      DATA EVOFF      / 10.0 /
C--
      DATA AMW        / 80.0 /
      DATA AMZ        / 91.1 /
      DATA AMT        / 150. /
C W mass resolution
      DATA SGMV       /   4. /
C t mass resolution ( depend beta of t)
      DATA SGMT       /  15. /
C>>>  cut by TTFT
      COMMON /PRUCUT/ CUTPT, CUTEVS, EVISPL, ENGVET, THTVET
C      miss.pT ( vis.pT)
CCC   DATA CUTPT /50./
C      vis.E
CCC   DATA CUTEVS/700./
C      vis.E + !pL!
CCC   DATA EVISPL/800./
C>>>
C
C     el.mag. veto ( for e+/- veto )
        PARAMETER( NTHC=4, NENGC=7 )
        REAL*4 THCUT(NTHC), ENGCUT(NENGC)
        INTEGER*4 IEVETO(NENGC,NTHC)
        DATA THCUT/0.05, 0.100, 0.150, 0.200/
        DATA ENGCUT /10., 30., 50., 70., 90., 110., 130./
 
      REAL*4  PTCM1(4), PTCM2(4), PTTCM(4)
 
C
C==================<<  Entry Point  >>================================
C
C--
C  Reset return code, Skip except EVENT record.
C--
      IRET = 0
      IF( IDREC .NE. 1 ) RETURN
      LEVEL  = LEVEL
      IDEBUG = IDEBUG
      IRET = 1
C--
C get Header to know event number
C--
      CALL TBGET(1,'Generator:Header',1,NW,IDATA(1,1),IRT)
      IF ( IRT.LT.0 ) THEN
         WRITE(6,*) ' TBGET ERROR to get "GENERATOR:HEADER"'
         STOP
      ENDIF
      IEVNUM = IDATA(1,1)
C--
C  Set beam energy.
C--
      CALL TBGET(1,BKNAME(-1),1,NW,IDATA(1,1),IRT)
      IF ( IRT.LT.0 ) RETURN
      EBM   = IDATA(7,1)/1000.
      ROOTS = 2*EBM
C--
C  TBGET simulator information.
C        RDATA(    1) = EX
C             (    2) = EY
C             (    3) = EZ
C             (    4) = E
C--
      NPT = 0
      CALL UVZERO(4,NTK)
      DO 1000 IB = 1, 3
         CALL TBNOEL(1,BKNAME(IB),NE,IELM(1,IB))
         IF ( NE.LE.0 )                          GO TO 1000
         DO 100 IE = 1, NE
            NPT     = NPT + 1
            NTK(IB) = NTK(IB) + 1
            CALL TBGET(1,BKNAME(IB),IELM(IE,IB),NW,RDATA(1,NPT),IRT)
100      CONTINUE
1000  CONTINUE
C--
C  # tracks.
C--
      CALL HCUM1(1,0.1,1.)
      CALL HCUM1(2,NPT+.1,1.)
      CALL HCUM1(3,NTK(1)+.1,1.)
      CALL HCUM1(4,NTK(2)+.1,1.)
      CALL HCUM1(5,NTK(3)+.1,1.)
C--
      IF ( NPT.EQ.0 )                            GO TO 9999
      CALL HCUM1(1,1.1,1.)
C--
C  Select good clusters.
C--
      IPT1 = NTK(0) + NTK(1) + 1
      IPT2 = NPT
CEMTK       IPT1 = NTK(0) + 1
CEMTK       IPT2 = NTK(0) + NTK(1) + NTK(2)
      NTRK = 0
      DO 2000 IPT = IPT1, IPT2
         E = RDATA(4,IPT)
         IF ( E.LT.ECUT )                        GO TO 2000
         NTRK = NTRK + 1
         CALL UVCOPY(4,RDATA(1,IPT),QV(1,NTRK))
2000  CONTINUE
C--
      IF ( NTRK.LT.6 )                           GO TO 9999
      CALL HCUM1(1,2.1,1.)
C--
C  Require approximate 4-momentum conservation to select well
C  reconstructed events.
C--
      ISM = NTRK + 1
      CALL UVZERO(4,QV(1,ISM))
      DO 250 ITK = 1, NTRK
         CALL UADD4(QV(1,ISM),QV(1,ITK),QV(1,ISM))
250   CONTINUE
      EVIS = QV(4,ISM)
      PT   = SQRT( QV(1,ISM)*QV(1,ISM) + QV(2,ISM)*QV(2,ISM) )
      PL   = QV(3,ISM)
      DO 251 II=1,3
251   PMISS(II) = -QV(II,ISM)
      PMISS(4)  = ROOTS-EVIS
CCC   CALL HCUM2(204,EVIS,PL,1.)
      CALL HCUM1(  8,PT,1.)
C--
CB    EVSCUT = REVSCT*ROOTS
      EVSCUT = ROOTS - DEVSCT
      IF ( EVIS.LT.EVSCUT .OR. PT.GT.PTCUT .OR.
     .     ABS(PL).GT.PLCUT )                    GO TO 9999
      CALL HCUM1(1,3.1,1.)
C--
C  Cluster into jets.
C--
      CALL JCLUST(NTRK,QV(1,1),LNxPV,0,MXxYCT,YCUT(1),
     .            NJCLS,NPINJ,IPTOJ,PVJET,IRT)
C--
      IF ( IRT.LT.0 )  THEN
        WRITE(6,*) '        Event number=',IEVNUM, ' NTRK=',NTRK
        GO TO 9999
      ENDIF
      CALL HCUM1(1,4.1,1.)
C--
      ICTS = 0
      DO 3000 ICT = 1, MXxYCT
         IF ( NJCLS(ICT).GE.6 ) ICTS = ICT
         DO 300 IJT = 2, 10
            IHST = 10 + IJT
            IF ( NJCLS(ICT).EQ.IJT ) THEN
               EPS = 1.
            ELSE IF ( NJCLS(ICT).GT.10 .AND. IJT.EQ.10 ) THEN
               EPS = 1.
            ELSE
               EPS = 0.
            ENDIF
            CALL HCUM1(IHST,ICT+.1,EPS)
300      CONTINUE
3000  CONTINUE
C--
C  Require 6 or more jets for nominal y_cut.
C--
      IF ( NJCLS(NOMYCT).LT.6 )                  GO TO 9999
      CALL HCUM1(1,5.1,1.)
C--
C  Find a y_cut which gives 6 jets.
C--
      NTRY    = 0
C--
      IF ( ICTS.LT.MXxYCT ) THEN
         YCUT(0) = YCUT(ICTS)
         DYCT    = (YCUT(ICTS+1)-YCUT(ICTS))/2
      ELSE IF ( NJCLS(ICTS).EQ.6 ) THEN
         YCUT(0) = YCUT(ICTS)
                                                 GO TO 360
      ELSE
         YCUT(0) = YCUT(MXxYCT)
         DYCT    = DYMAX
      ENDIF
      YSTART = YCUT(0)
 
350   NTRY    = NTRY + 1
      YCUT(0) = YCUT(0) + DYCT
      CALL JCLUST(NTRK,QV(1,1),LNxPV,0,1,YCUT(0),
     .            NJCLS,NPINJ,IPTOJ,PVJET,IRT)
      IF ( IRT.LT.0 ) THEN
         PRINT *, ' >>>>>>> Error in JCLUST >>>>>>>'
         PRINT *, '    IRT = ', IRT, ' Skip this event. '
                                                 GO TO 9999
      ENDIF
      NJT = NJCLS(1)
CCC   IF ( NJT.EQ.6 .AND. ABS(DYCT).LT.DYMIN )   GO TO 360
      IF ( NJT.EQ.6 )                            GO TO 360
      IF ( NTRY.GT.NTRYMX ) THEN
         IF ( NJT.EQ.6 )                         GO TO 360
         PRINT *, ' >>>>>> Cannot find y_cut >>>>>> '
         PRINT *, '    NTRY    = ', NTRY
         PRINT *, '    YCUT(0) = ', YCUT(0), ' YSTART=',YSTART,
     &            ' NJT = ', NJT
         CALL HCUM1(9,NTRY+.1,1.)
                                                 GO TO 9999
      ENDIF
      IF ( NJT.LT.6 ) THEN
         DYCT = - ABS(DYCT)/2
      ELSE IF ( NJT.GE.6 ) THEN
         DYCT = ABS(DYCT)/2
      ENDIF
                                                 GO TO 350
360   CALL HCUM1(9,NTRY+.1,1.)
      CALL HCUM1(10,YCUT(0),1.)
C--
C  Look for W+ and W-.
C--
      CALL UVZERO(MXxJET,IUSFLG)
      NCMB = 0
      DO 6000 IJT1 = 1, 5
      DO 600 JJT1 = IJT1+1, 6
         CALL UADD4(PVJET(1,IJT1),PVJET(1,JJT1),PV(1,1))
         AMJ = UDOT4(PV(1,1),PV(1,1))
         AMJ = SIGN(SQRT(ABS(AMJ)),AMJ)
         IF ( ABS(AMJ-AMW).GT.AMJCUT )           GO TO 600
         IUSFLG(IJT1) = 1
         IUSFLG(JJT1) = 1
      DO 5000 IJT2 = 1, 5
         IF ( IUSFLG(IJT2).NE.0 )                GO TO 5000
      DO 500 JJT2 = IJT2+1, 6
         IF ( IUSFLG(JJT2).NE.0 )                GO TO 500
         CALL UADD4(PVJET(1,IJT2),PVJET(1,JJT2),PV(1,2))
         AMJ = UDOT4(PV(1,2),PV(1,2))
         AMJ = SIGN(SQRT(ABS(AMJ)),AMJ)
         IF ( ABS(AMJ-AMW).GT.AMJCUT )           GO TO 500
         IUSFLG(IJT2) = 1
         IUSFLG(JJT2) = 1
         NCMB = NCMB + 1
         IJTCMB(1,1,NCMB) = IJT1
         IJTCMB(2,1,NCMB) = JJT1
         IJTCMB(1,2,NCMB) = IJT2
         IJTCMB(2,2,NCMB) = JJT2
         NBJT = 0
         DO 50 IJT = 1, 6
            IF ( IUSFLG(IJT).EQ.0 ) THEN
               NBJT = NBJT + 1
               IJTCMB(NBJT,4,NCMB) = IJT
            ENDIF
50       CONTINUE
         IUSFLG(IJT2) = 0
         IUSFLG(JJT2) = 0
500   CONTINUE
5000  CONTINUE
         IUSFLG(IJT1) = 0
         IUSFLG(JJT1) = 0
600   CONTINUE
6000  CONTINUE
C--
C  Calculate invariant masses, etc.
C--
      CALL HCUM1(6,NCMB+.1,1.)
      IF ( NCMB.LE.0 )                           GO TO 9999
      CALL HCUM1(1,6.1,1.)
C>>>
CP       PRINT *, ' --- '
CP       DO 660 IJT = 1, 8
CP          PRINT *, ' PVJET(*,', IJT, ') = ', ( PVJET(K,IJT), K=1,4 )
CP 660   CONTINUE
CP       PRINT *, ' PVJET_sum = ', ( QV(K,ISM), K=1,4 )
CP       PRINT *, ' --- '
CP       PRINT *, ' NCMB = ', NCMB
C>>>
      NTT    = 0
      CHI2S  = 1.E20
      ITTBST = 0
      ITTBS2 = 0
      DO 7000 ICMB = 1, NCMB
C>>>
CP          PRINT *, ' ICMB = ', ICMB, ' IJTCMB = ',
CP      .             ( ( IJTCMB(K,KK,ICMB), K=1,2 ), KK=1,4 )
C>>>
         IJT1 = IJTCMB(1,1,ICMB)
         JJT1 = IJTCMB(2,1,ICMB)
         IJT2 = IJTCMB(1,2,ICMB)
         JJT2 = IJTCMB(2,2,ICMB)
         IBJ1 = IJTCMB(1,4,ICMB)
         IBJ2 = IJTCMB(2,4,ICMB)
         CALL UADD4(PVJET(1,IJT1),PVJET(1,JJT1),PV(1,1))
         CALL UADD4(PVJET(1,IJT2),PVJET(1,JJT2),PV(1,2))
         AMW1 = UDOT4(PV(1,1),PV(1,1))
         AMW1 = SIGN(SQRT(ABS(AMW1)),AMW1)
         AMW2 = UDOT4(PV(1,2),PV(1,2))
         AMW2 = SIGN(SQRT(ABS(AMW2)),AMW2)
C>>>
         CALL USETV4(AMW,PV(1,1),PV(1,4))
         CALL USETV4(AMW,PV(1,2),PV(1,5))
C        CALL UVCOPY(4,PV(1,1),PV(1,4))
C        CALL UVCOPY(4,PV(1,2),PV(1,5))
C>>>
C--
         CALL UADD4(PV(1,4),PVJET(1,IBJ1),PV(1,6))
         CALL UADD4(PV(1,5),PVJET(1,IBJ2),PV(1,7))
         AMJ1 = UDOT4(PV(1,6),PV(1,6))
         AMJ1 = SIGN(SQRT(ABS(AMJ1)),AMJ1)
         AMJ2 = UDOT4(PV(1,7),PV(1,7))
         AMJ2 = SIGN(SQRT(ABS(AMJ2)),AMJ2)
C>>>
CP          PRINT *, ' AMT1, PV(*,T1) = ', AMJ1, ( PV(K,6), K=1,4 )
CP          PRINT *, ' AMT2, PV(*,T1) = ', AMJ2, ( PV(K,7), K=1,4 )
C>>>
CXXX     CALL HCUM2(201,AMJ1,AMJ2,1.)
C        IF ( ABS(AMJ1-AMJ2).LT.DMJCUT ) THEN
C        IF ( ABS(AMJ1-AMT).LT.DMJCUT .AND.
C    .        ABS(AMJ2-AMT).LT.DMJCUT ) THEN
C        SMJCUT = 2*AMT - DSMJCT
C        IF ( ABS(AMJ1-AMT).LT.DMJCUT .AND.
C    .        ABS(AMJ2-AMT).LT.DMJCUT .AND.
C    .        AMJ1+AMJ2.GT.SMJCUT  ) THEN
         RMT = SQRT( (AMJ1-AMT)**2 + (AMJ2-AMT)**2 )
         IF ( RMT.LT.RMTCUT .OR.
     .      ( AMJ1.GE.AMT .AND. AMJ2.GE.AMT-RMTCUT ) .OR.
     .      ( AMJ2.GE.AMT .AND. AMJ1.GE.AMT-RMTCUT ) ) THEN
            NTT = NTT + 1
C--
            CHI2 =   ((AMW1-AMW)/SGMV)**2 + ((AMW2-AMW)/SGMV)**2
     .             + ((AMJ1-AMT)/SGMT)**2 + ((AMJ2-AMT)/SGMT)**2
            IF ( CHI2.LT.CHI2S ) THEN
               CHI2S  = CHI2
               ITTBS2 = ITTBST
               ITTBST = NTT
            ENDIF
C--
            CALL UADD4(PV(1,6),PV(1,7),PV(1,10))
            AMTT = UDOT4(PV(1,10),PV(1,10))
            AMTT = SIGN(SQRT(ABS(AMTT)),AMTT)
            CST1 = PV(3,6)/UABSV3(PV(1,6))
            CST2 = PV(3,7)/UABSV3(PV(1,7))
            DEPL = EVIS + EVOFF + ABS(PL) - ROOTS
C-
            XHDATA( 1,NTT) = ICMB
            XHDATA( 2,NTT) = AMW1
            XHDATA( 3,NTT) = AMW2
            XHDATA( 5,NTT) = AMJ1
            XHDATA( 6,NTT) = AMJ2
            XHDATA( 7,NTT) = AMTT
            XHDATA(10,NTT) = CST1
            XHDATA(11,NTT) = CST2
            XHDATA(12,NTT) = EVIS
            XHDATA(13,NTT) = PT
            XHDATA(14,NTT) = PL
            XHDATA(15,NTT) = CHI2
            XHDATA(16,NTT) = DEPL
C--
            CALL HCUM1(7,AMTT,1.)
CXXX        CALL HCUM2(202,AMW1,AMW2,1.)
         ENDIF
7000  CONTINUE
C--
C  Look at the best combination.
C--
      CALL HCUM1(11,NTT+.1,1.)
      IF ( ITTBST.LE.0 )                         GO TO 9999
      CALL HCUM1(1,7.1,1.)
C--
      ITT = ITTBST
      IF(ITT.EQ.1) ITTBS2=1
      ICMB  = XHDATA( 1,ITT)
      AMW1  = XHDATA( 2,ITT)
      AMW2  = XHDATA( 3,ITT)
      AMT1  = XHDATA( 5,ITT)
      AMT2  = XHDATA( 6,ITT)
      AMTT  = XHDATA( 7,ITT)
      CST1  = XHDATA(10,ITT)
      CST2  = XHDATA(11,ITT)
      EVIS  = XHDATA(12,ITT)
      PT    = XHDATA(13,ITT)
      PL    = XHDATA(14,ITT)
      CHI2  = XHDATA(15,ITT)
      DEPL  = XHDATA(16,ITT)
      AMTT2 = XHDATA( 7,ITTBS2)
      CHI22 = XHDATA(15,ITTBS2)
C--
      CALL HCUM1(21,AMW1,1.)
      CALL HCUM1(21,AMW2,1.)
      CALL HCUM1(23,AMTT,1.)
      CALL HCUM1(24,CST1,1.)
      CALL HCUM1(24,CST2,1.)
      CALL HCUM1(25,PT  ,1.)
      CALL HCUM1(26,CHI2,1.)
CXXX  CALL HCUM2(221,AMT1,AMT2,1.)
C     CALL HCUM2(222,CSZ ,EZ  ,1.)
      CALL HCUM2(223,EVIS,PL  ,1.)
C     CALL HCUM2(224,CHI2,AMTT,1.)
C     CALL HCUM2(225,PT  ,AMTT,1.)
C     CALL HCUM2(226,CHI22,AMTT2,1.)
C     CALL HCUM2(227,AMTT ,AMTT2,1.)
C     CALL HCUM2(228,DEPL ,AMTT,1.)
CXXX  CALL HCUM2(229,AMW1 ,AMW2,1.)
C     CALL HCUM2(231,PT, PL,1.)
C     CALL HCUM2(232,PT, EVIS,1.)
C     CALL HCUM2(233,EVIS, EVIS+ABS(PL), 1.)
 
         IJT1 = IJTCMB(1,1,ICMB)
         JJT1 = IJTCMB(2,1,ICMB)
         IJT2 = IJTCMB(1,2,ICMB)
         JJT2 = IJTCMB(2,2,ICMB)
         IBJ1 = IJTCMB(1,4,ICMB)
         IBJ2 = IJTCMB(2,4,ICMB)
         CALL UADD4(PVJET(1,IJT1),PVJET(1,JJT1),PV(1,1))
         CALL UADD4(PVJET(1,IJT2),PVJET(1,JJT2),PV(1,2))
         CALL USETV4(AMW,PV(1,1),PV(1,4))
         CALL USETV4(AMW,PV(1,2),PV(1,5))
         CALL UADD4(PV(1,4),PVJET(1,IBJ1),PV(1,6))
         CALL UADD4(PV(1,5),PVJET(1,IBJ2),PV(1,7))
         CALL UADD4(PV(1,6),PV(1,7),PTTCM)
C boost t/t_bar to the t-t_bar CM
         CALL UBSTFD( PV(1,6), PTTCM, PTCM1 )
         CALL UBSTFD( PV(1,7), PTTCM, PTCM2 )
C cos(th) of t t_bar system
         COSTT = PTTCM(3)/UABSV3(PTTCM)
         CALL HCUM1(62,COSTT,1.)
C cos(th) of t/t_bar in t-t_bar CM defined by t-t_bar CM direction
         CST1CM = UDOT3(PTTCM,PTCM1)/UABSV3(PTTCM)/UABSV3(PTCM1)
         CST2CM = UDOT3(PTTCM,PTCM2)/UABSV3(PTTCM)/UABSV3(PTCM2)
         CALL HCUM1( 46, CST1CM, 1. )
         CALL HCUM1( 46, CST2CM, 1. )
C opening angle between t & t_bar jets in XY plane
         OTTXY = ( PV(1,6)*PV(1,7) + PV(2,6)*PV(2,7) )
     &           / SQRT(PV(1,6)**2+PV(2,6)**2)
     &           / SQRT(PV(1,7)**2+PV(2,7)**2)
         CALL HCUM1( 60, OTTXY, 1. )
C opening angle between t & t_bar jets
         OPNTT = 0.
         DO 8001 II=1,3
8001     OPNTT = OPNTT +PV(II,6)*PV(II,7)
         OPNTT = OPNTT/UABSV3(PV(1,6))/UABSV3(PV(1,6))
         CALL HCUM1( 28, OPNTT, 1. )
CCC      CALL HCUM2(234,OPNTT, EVIS+ABS(PL), 1.)
C opening angle between p_miss & b/b_bar jets
         OPNB1 = 0.
         DO 8002 II=1,3
8002     OPNB1 = OPNB1 +PVJET(II,IBJ1)*PMISS(II)
         OPNB1 = OPNB1/UABSV3(PVJET(1,IBJ1))/UABSV3(PMISS)
 
         OPNB2 = 0.
         DO 8003 II=1,3
8003     OPNB2 = OPNB2 +PVJET(II,IBJ2)*PMISS(II)
         OPNB2 = OPNB2/UABSV3(PVJET(1,IBJ2))/UABSV3(PMISS)
 
C opening angle between p_miss & b/b_bar jets in R-phi plane
         OPNBT1 = 0.
         DO 8004 II=1,2
8004     OPNBT1 = OPNBT1 +PVJET(II,IBJ1)*PMISS(II)
         OPNBT1 = OPNBT1/SQRT(PVJET(1,IBJ1)**2+PVJET(2,IBJ1)**2)/PT
 
         OPNBT2 = 0.
         DO 8005 II=1,2
8005     OPNBT2 = OPNBT2 +PVJET(II,IBJ2)*PMISS(II)
         OPNBT2 = OPNBT2/SQRT(PVJET(1,IBJ2)**2+PVJET(2,IBJ2)**2)/PT
 
C opening angle between p_miss & f/f_bar jets in R-phi plane
         OPNJT1 = 0.
         DO 8006 II=1,2
8006     OPNJT1 = OPNJT1 +PVJET(II,IJT1)*PMISS(II)
         OPNJT1 = OPNJT1/SQRT(PVJET(1,IJT1)**2+PVJET(2,IJT1)**2)/PT
 
         OPNJT2 = 0.
         DO 8007 II=1,2
8007     OPNJT2 = OPNJT2 +PVJET(II,JJT1)*PMISS(II)
         OPNJT2 = OPNJT2/SQRT(PVJET(1,JJT1)**2+PVJET(2,JJT1)**2)/PT
 
         OPNJT3 = 0.
         DO 8008 II=1,2
8008     OPNJT3 = OPNJT3 +PVJET(II,IJT2)*PMISS(II)
         OPNJT3 = OPNJT3/SQRT(PVJET(1,IJT2)**2+PVJET(2,IJT2)**2)/PT
 
         OPNJT4 = 0.
         DO 8009 II=1,2
8009     OPNJT4 = OPNJT4 +PVJET(II,JJT2)*PMISS(II)
         OPNJT4 = OPNJT4/SQRT(PVJET(1,JJT2)**2+PVJET(2,JJT2)**2)/PT
 
      OPNBMX=AMAX1( OPNB1, OPNB2 )
C     OPBTMX=AMAX1( OPNBT1, OPNBT2 )
      OPBTMX=AMAX1( OPNBT1, OPNBT2, OPNJT1, OPNJT2, OPNJT3, OPNJT4 )
      CALL HCUM1( 34, OPNBMX, 1. )
      CALL HCUM1( 35, OPBTMX, 1. )
 
      CS1 = PVJET(3,IBJ1)/UABSV3(PVJET(1,IBJ1))
      CS2 = PVJET(3,IBJ2)/UABSV3(PVJET(1,IBJ2))
      CS3 = PVJET(3,IJT1)/UABSV3(PVJET(1,IJT1))
      CS4 = PVJET(3,JJT1)/UABSV3(PVJET(1,JJT1))
      CS5 = PVJET(3,IJT2)/UABSV3(PVJET(1,IJT2))
      CS6 = PVJET(3,JJT2)/UABSV3(PVJET(1,JJT2))
      CSMX = AMAX1( ABS(CS1), ABS(CS2), ABS(CS3), ABS(CS4),
     &              ABS(CS5), ABS(CS6) )
 
C     e+/- veto
      CALL ELVETO( ROOTS, ENGCUT,NENGC,  THCUT,NTHC,  IEVETO )
      DO 8000 I1=1,NENGC
      DO 8000 I2=1,NTHC
       XXX=10*I1+I2
       IF( IEVETO(I1,I2).EQ.0 ) CALL HCUM1( 27, XXX+0.1, 1. )
8000  CONTINUE
 
      CALL ELVETO( ROOTS, ENGVET,1,  THTVET,1,  IVTFLG )
C apply cuts by TTFT
      IF( IVTFLG.EQ.0 ) THEN
C       e+/-(EM.)veto
CXXX    CALL HCUM2( 235, AMTT, EVIS+ABS(PL), 1. )
CXXX    CALL HCUM2( 236, AMTT, EVIS, 1. )
CXXX    CALL HCUM2( 237, AMTT, PT, 1. )
        CALL HCUM2( 247, PT, EVIS, 1. )
        CALL HCUM2( 248, EVIS, EVIS+ABS(PL), 1. )
        CALL HCUM2( 249, PT, EVIS+ABS(PL), 1. )
        CALL HCUM1( 29, AMTT, 1. )
CXXX    CALL HCUM2( 238, AMTT, EVIS+ABS(PL), 1. )
        CALL HCUM2( 254,SQRT((AMT1-AMT)**2+(AMT2-AMT)**2),
     &              OPBTMX, 1. )
      IF( EVIS+ABS(PL) .LT. EVISPL   ) THEN
        CALL HCUM1( 30, AMTT, 1. )
CXXX    CALL HCUM2( 239, AMTT, EVIS, 1. )
      IF( EVIS .LT. CUTEVS ) THEN
        CALL HCUM1( 31, AMTT, 1. )
CXXX    CALL HCUM2( 240, AMTT, PT, 1. )
        CALL HCUM2( 253, PT, OPBTMX, 1. )
      IF( PT   .GE. CUTPT ) THEN
        CALL HCUM1( 32, AMTT, 1. )
CXXX    CALL HCUM2( 241, AMTT, EVIS+ABS(PL), 1. )
CXXX    CALL HCUM2( 242, AMTT, EVIS, 1. )
CXXX    CALL HCUM2( 243, AMTT, PT, 1. )
CC      CALL HCUM2( 244,OPNTT, EVIS+ABS(PL), 1.)
        CALL HCUM1(33,YCUT(0),1.)
        CALL HCUM1( 36, OPNBMX, 1. )
        CALL HCUM1( 37, OPBTMX, 1. )
        CALL HCUM2(245,AMT1,AMT2,1.)
        CALL HCUM2( 250, PT, EVIS, 1. )
        CALL HCUM2( 251, EVIS, EVIS+ABS(PL), 1. )
        CALL HCUM2( 252, PT, EVIS+ABS(PL), 1. )
        CALL HCUM1( 38, CSMX, 1. )
        CALL HCUM2( 255,SQRT((AMT1-AMT)**2+(AMT2-AMT)**2),
     &              OPBTMX, 1. )
C---
               IRET = 0
C---
        IF( OPBTMX.LT.0.95 .AND.
     &      SQRT((AMT1-AMT)**2+(AMT2-AMT)**2).LT.50.   ) THEN
          CALL HCUM2(246,AMT1,AMT2,1.)
          CALL HCUM1( 55, AMTT, 1. )
          CALL HCUM1( 47, CST1, 1. )
          CALL HCUM1( 47, CST2, 1. )
          CALL HCUM1( 48, CST1CM, 1. )
          CALL HCUM1( 48, CST2CM, 1. )
          CALL HCUM1( 49, OPNTT, 1. )
          CALL HCUM1( 61, OTTXY, 1. )
          CALL HCUM1( 63,COSTT,1.)
          CALL HCUM2( 256, COSTT, PT, 1. )
          CALL HCUM2( 257, EVIS, PT, 1. )
          CALL HCUM2( 258, OTTXY, PT, 1. )
          CALL HCUM2( 259, EVIS, COSTT, 1. )
        ENDIF
      ENDIF
      ENDIF
      ENDIF
      ENDIF
 
 
      IF( .FALSE. ) THEN
C--
C  Output mini-DST.
C        HBUF( 1-24) = IDPTCL(3,8)
C            (25-32) = IHLCMB
C        RBUF(17-31) = XPHASE(3,5)
C            (   32) = DSGMDX
C            (   33) = DPDEBM
C            (   34) = nominal beam energy
C            (   35) = Gaussian smeared E(e-)
C            (   36) = Gaussian smeared E(e+)
C            (   37) = E(e-) after beamstrahlung
C            (   38) = E(e+) after beamstrahlung
C--
CCCC  IRET = 0
      CALL TBGET(1,BKNAME(-3),2,NW,IDATA(1,1),IRT)
      DO 80 I = 1, 32
         HBUF(I) = IDATA(I,1)
80    CONTINUE
      CALL UVCOPY(22,IDATA(33,1),IBUF(17))
      NWD = 38
      WRITE(24,IOSTAT=IOS,ERR=9998) NWD, (IBUF(I),I=1,NWD)
9998  IRET = IOS
       ENDIF
C--
C  That's it.
C--
9999  RETURN
      END
C======================================================================C
      SUBROUTINE ELVETO(ROOTS, ECUT,N1, THCUT,N2,IEVETO)
C======================================================================C
C For TBS
      PARAMETER( IBNKW4=10000 )
      PARAMETER( IBNKW2=IBNKW4*2, IBNKW1=IBNKW4*4)
      PARAMETER( MXSIZ = 500 )
      COMMON /SSWORK/ WORK(IBNKW4), NELM(MXSIZ)
      INTEGER*4 IWORK(IBNKW4)
      INTEGER*2 HWORK(IBNKW2)
      EQUIVALENCE( WORK(1), IWORK(1), HWORK(1) )
 
      REAL*4     ECUT(N1), THCUT(N2)
      INTEGER*4  IEVETO(N1,N2)
 
      DATA PI /3.1415926/
 
C----------------------------------------------------------------------C
      CALL UVZERO( N1*N2, IEVETO )
C---
C  get # of elements of EM.
C---
C        CALL TBNOEL(1, 'Production:EMC;Hit_Cell', NE, NELM )
         CALL TBNOEL(1, 'Production:EMC;CLUSTER', NE, NELM )
C---
C  inspect EM. data
C---
      DO 10 I=1,NE
        NEL=NELM(I)
C       CALL TBGET(1,'Production:EMC;Hit_Cell',NEL,NW,WORK,IRT)
        CALL TBGET(1,'Production:EMC;CLUSTER',NEL,NW,WORK,IRT)
        ENG = WORK(4)
        EX  = WORK(1)
        EY  = WORK(2)
        EZ  = WORK(3)
        THETA = ATAN2(SQRT(EX**2 +EY**2),EZ)
C       IF( ENG.GE.10.)
C    &    CALL HCUM2(230, ENG/ROOTS, THET0/PI*180., 1. )
        IF( THETA.GE.PI/2 ) THEN
         THET0 = PI-THETA
        ELSE
         THET0 = THETA
        ENDIF
C         apply cuts
          DO 20 I1=1,N1
          DO 20 I2=1,N2
          IF( THET0.GE.THCUT(I2)
     &       .AND. ENG.GE.ECUT(I1) ) IEVETO(I1,I2) =1
20        CONTINUE
10    CONTINUE
 
      RETURN
      END
