C***********************************************************************
C*
C*====================
C* Subroutine PRUJIN
C*====================
C*
C* (Function)
C*    Job initialization for user analysis.
C* (Input & Output )
C*    none.
C* (Relation)
C*    Called from FLANLI
C* (Update Record)
C*    5/29/87  K.Fujii             Original version.
C*
C***********************************************************************
 
      SUBROUTINE PRUJIN
 
      PARAMETER     ( MXxHPK = 800000 )
      COMMON /PAWC/ M(MXxHPK)
C
C========< Entry Point >================================================
C
C--
C  Write user production version #.
C--
      CALL PRPVRS( 'USER:', 001, 900423)
C--
C  Initialize plot buffer.
C--
      CALL HINIT(MXxHPK)
C--
C  Choose appropriate options.
C--
      CALL DOPT('NCALLS',.TRUE.)
      CALL DOPT('L2ZAUT',.TRUE.)
      CALL DOPT('L2COL',2)
C     CALL DOPT('L2COL',1)
C     CALL DOPT('L2SYM',16)
      CALL DOPT('YZERO',.TRUE.)
      CALL HOPTN('STAT',.TRUE.)
      CALL HOPTN('HOMIT',.TRUE.)
C--
C  Initialize hists and plots.
C--
      CALL HDEF1(  1,'I*4', 20,  0.,1.0     ,  'Cut statistics      @')
      CALL HDEF1(  2,'I*4',100,  0.,1.0     ,  '# lepton tracks     @')
      CALL HDEF1(  3,'I*4',100,  0.,1.0     ,  '# gamma tracks      @')
      CALL HDEF1(  4,'I*4',100,  0.,1.0     ,  '# hadron tracks     @')
      CALL HDEF1(  5,'I*4',100,  0.,2.0     ,  '# good tracks       @')
      CALL HDEF1(  6,'I*4',100,  0.,1.0     ,  '# combinations      @')
      CALL HDEF1(  7,'I*4',150,240.,2.0     ,  'm(t-t_bar) w/cuts   @')
      CALL HDEF1(  8,'I*4',100,  0.,2.0     ,  'Pt                  @')
      CALL HDEF1(  9,'I*4', 50,  0.,1.0     ,  'NTRY(y_cut)         @')
      CALL HDEF1( 10,'I*4',100,  0.,2.E-4   ,  'y_cut(6-jet)        @')
      CALL HDEF1( 11,'I*4',100,  0.,1.0     ,  '# tt combinations   @')
C     CALL HDEF1( 12,'EFF', 20,  1.,1.0     ,  ' 2-jet fracton      @')
C     CALL HDEF1( 13,'EFF', 20,  1.,1.0     ,  ' 3-jet fracton      @')
C     CALL HDEF1( 14,'EFF', 20,  1.,1.0     ,  ' 4-jet fracton      @')
      CALL HDEF1( 15,'EFF', 20,  1.,1.0     ,  ' 5-jet fracton      @')
      CALL HDEF1( 16,'EFF', 20,  1.,1.0     ,  ' 6-jet fracton      @')
      CALL HDEF1( 17,'EFF', 20,  1.,1.0     ,  ' 7-jet fracton      @')
      CALL HDEF1( 18,'EFF', 20,  1.,1.0     ,  ' 8-jet fracton      @')
      CALL HDEF1( 19,'EFF', 20,  1.,1.0     ,  ' 9-jet fracton      @')
      CALL HDEF1( 20,'EFF', 20,  1.,1.0     ,  '10-jet fracton      @')
      CALL HDEF1( 21,'I*4',240, 20.,0.5     ,  'm(W) final          @')
      CALL HDEF1( 23,'I*4',150,240.,2.0     ,  'm(t-t_bar) final    @')
      CALL HDEF1( 24,'I*4',100, -1.,0.02    ,  'cos(theta_t) final  @')
      CALL HDEF1( 25,'I*4',200,  0.,0.25    ,  'Pt final            @')
      CALL HDEF1( 26,'I*4',100,  0.,0.5     ,  'Chi**2 final        @')
      CALL HDEF1( 27,'I*4',100,  0.,0.01    ,  'Thrust final-1      @')
      CALL HDEF1( 28,'I*4',100,  0.,2.E-4   ,  'y_cut(6-jet) final  @')
      CALL HDEF1( 29,'I*4',100, -1.,0.02    ,  'CSBWG               @')
      CALL HDEF1( 30,'I*4',100, -1.,0.02    ,  'cos(jet)_max        @')
      CALL HDEF1( 31,'I*4',100,  0.,1.0     ,  '# lepton E>ELPLCT   @')
      CALL HDEF1( 32,'I*4',200,-20.,0.2     ,  'APT1-APT2           @')
      CALL HDEF1( 33,'I*4',500,  0.,0.002   ,  'cos(jet-p_miss)_max @')
      CALL HDEF1( 34,'I*4',500,  0.,0.002   ,  'cos(jet-jet)_max    @')
      CALL HDEF1( 35,'I*4',100,  0.,0.005   ,  'RCSBW               @')
      CALL HDEF1( 36,'I*4',500,  0.,0.002   ,  'CJMMX w/ PTM cut    @')
      CALL HDEF1( 37,'I*4',500,  0.,0.002   ,  'Sum(CSGR-1)**2_min  @')
      CALL HDEF1( 38,'I*4', 20,  0.,1.0     ,  '# neutrinos (GN).   @')
      CALL HDEF1( 39,'I*4', 20,  0.,1.0     ,  '# b-jets.           @')
      CALL HDEF1( 41,'I*4',500,  0.,0.002   ,  'CSJJMX best right   @')
      CALL HDEF1( 42,'I*4', 20,  0.,1.0     ,  'NBJT   best right   @')
      CALL HDEF1( 43,'I*4',100,-1.0,0.02    ,  'CBB         right   @')
      CALL HDEF1( 44,'I*4',100,  0.,2.E-4   ,  'y_cut(6-jet) right  @')
      CALL HDEF1( 51,'I*4',500,  0.,0.002   ,  'CSJJMX best wrong   @')
      CALL HDEF1( 52,'I*4', 20,  0.,1.0     ,  'NBJT   best wrong   @')
      CALL HDEF1( 53,'I*4',100,-1.0,0.02    ,  'CBB         wrong   @')
      CALL HDEF1( 54,'I*4',100,  0.,2.E-4   ,  'y_cut(6-jet) wrong  @')
C--
      CALL HDEF2(201,'I*4',100,100, 80., 80.,2.,2., '(AMT,AMT)      @')
      CALL HDEF2(202,'I*4',100,100,30.,30., 1.0,1., '(AMW,AMW)      @')
      CALL HDEF2(204,'I*4',160,100,0.,-100., 5.0,2., '(Evis,Pl)     @')
      CALL HDEF2(205,'R*4', 40, 50,-1., 0.,.05, 1., '(CSTG,APTG)    @')
      CALL HDEF2(206,'R*4',200,200,-1.,-1.,.01,.01, '(DCB1,DCB2)    @')
      CALL HDEF2(207,'R*4',100,100,-1.,-1.,.02,.02, '(CBW1,CBW2)    @')
      CALL HDEF2(221,'I*4',100,100, 80., 80.,2.,2., '(AMT,AMT) best @')
      CALL HDEF2(223,'I*4',160,100,0.,-100., 5.0,2., '(Evis,Pl) best@')
C     CALL HDEF2(224,'I*4', 50,150,  0.,240.,.5,2., '(CH2,AMT) best @')
C     CALL HDEF2(225,'I*4',100,150,  0.,240.,2.,2., '(PT ,AMT) best @')
C     CALL HDEF2(226,'I*4', 50,150,  0.,240.,.5,2., '(CH2,AMT) 2-nd @')
C     CALL HDEF2(227,'I*4', 60, 60,240.,240.,5.,5., '(AMTT1,AMTT2)  @')
C     CALL HDEF2(228,'I*4', 60, 60,-60.,240.,2.,5.,'(DEPL,AMTT) best@')
      CALL HDEF2(229,'I*4',100,100,30.,30., 1.0,1., '(AMW,AMW) best @')
      CALL HDEF2(230,'I*4',100,100, 80., 80.,2.,2., '(MTL,MTH) best @')
      CALL HDEF2(231,'I*4', 20, 20, 0., 0.,.05,.05, '(CH1,CH2) best @')
      CALL HDEF2(232,'I*4',100,100,0.,0.,0.5,0.5,    '(P1 ,P2) best @')
      CALL HDEF2(233,'R*4',100,100,-1.,-1.,.02,.02, '(CBW1,CBW2) bst@')
C
      CALL HDEF2(243,'R*4', 40, 50,-1., 0.,.05, 1., '(CSTG,APTG) bst@')
      CALL HDEF2(244,'R*4', 40, 50,-1., 0.,.05, 1., '(CST,APT)   bst@')
      CALL HDEF2(249,'I*4', 50,150,0.,-15.,1., 0.2, '(APTG,DAPT) bst@')
      CALL HDEF2(250,'I*4', 10, 10,0.,  0.,1.,  1., '(IGEN,IBST) bst@')
      CALL HDEF2(251,'I*4', 10, 10,0.,  0.,1.,  1., '(IGEN,IBS2) bst@')
      CALL HDEF2(252,'R*4',100, 50,-1., 0.,.02, 1., '(CJJ,APT)   bst@')
      CALL HDEF2(253,'R*4',100, 50,-1., 0.,.02, 1., '(CBB,APT)   bst@')
      CALL HDEF2(254,'R*4', 20, 50, 0., 0., 1., 1., '(NBJ,APT)   bst@')
      CALL HDEF2(261,'R*4',100, 50,-1., 0.,.02, 1., '(CBB,APT)R bst @')
      CALL HDEF2(262,'R*4',100,100,-1.,-1.,.02,.02,'(CQQ1,CQQ2)R bst@')
      CALL HDEF2(263,'I*4',100,100,30.,30., 1.0,1., '(AMW,AMW)R bst @')
      CALL HDEF2(264,'I*4',100,100, 80., 80.,2.,2., '(AMT,AMT)R bst @')
      CALL HDEF2(271,'R*4',100, 50,-1., 0.,.02, 1., '(CBB,APT)W bst @')
      CALL HDEF2(272,'R*4',100,100,-1.,-1.,.02,.02,'(CQQ1,CQQ2)W bst@')
      CALL HDEF2(273,'I*4',100,100,30.,30., 1.0,1., '(AMW,AMW)W bst @')
      CALL HDEF2(274,'I*4',100,100, 80., 80.,2.,2., '(AMT,AMT)W bst @')
C--
C  That's it.
C--
      RETURN
      END
