C
C ===========================
C    Cuts for 6J Selection
C ===========================
C
C     Final cut set for threshold scan is either CUT21 or CUT22.
C     CUT21 is better, since it's BG-free and has a higher
C     efficiency. To be conservative, we use CUT22 for fear
C     VTX requires some time to properly work.
C
C        CUT20: Cuts for threshold scan(no b-tag,no thrust cut).
C        CUT21: Cuts for threshold scan(w/ b-tag,no thrust cut).
C        CUT22: Cuts for threshold scan(no b-tag,w/ thrust cut).
C--
C  Parameters for jet-clustering.
C--
      REAL*4          YCUT(0:MXxYCT)
      DATA   YCUT     / 4.0E-3,
     .                  0.5E-3, 1.0E-3, 1.5E-3, 2.0E-3, 2.5E-3,
     .                  3.0E-3, 3.5E-3, 4.0E-3, 4.5E-3, 5.0E-3,
     .                  5.5E-3, 6.0E-3, 6.5E-3, 7.0E-3, 7.5E-3,
     .                  8.0E-3, 8.5E-3, 9.0E-3, 9.5E-3, 1.0E-2 /
C--
      DATA NOMYCT     /  10  /
      DATA DYMAX      / 1.E-2/
      DATA NTRYMX     /  50  /
C--
C  Track selection.
C--
      DATA NTRKCT     /  20  /
      DATA ECUT       /  0.1 /
C--
C  Lepton cuts.
C--
      DATA ELPLCT     / 999. /
C--
C  Energy momentum balance.
C--
      DATA PTCUT      /  50. /
      DATA PLCUT      /  50. /
      DATA DEVSCT     / 100. /
      DATA EVOFF      /  10. /
C--
C  Mass cuts.
C--
      DATA AMJCUT     /  60. /
      DATA RMTCUT     /  50. /
C--
C  Angle cuts.
C--
      DATA CSJCUT     / 999. /
C--
      DATA PTMCUT     /   2. /
      DATA CSMJCT     / 999. /
C--
      DATA CSJJCT     / 999. /
C--
      DATA CSBBCT     / 999. /
C--
      DATA CSBWCT     /-0.65 /
      DATA RCBWCT     / 0.35 /
C--
C  B-tagging.
C--
      DATA NBTKCT     /    2 /
C21   DATA NBJLCT     /    1 /
C20,22
      DATA NBJLCT     /    0 /
      DATA NBJHCT     /  999 /
C--
C  Parameters for best candidate selection.
C--
      DATA AMW        / 80.0 /
      DATA AMT        / 150. /
C--
      DATA SGMV       /   4. /
      DATA SGMT       /   5. /
C--
C  Event shape cut.
C--
C20,21 DATA THRSCT     / 1.00 /
C22
      DATA THRSCT     / 0.75 /
C--
C  Cut on #ttbar candidates.
C--
      DATA NTTCUT     /  999 /
C--
C  Artificial cut knowing generator information.
C--
      DATA ICMBCT     /    0 /
