CC********************************************************************CC
C*                                                                    *C
C*=================                                                   *C
C* Subroutine FLANLI                                                  *C
C*=================                                                   *C
C*    Example for SPRING + Hadronize                                  *C
C*                                                                    *C
C*(Purpose)                                                           *C
C*    Define analysis program.                                        *C
C*(Relation)                                                          *C
C*    Called by PRMAIN.                                               *C
C*(Author)                                                            *C
C*   17-May-1990  A. Miyamoto  For Full system                        *C
C*                                                                    *C
CC********************************************************************CC
C
      SUBROUTINE FLANLI
C
#include "fldscr.inc"
C     INCLUDE (@FLDSCR)
C
C
C======< ENTRY POINT >==================================================
C
C ----------------------------------------------------------------------
C (1) Declare version number of Full module.
C ----------------------------------------------------------------------
C
      CALL PRPDSC( 'Z-Z-gamma', 101, 900528)
C
C ----------------------------------------------------------------------
C (2) Reset counters.
C ----------------------------------------------------------------------
C
      NPROG = 0
      NENTR = 0
      NHIST = 0
C
C ----------------------------------------------------------------------
C (3) Define analysis routine and calling sequence.
C ----------------------------------------------------------------------
C
C                     Define SPRING generator.
#ifdef USESPRG
      CALL DSSPRG
#endif
C                     Define Lund Hadronizer.
#ifdef USELHAD
      CALL DSLHAD
#endif
C                     Define Swimmer  routine.
#ifdef USESWIM
      CALL DSCSWM
#endif
C                     Define Smearing routine.
#ifdef USESMEAR
      CALL DSCSMR
#endif
C                     Define recover routine
#ifdef USERCV
      CALL DSRCOV
#endif
C                     Define User routine.
#ifdef USEUSER
      CALL DSCUSR
#endif
C                     Define squeez routine.
#ifdef USESQZ
      CALL DSSQUZ
#endif
      RETURN
      END
