C***********************************************************************
C*
C*====================
C* Subroutine PRUJIN
C*====================
C*
C* (Function)
C*    Job initialization for user analysis.
C* (Input & Output )
C*    none.
C* (Relation)
C*    Called from FLANLI
C* (Update Record)
C*    5/29/87  K.Fujii             Original version.
C*
C***********************************************************************
 
      SUBROUTINE PRUJIN
 
      PARAMETER     ( MXxHPK = 400000 )
      COMMON /PAWC/ M(MXxHPK)
C
C========< Entry Point >================================================
C
C--
C  Write user production version #.
C--
      CALL PRPVRS( 'USER:', 001, 900423)
C--
C  Initialize plot buffer.
C--
      CALL HINIT(MXxHPK)
C--
C  Choose appropriate options.
C--
      CALL DOPT('NCALLS',.TRUE.)
      CALL DOPT('L2ZAUT',.TRUE.)
      CALL DOPT('L2COL',2)
C     CALL DOPT('L2COL',1)
C     CALL DOPT('L2SYM',16)
      CALL DOPT('YZERO',.TRUE.)
      CALL HOPTN('STAT',.TRUE.)
      CALL HOPTN('HOMIT',.TRUE.)
C--
C  Initialize hists and plots.
C--
      CALL HDEF1(  1,'I*4', 20,  0.,1.0     ,  'Cut statistics      @')
      CALL HDEF1(  2,'I*4',100,  0.,1.0     ,  '# lepton tracks     @')
      CALL HDEF1(  3,'I*4',100,  0.,1.0     ,  '# gamma tracks      @')
      CALL HDEF1(  4,'I*4',100,  0.,1.0     ,  '# hadron tracks     @')
      CALL HDEF1(  5,'I*4',100,  0.,0.5     ,  'E_track             @')
      CALL HDEF1(  6,'I*4',100,  0.,1.0     ,  'E_cone(track)       @')
      CALL HDEF1(  7,'I*4',100,  0.,1.0     ,  'E_cone for iso-trk  @')
      CALL HDEF1(  8,'I*4', 20,  0.,1.0     ,  '# isolated leptons  @')
      CALL HDEF1(  9,'I*4',100,  0.,1.0     ,  '# tracks            @')
      CALL HDEF1( 10,'I*4',100,  0.,2.0     ,  'Pt                  @')
      CALL HDEF1( 12,'EFF', 20,  1.,1.0     ,  ' 2-jet fracton      @')
      CALL HDEF1( 13,'EFF', 20,  1.,1.0     ,  ' 3-jet fracton      @')
      CALL HDEF1( 14,'EFF', 20,  1.,1.0     ,  ' 4-jet fracton      @')
      CALL HDEF1( 15,'EFF', 20,  1.,1.0     ,  ' 5-jet fracton      @')
      CALL HDEF1( 16,'EFF', 20,  1.,1.0     ,  ' 6-jet fracton      @')
      CALL HDEF1( 17,'EFF', 20,  1.,1.0     ,  ' 7-jet fracton      @')
      CALL HDEF1( 18,'EFF', 20,  1.,1.0     ,  ' 8-jet fracton      @')
      CALL HDEF1( 19,'EFF', 20,  1.,1.0     ,  ' 9-jet fracton      @')
      CALL HDEF1( 20,'EFF', 20,  1.,1.0     ,  '10-jet fracton      @')
      CALL HDEF1( 21,'I*4', 50,  0.,1.0     ,  'NTRY(y_cut)         @')
      CALL HDEF1( 22,'I*4',100,  0.,4.E-4   ,  'y_cut(4-jet)        @')
      CALL HDEF1( 23,'I*4',100,  0.,1.0     ,  '# combinations      @')
      CALL HDEF1( 24,'I*4',150,240.,2.0     ,  'm(t-t_bar) w/cuts   @')
      CALL HDEF1( 25,'I*4',100,  0.,1.0     ,  '# tt combinations   @')
      CALL HDEF1( 26,'I*4',100,  0.,0.01    ,  'Thrust final-1      @')
      CALL HDEF1( 27,'I*4',100, -1.,0.02    ,  'cos(b-W) gen        @')
      CALL HDEF1( 28,'I*4',100,  0.,0.05    ,  'ECONE/ETRK          @')
      CALL HDEF1( 29,'I*4',100,  0.,0.05    ,  'E/P                 @')
      CALL HDEF1( 30,'I*4',100, -1.,0.02    ,  'cos(jet)_max        @')
C--
      CALL HDEF1( 31,'I*4',150,240.,2.0     ,  'm(t-t_bar) final    @')
      CALL HDEF1( 32,'I*4',100, -1.,0.02    ,  'cos(th_t_lp) final  @')
      CALL HDEF1( 33,'I*4',100, -1.,0.02    ,  'cos(th_t_hd) final  @')
      CALL HDEF1( 34,'I*4',100,  0.,1.0     ,  'Pt final            @')
      CALL HDEF1( 35,'I*4',100,  0.,0.5     ,  'Chi**2 final        @')
      CALL HDEF1( 36,'I*4',100,  0.,4.E-4   ,  'y_cut(4-jet) final  @')
      CALL HDEF1( 37,'I*4',100,  0.,0.05    ,  'E/P          final  @')
      CALL HDEF1( 38,'I*4',500,  0.,0.002   ,  'Sum(CSGR-1)**2_min  @')
      CALL HDEF1( 39,'I*4', 10,  0.,1.0     ,  '#b-jets.            @')
      CALL HDEF1( 40,'I*4',100, -1.,0.02    ,  'cos(jj)_max         @')
      CALL HDEF1( 42,'I*4', 20,  0.,1.0     ,  'NBJT   best right   @')
      CALL HDEF1( 43,'I*4',100, -1.,0.02    ,  'cos(jj)_max R bst   @')
      CALL HDEF1( 52,'I*4', 20,  0.,1.0     ,  'NBJT   best wrong   @')
      CALL HDEF1( 53,'I*4',100, -1.,0.02    ,  'cos(jj)_max W bst   @')
C--
C  2-d plots.
C--
C     CALL HDEF2(201,'I*4',100,100,0.,   0.,1.0,1.0,'(E_tk,E_cone)  @')
C     CALL HDEF2(202,'I*4',160,100,0.,-100., 5.0,2.,'(Evis,Pl)      @')
      CALL HDEF2(203,'I*4',100,100, 80., 80.,2.,2., '(AMT,AMT)      @')
      CALL HDEF2(204,'I*4',150,150,20.,20., 1.0,1., '(AMW,AMW)      @')
      CALL HDEF2(205,'R*4', 40, 50,-1., 0.,.05, 1., '(CST,APT) gen  @')
C     CALL HDEF2(206,'R*4',200,200,-1.,-1.,.01,.01, '(DCB1,DCB2)    @')
C     CALL HDEF2(207,'R*4',200,200,-1.,-1.,.01,.01, '(CSB1,CSB2) gen@')
C--
      CALL HDEF2(221,'I*4',100,100, 80., 80.,2.,2., '(AMT,AMT) best @')
      CALL HDEF2(223,'I*4',160,100,0.,-100., 5.0,2., '(Evis,Pl) best@')
      CALL HDEF2(229,'I*4',150,150,20.,20., 1.0,1., '(AMW,AMW) best @')
      CALL HDEF2(231,'I*4', 20, 20, 0., 0.,.05,.05, '(CH1,CH2) best @')
      CALL HDEF2(233,'I*4',100,100,0.,   0.,1.0,1.0,'(ELP,ECN) final@')
      CALL HDEF2(234,'R*4', 40, 40,-1.,-1.,.05,.05, '(CST,DCS) best @')
C     CALL HDEF2(235,'R*4', 40, 40,-1.,-1.,.05,.05, '(DCB,DCT) best @')
C     CALL HDEF2(236,'R*4', 40, 40,-1.,-1.,.05,.05, '(DCW,DCT) best @')
C     CALL HDEF2(237,'R*4', 40, 40,-1.,-1.,.05,.05, '(CWW,DCT) best @')
      CALL HDEF2(238,'R*4', 40, 40,-1.,-1.,.05,.05, '(CBW,DCT) best @')
      CALL HDEF2(239,'R*4', 40, 40,-1.,-1.,.05,.05, '(CBB,DCT) best @')
C     CALL HDEF2(240,'I*4',100, 50,30., 0.,1.0, 1., '(AMW,APT) best @')
C     CALL HDEF2(241,'I*4',100, 40,30.,-1.,1.,0.05, '(AMW,DCST) best@')
      CALL HDEF2(242,'I*4',100,100,30.,-1.,1.,0.02, '(AMW,CST) best @')
      CALL HDEF2(243,'R*4', 40, 50,-1., 0.,.05, 1., '(CST,APT) gen  @')
      CALL HDEF2(244,'R*4', 40, 50,-1., 0.,.05, 1., '(CST,APT) best @')
      CALL HDEF2(245,'R*4', 40, 50,-1., 0.,.05, 1., '(DCSB,APT) best@')
      CALL HDEF2(246,'R*4', 40, 40,-1.,-1.,.05,.05, '(DCB,DCW) best @')
      CALL HDEF2(247,'I*4',100, 50,30., 0.,1.0, 1., '(AMWJ,APT) best@')
      CALL HDEF2(248,'I*4',100, 40,30.,-1.,1.,0.05, '(AMWJ,DCST) bst@')
      CALL HDEF2(249,'I*4', 50,150,0.,-15.,1., 0.2, '(APTG,DAPT) bst@')
      CALL HDEF2(250,'I*4',100, 50,80., 0.,2.0, 1., '(AMTL,APT) best@')
      CALL HDEF2(251,'I*4',100, 50,80., 0.,1.0, 1., '(AMTJ,APT) best@')
      CALL HDEF2(252,'I*4', 50, 40,0., -1.,1.,0.05, '(APTG,DCST) bst@')
      CALL HDEF2(253,'I*4', 10, 10,0.,  0.,1.,  1., '(IGEN,IBST) bst@')
      CALL HDEF2(254,'I*4', 10, 10,0.,  0.,1.,  1., '(IGEN,IBS2) bst@')
      CALL HDEF2(255,'R*4',100, 50,-1., 0.,.02, 1., '(CBB,APT)   bst@')
      CALL HDEF2(256,'I*4',100, 40, 90.,-1.,1.,0.05,'(AMTJ,DCST) bst@')
C--
      CALL HDEF2(261,'R*4',100, 50,-1., 0.,.02, 1., '(CBB,APT)R bst @')
      CALL HDEF2(263,'I*4',150,150,20.,20., 1.0,1., '(AMW,AMW)R bst @')
      CALL HDEF2(264,'I*4',100,100, 80., 80.,2.,2., '(AMT,AMT)R bst @')
      CALL HDEF2(265,'I*4',100, 50,80., 0.,1.0, 1., '(AMTJ,APT)R bst@')
      CALL HDEF2(266,'I*4',100,  4,80., 0.,1.0, 1., '(AMTJ,FB )R bst@')
      CALL HDEF2(271,'R*4',100, 50,-1., 0.,.02, 1., '(CBB,APT)W bst @')
      CALL HDEF2(273,'I*4',150,150,20.,20., 1.0,1., '(AMW,AMW)W bst @')
      CALL HDEF2(274,'I*4',100,100, 80., 80.,2.,2., '(AMT,AMT)W bst @')
      CALL HDEF2(275,'I*4',100, 50,80., 0.,1.0, 1., '(AMTJ,APT)R bst@')
      CALL HDEF2(276,'I*4',100,  4,80., 0.,1.0, 1., '(AMTJ,FB )R bst@')
C--
C  That's it.
C--
      RETURN
      END
