C***********************************************************************
C*
C*====================
C* Subroutine PRUJIN
C*====================
C*
C* (Function)
C*    Job initialization for user analysis.
C* (Input & Output )
C*    none.
C* (Relation)
C*    Called from FLANLI
C* (Update Record)
C*    5/29/87  K.Fujii             Original version.
C*
C***********************************************************************
 
      SUBROUTINE PRUJIN
 
      PARAMETER     ( MXxHPK = 400000 )
      COMMON /PAWC/ M(MXxHPK)
C
C========< Entry Point >================================================
C
C--
C  Write user production version #.
C--
      CALL PRPVRS( 'USER:', 201, 950614)
C--
C  Initialize plot buffer.
C--
      CALL HINIT(MXxHPK)
C--
C  Choose appropriate options.
C--
      CALL DOPT('NCALLS',.TRUE.)
      CALL DOPT('L2ZAUT',.TRUE.)
      CALL DOPT('L2COL',2)
C     CALL DOPT('L2COL',1)
C     CALL DOPT('L2SYM',16)
      CALL DOPT('YZERO',.TRUE.)
      CALL HOPTN('STAT',.TRUE.)
      CALL HOPTN('HOMIT',.TRUE.)
C--
C  Initialize hists and plots.
C--
      CALL HDEF1(  1,'I*4', 20,  0.,1.0     ,  'Cut statistics      @')
      CALL HDEF1(  2,'I*4',200,  0.,5.0     ,  '# all tracks        @')
      CALL HDEF1(  3,'I*4',100,  0.,1.0     ,  '# charged tracks    @')
      CALL HDEF1(  4,'I*4',200,  0.,1.0     ,  '# EM clusters       @')
      CALL HDEF1(  5,'I*4',200,  0.,1.0     ,  '# HD clusters       @')
      CALL HDEF1(  6,'I*4',200,  0.,1.0     ,  '# combinations      @')
      CALL HDEF1(  7,'I*4',100,200.,5.0     ,  'm(t-t_bar) w/cuts   @')
      CALL HDEF1(  8,'I*4',100,  0.,2.0     ,  'Pt                  @')
      CALL HDEF1(  9,'I*4', 50,  0.,1.0     ,  'NTRY(y_cut)         @')
      CALL HDEF1( 10,'I*4',100,  0.,4.E-5   ,  'y_cut(8-jet)        @')
      CALL HDEF1( 11,'I*4',100,  0.,1.0     ,  '# tt combinations   @')
C      CALL HDEF1( 12,'EFF', 20,  1.,1.0     ,  ' 2-jet fracton      @')
C      CALL HDEF1( 13,'EFF', 20,  1.,1.0     ,  ' 3-jet fracton      @')
C      CALL HDEF1( 14,'EFF', 20,  1.,1.0     ,  ' 4-jet fracton      @')
      CALL HDEF1( 15,'EFF', 20,  1.,1.0     ,  ' 5-jet fracton      @')
      CALL HDEF1( 16,'EFF', 20,  1.,1.0     ,  ' 6-jet fracton      @')
      CALL HDEF1( 17,'EFF', 20,  1.,1.0     ,  ' 7-jet fracton      @')
      CALL HDEF1( 18,'EFF', 20,  1.,1.0     ,  ' 8-jet fracton      @')
      CALL HDEF1( 19,'EFF', 20,  1.,1.0     ,  ' 9-jet fracton      @')
      CALL HDEF1( 20,'EFF', 20,  1.,1.0     ,  '10-jet fracton      @')
      CALL HDEF1( 21,'I*4',100, 60.,0.5     ,  'm(W) final          @')
      CALL HDEF1( 22,'I*4',100, 60.,0.5     ,  'm(Z) final          @')
      CALL HDEF1( 23,'I*4',100,200.,5.0     ,  'm(t-t_bar) final    @')
      CALL HDEF1( 24,'I*4',100, -1.,0.02    ,  'cos(theta_t) final  @')
      CALL HDEF1( 25,'I*4',100,  0.,1.0     ,  'Pt final            @')
      CALL HDEF1( 26,'I*4',100,  0.,0.5     ,  'Chi**2 final        @')
      CALL HDEF1( 27,'I*4',100,200.,5.0     ,  'm(t-t_bar) gen      @')
C--
      CALL HDEF2(201,'I*4',100,100, 80., 80.,2.,2., '(AMT,AMT)      @')
      CALL HDEF2(202,'I*4',100,100,30.,30., 1.0,1., '(AMW,AMW)      @')
      CALL HDEF2(203,'I*4',100,100,30.,30., 1.0,1.,  '(AMW,AMZ)     @')
      CALL HDEF2(204,'I*4',160,100,0.,-250., 5.0,5., '(Evis,Pl)     @')
      CALL HDEF2(221,'I*4',100,100, 80., 80.,2.,2., '(AMT,AMT) best @')
      CALL HDEF2(222,'I*4', 50,100,-1., 80.,.04,2., '(CSZ,EZ)  best @')
      CALL HDEF2(223,'I*4',160,100,0.,-250., 5.0,5., '(Evis,Pl) best@')
      CALL HDEF2(224,'I*4', 50,100,  0.,200.,.5,5., '(CH2,AMTT) best@')
      CALL HDEF2(225,'I*4',100,100,  0.,200.,2.,5., '(PT ,AMTT) best@')
      CALL HDEF2(226,'I*4', 50,100,  0.,200.,.5,5., '(CH2,AMTT) 2-nd@')
      CALL HDEF2(227,'I*4',100,100,200.,200.,5.,5., '(AMTT1,AMTT2)  @')
      CALL HDEF2(228,'I*4', 60,100,-200.,200.,5.,5.,'(DEPL,AMTT)best@')
      CALL HDEF2(229,'I*4',100,100,30.,30., 1.0,1., '(AMW,AMW) best @')
      CALL HDEF2(230,'I*4',100,100,30.,30., 1.0,1., '(AMW,AMZ) best @')
C--
C  That's it.
C--
      RETURN
      END
