      IMPLICIT    REAL*4  ( A-H, O-Z )
C--
      REAL*4     RS, CS, PHI, SG
      PARAMETER  ( NHEL = 4 )
      INTEGER*4  IHEL(4,NHEL,2)
      DATA IHEL  / -1, +1, -1, -1,
     .             -1, +1, -1, +1,
     .		   -1, +1, +1, -1,
     .             -1, +1, +1, +1,
     .             +1, -1, -1, -1,
     .             +1, -1, -1, +1,
     .		   +1, -1, +1, -1,
     .             +1, -1, +1, +1/
C--
      CHARACTER*20 PATRN(1:4)
      DATA PATRN  / '0.01 0.05 0.01' ,
     .              '0.2 0.05 0.01 0.05',
     .              '0.2 0.05',
     .              '0.01 0.05 0.01' /
      CHARACTER*9 JOIN(1:4)
      DATA JOIN   / 'PATTERNED',
     .              'PATTERNED',
     .              'PATTERNED',
     .              'PATTERNED'/
      DATA LOU / 20 /
C--
      REAL*4         XYDAT(2,0:1000)
C
C========< Entry Point >================================================
C
C--
C  Differential cross section.
C--
      WRITE(LOU,'(''SET FONT DUPLEX'')')
      WRITE(LOU,'(''NEW FRAME'')')
      WRITE(LOU,'(''SET WINDOW X 2 10 Y 2 8'')')
      WRITE(LOU,'(''SET LIMITS X -1. 1. Y 0. 0.100'')')
      WRITE(LOU,'(''(SET LIMITS X -1. 1. Y 0.001 10.'')')
      WRITE(LOU,'(''(SET SCALE Y LOGARITHMIC'')')
      WRITE(LOU,'(''SET LABELS SIZE 2.5'')')
      WRITE(LOU,'(''SET TITLE  SIZE 4.0'')')
      WRITE(LOU,'(''TITLE 5.7 1.2 ''''cos Q'')')
      WRITE(LOU,'(''CASE          ''''    G'')')
      WRITE(LOU,'(''TITLE 0.2 3.7 ANGLE 90.'',
     .                            '' ''''dS/dW (pb)'')')
      WRITE(LOU,'(''CASE          '''' G  F     '')')
C--
C  Standard Model parameters.
C--
      x2PI  = 2*ACOS(-1.)
      ALFI  = 128.
      ALFS  = 0.12
      AMSW  = 80
      AMSZ  = 91.19
      AMSH  = 1.E5
      AMST  = 150
      ALF   = 1/ALFI
      CALL INSMCN(ALF,ALFS,AMSW,AMSZ,AMSH,AMST)
C--
C  Angular region for plot.
C     CSMN = cos(theta)_min
C     CSMX = cos(theta)_max
C--
      CSMN = -1
      CSMX = -CSMN
      NCS  = 100
      DCS  = (CSMX-CSMN)/NCS
      PHI  = 0.
C--
C  Set sqrt(s) and polarization.
C--
      RS   = 400.
C--
C  Loop over cos(theta).
C--
      DO 2000 IHE = 1, 2
         SGSUM = 0
         CALL UVZERO(2*(NCS+1),XYDAT)
         DO 100 ICASE = 1, 4
            WRITE(LOU,'(''( IHE, IHT = '',2I2)') IHE, ICASE
            SGSM = 0
            WRITE(LOU,'(''SET ORDER X Y '')')
            DO 10   ICS = 0, NCS
               CS = CSMN + DCS*ICS
               CALL DSGTT(RS,IHEL(1,ICASE,IHE),CS,PHI,SG)
               WRITE(LOU,'(2E15.5)') CS, SG
               SGSM = SGSM + SG
               XYDAT(1,ICS) = CS
               XYDAT(2,ICS) = XYDAT(2,ICS) + SG
10          CONTINUE
            WRITE(LOU,'(''SET PATTERN '',A20)') PATRN(ICASE)
            WRITE(LOU,'(''JOIN '',A9)') JOIN(ICASE)
            WRITE(LOU,'(''( sqrt<s> ='',F8.1,
     .                     '' sigma = '',E15.5,'' pb'')')
     .                     RS, SGSM*x2PI*DCS
            SGSUM = SGSUM + SGSM*x2PI*DCS
100      CONTINUE
C--
         WRITE(LOU,'(''( All IHE = '',I2)') IHE
         WRITE(LOU,'(''SET ORDER X Y '')')
         DO 200 ICS = 0, NCS
            WRITE(LOU,'(2E15.5)') XYDAT(1,ICS), XYDAT(2,ICS)
200      CONTINUE
         WRITE(LOU,'(''JOIN SOLID'')')
         WRITE(LOU,'(''( sqrt<s> ='',F8.1,
     .                     '' sigma = '',E15.5,'' pb'')')
     .                     RS, SGSUM
2000  CONTINUE
C--
      STOP
      END
