C*
C* (Update Record)
C*   95/Oct/14  T.Tsukamoto		Modified for BASES25.
C*   96/Mar/08  K.Fujii			Modified for BASES5.1.
C*
      SUBROUTINE USERIN
 
C ....................................................................
C
C          E(+) E(-) INTO E(+) E(-) MU(+) MU(-)
C                                                        20 JAN. 1986
C
C          EXACT CALCULATION
C          CROSS SECTION IN NB =10**(-33) CM**2
C
C......................................................................
 
      IMPLICIT REAL*8(A-H,O-Z)
C--
C  Bases's commons.
C--
      PARAMETER (MXDIM = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,IG(MXDIM),NCALL
      COMMON /BPARM2/ ACC1,ACC2,ITMX1,ITMX2
      INTEGER*4       NDIM, NWILD, IG, NCALL, ITMX1, ITMX2
      REAL   *8       XL, XU, ACC1, ACC2
=EXPAND 'BASESV51/BS51PR.inc'
=EXPAND 'BASESV51/BSITPR.inc'
C--
C  User's commons.
C--
=EXPAND 'dkin_lib/USMPRM.inc'
=EXPAND 'dkin_lib/SMCONS.inc'
=EXPAND 'dkin_lib/SMPTAB.inc'
      INCLUDE 'USRPRM.inc'
      INCLUDE 'KINEM.inc'
      INCLUDE 'CUTS.inc'
C--
C  Local arrays.
C--
      REAL   *8    QF(3,2,2)
C
C========< Entry Point >================================================
C
C--
C  Set fermion charge: QF(IG,IT,LQ), where
C     IG = generation number
C     IT = (1,2) = (up-type,down-type)
C     LQ = (1,2) = (lepton,quark)
C--
      DO 10 IGN = 1, 3
         QF(IGN,1,1) =  0
         QF(IGN,2,1) = -1
         QF(IGN,1,2) =  2.D0/3
         QF(IGN,2,2) = -1.D0/3
10    CONTINUE
C--
C  Check if inputs from FT05 are consistent with those used in the
C  integration step, when NGETBS = 1. Otherwise, Write the inputs 
C  to 'BASES:Inputs'.
C--
      CALL SPPARM
C--
C  Initialize constants. 
C--
      ALF    = 1/ALFI
      CALL INSMCN(ALF,DBLE(ALFS),DBLE(AMSW),DBLE(AMSZ),
     .                           DBLE(AMSH),DBLE(AMST))
C--
      CE     = SQRT(4*xPI*ALF)
      EM     = AMF(1,2,1)
C--
C  Set the charge and mass of the final-state fermions.
C--
      CHARGE = QF (IGFR,ITFR,LQFR)
      UM     = AMF(IGFR,ITFR,LQFR)
C--
C  Center of mass energy.
C--
      W      = SQRTS
      E      = W/2
      S      = W*W
C--
C  Derived quantities.
C--
      CE8    = CE**8
C--
      EME    = EM/E
      EME2   = EME**2
      EME4   = EME2**2
      EME6   = EME2*EME4
      EME8   = EME**8
C--
      UME    = UM/E
      UME2   = UME**2
      UME4   = UME2**2
      UME6   = UME2*UME4
      UME8   = UME4**2
C--
      BETHA  = SQRT((1+EME)*(1-EME))
      FACT   = CE8/(4*E**2*(2*xPI)**7)*xGV2PB/BETHA
C--
C  Cuts.
C--
C e+
      PCUT    = PECT
      PCUT    = PCUT/E
      CTAGL_2 = CECL
      CTAGU_2 = CECU
C e-
      PTAGC   = PPCT
      PTAGC   = PTAGC/E
      CTAGL_1 = CPCL
      CTAGU_1 = CPCU
C f
      PMUCUT  = PFCT
      PMUCUT  = PMUCUT/E
      CMUCUT  = CFCT
      WMIN    = WMNF
      WMIN    = WMIN/E
C--
      PRINT *, ' ******< Job constants >*********** '
      PRINT *, '  '
      PRINT *, '     W      = ', W, ' GeV'
C      PRINT *, '     SGEBM  = ', SGEBM
C      PRINT *, '     POLE   = ', POLE
C      PRINT *, '     ISRBM  = ', ISRBM
      PRINT *, '     CHARGE = ', CHARGE
      PRINT *, '     UM     = ', UM, ' GeV'
      PRINT *, '  '
      PRINT *, ' ********************************** '
C--
C  Set BASES constants.
C--
      NDIM   = 7
      NWILD  = 7
      NCALL  = NCAL
      ITMX1  = ITM1
      ITMX2  = ITM2
C--
C  Set lower and upper limits for integration variables.
C--
      XL(1)  = 0.0D0
      XU(1)  = 1.0D0
      XL(2)  = -1.0D0
      XU(2)  = 1.0D0
      XL(3)  = 0.0D0
      XU(3)  = 2*xPI
      XL(4)  = 0.0D0
      XU(4)  = 1.0D0
      XL(5)  = 0.0D0
      XU(5)  = 1.0D0
      XL(6)  = 0.0D0
      XU(6)  = 1.0D0
      XL(7)  = 0.0D0
      XU(7)  = 1.0D0
C--
C  Define hists. and plots.
C--
      CALL XHINIT(1, -1.D0,  1.D0, 50, 'E-  COS1 DISTRIBUTION    ')
      CALL XHINIT(2, -1.D0,  1.D0, 50, 'E+  COS2 DISTRIBUTION    ')
      CALL XHINIT(3,  0.D0,  1.D0, 50, 'E-  ENERGY DISTRIBUTION  ')
      CALL XHINIT(4,  0.D0,  1.D0, 50, 'E+  ENERGY DISTRIBUTION  ')
      CALL XHINIT(5,  0.D0,  4.D0, 50, 'MU-PAIR INVARIANT MASS**2')
      CALL XHINIT(6, -1.D0,  1.D0, 50, 'MU- ANGLE DISTRIBUTION   ')
      CALL XHINIT(7,  0.D0,  1.D0, 50, 'MU- ENERGY DISTRIBUTION  ')
      CALL XHINIT(8,  0.D0,  2.D0, 40,
     .                           'MU-PAIR INVARIANT MASS(SCALED) ')
      CALL XHINIT(9, 0.D0, E/2,40,
     .                           'MU-PAIR INVARIANT MASS(GeV)    ')
C--
C  That's it.
C--
       RETURN
       END
