C* (Update Record)
C*   95/04/29  K.Fujii		Original version for EEWW.
C*

      SUBROUTINE USERIN
 
      IMPLICIT REAL*8 (A-H,O-Z)
C--
      PARAMETER (MXDIM = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,IG(MXDIM),NCALL
      COMMON /BPARM2/ ACC1,ACC2,ITMX1,ITMX2
C--
      INCLUDE 'EEWWCNF.inc'
      INCLUDE 'USRPRM.inc'
=EXPAND 'dkin_lib/USMPRM.inc'
=EXPAND 'dkin_lib/BEMCNS.inc'
=EXPAND 'BASESV51/BSHUFL.inc'
=EXPAND 'BASESV51/BSITPR.inc'
C--
C  Local R*4 variables used in subroutine calls.
C--
      REAL*8        ALF
C--
      INTEGER*4     JSHUFL(14,3)
      DATA JSHUFL / 4, 5, 6, 7, 8, 11, 12, 13, 14,  0,  0,  0,  0,  0,
     .              3, 4, 5, 6, 7,  8, 11, 12, 13, 14,  0,  0,  0,  0,
     .              1, 2, 3, 4, 5,  6,  7,  8, 11, 12, 13, 14, 20, 21/     
C
C========< Entry Point >================================================
C
C--
C  Check if inputs from FT05 are consistent with those used in the
C  integration step, when NGETBS = 1. Otherwise, Write the inputs 
C  to 'BASES:Inputs'.
C--
      CALL SPPARM
C--
C  Initialize numerical constants and particle table.
C--
      ALF   = 1/ALFI
      CALL INSMCN(ALF,DBLE(ALFS),DBLE(AMSW),DBLE(AMSZ),
     .                           DBLE(AMSH),DBLE(AMST))
C--
C  Set user constants.
C--
      ROOTS  = SQRTS
      SGEBM  = SGMEBM
      POLE   = POLEBM
      ISRBM  = ISRB
      PRINT *, ' ******< Job constants >*********** '
      PRINT *, '  '
      PRINT *, '     ROOTS  = ', ROOTS
      PRINT *, '     SGEBM  = ', SGEBM
      PRINT *, '     POLE   = ', POLE
      PRINT *, '     ISRBM  = ', ISRBM
      PRINT *, '  '
      PRINT *, ' ********************************** '
C--
C  Set BASES constants.
C--
      IF ( ISRBM.EQ.1 ) THEN
         NDIM   = 9
         NWILD  = 8
      ELSE IF ( ISRBM.EQ.2 ) THEN
         NDIM   = 10
         NWILD  = 9
      ELSE IF ( ISRBM.EQ.3 ) THEN
         NDIM   = 14
         NWILD  = 11
      ELSE
         PRINT *, ' >>> USERIN : Invalid ISRBM = ', ISRBM
         PRINT *, '   Will STOP immediately. '
         STOP
      ENDIF
C>>>
      CALL UVCOPY(NDIM,JSHUFL(1,ISRBM),ISHUFL)
      NOIG = NWILD + 1
C      NOIG = 999
C>>>
C--
      NZZ = NDIM
C--
      NCALL  = NCAL
      ITMX1  = ITM1
      ITMX2  = ITM2    
C--
C  Set lower and upper limits.
C--
      DO 100 IX = 1, NDIM
         XL(IX) = 0
         XU(IX) = 1
         IF ( IX.GE.NOIG ) IG(IX) = 0
100   CONTINUE
C--
C  Define hists. and plots.
C--
      CALL XHINIT( 1,   0.D0, 1.0D0, 50,'E_1/E_bm      ')
      CALL XHINIT( 2, -1.0D0, 1.0D0, 50,'cos_1         ')
      CALL XHINIT( 3,  0.0D0,360.D0, 50,'phi_1         ')
      CALL XHINIT( 4,   0.D0, 1.0D0, 50,'E_2/E_bm      ')
      CALL XHINIT( 5, -1.0D0, 1.0D0, 50,'cos_2         ')
      CALL XHINIT( 6,  0.0D0,360.D0, 50,'phi_2-phi_1   ')
      CALL XHINIT( 7,   0.D0, 1.0D0, 50,'WW/ROOTS      ')
      CALL XHINIT( 8, -1.0D0, 1.0D0, 50,'cos_W-        ')
      CALL XHINIT( 9,  0.0D0,360.D0, 50,'phi_W-        ')
      CALL XHINIT(16,  0.0D0, 1.0D0, 50,'RS/ROOTS      ')
      CALL XHINIT(18,  1.0D0,17.0D0, 16,'helicity      ')
      CALL XHINIT(19, -20.D0,20.0D0, 50,'eta_1         ')
      CALL XHINIT(20, -20.D0,20.0D0, 50,'eta_2         ')
      CALL XHINIT(21,   0.D0, 1.0D0, 50,'PT_W-/E_bm    ')
      CALL XHINIT(22,   0.D0, 1.0D0, 50,'PT_W+/E_bm    ')
      CALL XHINIT(23,   0.D0, 1.0D0, 50,'E_1/E_bm      ')
      CALL XHINIT(24,   0.D0, 1.0D0, 50,'E_2/E_bm      ')
      CALL XHINIT(25,   0.D0, 1.0D0, 50,'E_W-/E_bm     ')
      CALL XHINIT(26,   0.D0, 1.0D0, 50,'E_W+/E_bm     ')
C--
C  That's it.
C--
      RETURN
      END
