C*
C*  Differential cross section for e+e- --> W+ W-.
C*    RS = sqrt(S)
C*
C*  95/03/12  K.Fujii	Test version for HELAS V204.
C*
      IMPLICIT    REAL*4  ( A-H, O-Z )
C--
      REAL   *4  GAL(2), GAU(2), GAD(2), GWF(2), GZN(2), GZL(2), GZU(2),
     .           GZD(2), G1(2), GW, GWWZ, GWWA
C--
      REAL   *4  SG(0:2)
C--
      DATA LOU / 20 /
C
C========< Entry Point >================================================
C
C--
C  Differential cross section.
C--
      WRITE(LOU,'(''SET FONT DUPLEX'')')
      WRITE(LOU,'(''NEW FRAME'')')
      WRITE(LOU,'(''SET WINDOW X 2 10 Y 2 8'')')
      WRITE(LOU,'(''SET LIMITS X -1. 1. Y 0. 0.03'')')
      WRITE(LOU,'(''(SET LIMITS X -1. 1. Y 0.001 10.'')')
      WRITE(LOU,'(''(SET SCALE Y LOGARITHMIC'')')
      WRITE(LOU,'(''SET LABELS SIZE 3.0'')')
      WRITE(LOU,'(''SET TITLE  SIZE 4.0'')')
      WRITE(LOU,'(''TITLE   6. 7.5 SIZE 2.5'',
     .            '' '''' e2+3e2-3 --> W2+3W2-3'')')
      WRITE(LOU,'(''CASE                   '',
     .            '' ''''  X X X X      X X X X'')')
      WRITE(LOU,'(''TITLE 5.7 1.2 ''''cos Q'')')
      WRITE(LOU,'(''CASE          ''''    G'')')
      WRITE(LOU,'(''TITLE 0.2 3.7 ANGLE 90.'',
     .                            '' ''''dS/dW (pb)'')')
      WRITE(LOU,'(''CASE          '''' G  F     '')')
      WRITE(LOU,'(''SET ORDER X Y'')')
C--
C  Define constants.
C--
      x2PI      = 2*ACOS(-1.)
      x4PI      = 2*x2PI
      xSIN2W    = 0.23
      xCOS2W    = 1 - xSIN2W
      xSINW     = SQRT(xSIN2W)
      xCOSW     = SQRT(xCOS2W)

      ALF       = 1.D0/128D0
      SN2W      = 0.23
      AMZ       = 91.1
      AMW       = 80.0
      GMZ       = 2.5
      CALL UHCUPL(ALF,SN2W, GAL,GAU,GAD,GWF,GZN,GZL,GZU,GZD,G1,
     .            GW,GWWZ,GWWA)
C--
C  Angular region for plot.
C--
      CSMN = -1
      CSMX = -CSMN
      NCS  = 100
      DCS  = (CSMX-CSMN)/NCS
      PHI  = 0.
C--
C  Set sqrt(s).
C--
      RS        = 500.
      POL       = 0.
C--
C  Calculate dsg/dcosth. 
C--
      SGSM = 0
      DO 10   ICS = 0, NCS
         CS = CSMN + DCS*ICS
         CALL SGWWH(GAL,GZL,GWF,GW,AMZ,GMZ,AMW,
     .              RS, POL, CS, PHI, SG)
         WRITE(LOU,'(2E15.5)') CS, SG(0)
C        WRITE(6,*) CS, SG
         SGSM = SGSM + SG(0)
10    CONTINUE
      WRITE(LOU,'(''JOIN'')')
      WRITE(LOU,'(''( sqrt<s> ='',F8.0,
     .               '' sigma = '',E15.5,'' pb'')')
     .                  RS, SGSM*x2PI*DCS
C--
C  That's it.
C--
      STOP
      END
