 
      SUBROUTINE SGWWH(GAL,GZL,GWF,GW,AMZ,GMZ,AMW,
     .                 RS, POL, CSTH, PHI, SG)
 
      IMPLICIT   REAL*4  ( A-H, O-Z )
      REAL   *4  GAL(2), GZL(2), GWF(2), GW, AMZ, GMZ, AMW
      REAL   *4  RS, POL, CSTH, PHI, SG(0:2)
C--
      INTEGER*4  IHEL(4,9,2)
      DATA IHEL  / -1, +1, -1, -1,
     .             -1, +1, -1,  0,
     .             -1, +1, -1, +1,
     .             -1, +1,  0, -1,
     .             -1, +1,  0,  0,
     .             -1, +1,  0, +1,
     .             -1, +1, +1, -1,
     .             -1, +1, +1,  0,
     .             -1, +1, +1, +1,
     .             +1, -1, -1, -1,
     .             +1, -1, -1,  0,
     .             +1, -1, -1, +1,
     .             +1, -1,  0, -1,
     .             +1, -1,  0,  0,
     .             +1, -1,  0, +1,
     .             +1, -1, +1, -1,
     .             +1, -1, +1,  0,
     .             +1, -1, +1, +1/
      REAL   *4  PV(0:3,4)
      REAL   *4  AMP2(0:2)
      DATA NCALL / 0 /
C--
C  Statement function.
C--
      BETA(X1,X2) = SQRT( 1 - 2*(X1+X2) + (X1-X2)**2 )
C
C========< Entry Point >================================================
C
C--
C  Constants.
C--
      IF ( NCALL.EQ.0 ) THEN
         NCALL  = 1
         NHL    = 2
         SPIN   = 2*NHL
         NB     = 1
         xGV2PB = 3.893796623D8
         xPI    = ACOS(-1.D0)
         x2PI   = 2*xPI
         x4PI   = 2*x2PI
         FACT   = xGV2PB*x2PI/(x4PI**(3*NB))/SPIN
         AME    = 0.511E-3
      ENDIF
C--
C  Set 4-momenta.
C--
      CALL UVZERO(16,PV)
C
C-- e- + e+ --> CM.
C
      S       = RS*RS
      EBM     = RS/2
      PBM     = SQRT((EBM-AME)*(EBM+AME))
      BT0     = PBM/EBM
      PV(0,1) = EBM
      PV(3,1) = PBM
      CALL PMIRRx(PV(0,1),PV(0,2))
C
C-- CM --> W- + W+.
C
      BT1 = BETA(AMW**2/S,AMW**2/S)
      PW  = EBM*BT1
      EW  = SQRT(AMW**2+PW**2)
      CALL MOMNTx(EW,AMW, CSTH,PHI,PV(0,3))
      CALL PMIRRx(PV(0,3),PV(0,4))
C--
C  Calculate phase space weight.
C--
      WAT = FACT*BT1/(2*S*BT0)
C--
C  Calculate amplitude squared.
C--
      CALL UVZERO(3,SG)
      DO 100 IEHL = 1, NHL
         IF ( IEHL.EQ.1 ) THEN
            WT = 1 - POL
         ELSE
            WT = 1 + POL
         ENDIF
         DO 10 IXHL = 1, 9
            CALL TTAWWH(GAL,GZL,GWF,GW,AMZ,GMZ,AMW,
     .                  IHEL(1,IXHL,IEHL), PV, AMP2)
            SG(0) = SG(0) + AMP2(0)*WT
            SG(1) = SG(1) + AMP2(1)*WT
            SG(2) = SG(2) + AMP2(2)*WT
10       CONTINUE
100   CONTINUE
C--
C  Differenctial cross section.
C--
      SG(0) = SG(0)*WAT
      SG(1) = SG(1)*WAT
      SG(2) = SG(2)*WAT
C--
C  That's it.
C--
      RETURN
      END
