C* (Update Record)
C*  95/03/12  K.Fujii	Converted to unix. This version
C*			uses the new INSMCN in xcxc_lib.
C*  95/03/21  K.Fujii	Now calls SPPARM.
C*

      SUBROUTINE USERIN
  
      IMPLICIT REAL*8 (A-H,O-Z)
C--
      PARAMETER (MXDIM = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,IG(MXDIM),NCALL
      COMMON /BPARM2/ ACC1,ACC2,ITMX1,ITMX2
C--
      INCLUDE 'WWCNSF.inc'
      INCLUDE 'USRPRM.inc'
=EXPAND 'gen_lib/sm/USMPRM.inc'
=EXPAND 'gen_lib/sm/BEMCNS.inc'
=EXPAND 'BASESV51/BSHUFL.inc'
=EXPAND 'BASESV51/BSITPR.inc'
C--
C  Local R*4 variables used in subroutine calls.
C--
      REAL*4        ALF
C
C========< Entry Point >================================================
C
C--
C  Check if inputs from FT05 are consistent with those used in the
C  integration step, when NGETBS = 1. Otherwise, Write the inputs 
C  to 'BASES:Inputs'.
C--
      CALL SPPARM
C--
C  Initialize numerical constants and particle table.
C--
      ALF   = 1/ALFI
      CALL INSMCN(ALF,ALFS,AMSW,AMSZ,AMSH,AMST)
C--
C  Set user constants.
C--
      ROOTS  = SQRTS
      POLE   = POLEBM
      SGEBM  = SGMEBM
      ISRBM  = ISRB
      IMD1MN = IMD1LO
      IMD1MX = IMD1HI
      IMD2MN = IMD2LO
      IMD2MX = IMD2HI
      PRINT *, ' ******< Job constants >*********** '
      PRINT *, '  '
      PRINT *, '     ROOTS  = ', ROOTS
      PRINT *, '     SGEBM  = ', SGEBM
      PRINT *, '     POLE   = ', POLE
      PRINT *, '     ISRBM  = ', ISRBM
      PRINT *, '     IMD1MN = ', IMD1MN
      PRINT *, '     IMD1MX = ', IMD1MX      
      PRINT *, '     IMD2MN = ', IMD2MN
      PRINT *, '     IMD2MX = ', IMD2MX      
      PRINT *, '  '
      PRINT *, ' ********************************** '
C--
      IF ( ROOTS.LT.AMSW+AMSW ) THEN
         PRINT *, ' ROOTS is too small. '
         PRINT *, '    AMW = ', AMSW
         PRINT *, '    AMZ = ', AMSZ
      ENDIF
C--
C  Set BASES constants.
C--
      IF ( ISRBM.EQ.1 ) THEN
         NDIM   = 10
         NWILD  = 4
         IOFF   = 5
      ELSE IF ( ISRBM.EQ.2 ) THEN
         NDIM   = 11
         NWILD  = 5
         IOFF   = 4
      ELSE IF ( ISRBM.EQ.3 ) THEN
         NDIM   = 15
         NWILD  = 9
         IOFF   = 0
      ELSE
         PRINT *, ' >>> USERIN : Invalid ISRBM = ', ISRBM
         PRINT *, '   Will STOP immediately. '
         STOP
      ENDIF
C>>>
      NOIG = NWILD + 1
C      NOIG = 999
C>>>
C--
      NZZ = NDIM
C--
      NCALL  = NCAL
      ITMX1  = ITM1
      ITMX2  = ITM2    
C--
C  Set lower and upper limits.
C--
      DO 100 IX = 1, NDIM
         XL(IX) = 0
         XU(IX) = 1
         IF ( IX.GE.NOIG ) IG(IX) = 0
         ISHUFL(IX) = IX + IOFF
100   CONTINUE
C--
C  Define hists. and plots.
C--
      CALL XHINIT( 1, -1.0D0, 1.0D0, 50,'cos(theta_W)  ')
      CALL XHINIT( 2,  0.0D0,360.D0, 50,'phi_W         ')
      CALL XHINIT( 3,  60.D0,110.D0, 50,'m(W-)         ')
      CALL XHINIT( 4,  60.D0,110.D0, 50,'m(W+)         ')
      CALL XHINIT( 5, -1.0D0, 1.0D0, 50,'cos(theta_fd) ')
      CALL XHINIT( 6,  0.0D0,360.D0, 50,'phi_fd        ')
      CALL XHINIT( 7, -1.0D0, 1.0D0, 50,'cos(theta_fdb)')
      CALL XHINIT( 8,  0.0D0,360.D0, 50,'phi_fdb       ')
      CALL XHINIT( 9,  0.0D0, 1.0D0, 50,'RS/ROOTS      ')
      CALL XHINIT(10,  1.0D0,13.0D0, 12,'W- decay mode ')
      CALL XHINIT(11,  1.0D0,13.0D0, 12,'W+ decay mode ')
C--
C  That's it.
C--
      RETURN
      END
