C* (Update Record)
C*  95/03/12  K.Fujii	Converted to unix. This version
C*			uses the new INSMCN in xcxc_lib.
C*  95/03/21  K.Fujii	Now calls SPPARM.
C*

      SUBROUTINE USERIN
 
      IMPLICIT REAL*8 (A-H,O-Z)
C--
      PARAMETER (MXDIM = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,IG(MXDIM),NCALL
      COMMON /BPARM2/ ACC1,ACC2,ITMX1,ITMX2
C--
      INCLUDE 'WWZCNF.inc'
      INCLUDE 'USRPRM.inc'
=EXPAND 'gen_lib/sm/USMPRM.inc'
=EXPAND 'gen_lib/sm/BEMCNS.inc'
C--
C  Local R*4 variables used in subroutine calls.
C--
      REAL*4   ALF
C
C========< Entry Point >================================================
C
C--
C  Check if inputs from FT05 are consistent with those used in the
C  integration step, when NGETBS = 1. Otherwise, Write the inputs 
C  to 'BASES:Inputs'.
C--
      CALL SPPARM
C--
C  Initialize numerical constants and particle table.
C--
      ALF   = 1/ALFI
      CALL INSMCN(ALF,ALFS,AMSW,AMSZ,AMSH,AMST)
C--
C  Set user constants.
C--
      ROOTS  = SQRTS
      POLE   = POLEBM
      SGEBM  = SGMEBM
      PRINT *, ' ******< Job constants >*********** '
      PRINT *, '  '
      PRINT *, '     ROOTS  = ', ROOTS
      PRINT *, '     SGEBM  = ', SGEBM
      PRINT *, '     POLE   = ', POLE
      PRINT *, '  '
      PRINT *, ' ********************************** '
C--
      IF ( ROOTS.LT.AMSZ+AMSW+AMSW ) THEN
         PRINT *, ' ROOTS is too small. '
         PRINT *, '    AMW = ', AMSW
         PRINT *, '    AMZ = ', AMSZ
      ENDIF
C--
C  Set BASES constants.
C--
             NDIM   = 22
             NWILD  = 10
CZEROWIDTH              NWILD  = 5
C>>> For accumulation.
             NCALL  = 80000
             ITMX1  = 3
             ITMX2  = 3
C>>> For test.
CTEST        NCALL = 1000
CTEST        ITMX1  = 1
CTEST        ITMX2  = 1
C--
C  Set lower and upper limits.
C--
      DO 100 IX = 1, NDIM
         XL(IX) = 0
         XU(IX) = 1
100   CONTINUE
CZEROWIDTH       IG( 6) = 0
CZEROWIDTH       IG( 7) = 0
CZEROWIDTH       IG( 8) = 0
      IG(17) = 0
C--
C  Define hists. and plots.
C--
      CALL XHINIT( 1, -1.0D0, 1.0D0, 50,'cos(theta_Z) ')
      CALL XHINIT( 2,  0.0D0,360.D0, 50,'phi_Z        ')
      CALL XHINIT( 3,  0.0D0, 1.0D0, 50,'m(W-W+)/roots')
      CALL XHINIT( 4, -1.0D0, 1.0D0, 50,'cos(theta_W-)')
      CALL XHINIT( 5,  0.0D0,360.D0, 50,'phi_W-       ')
      CALL XHINIT( 7,  1.0D0,  5.D0,  4,'helicity combination  ')
C--
      CALL DHINIT( 9,0.D0,1.D0,50,-1.D0,1.D0,50,'E_Z/E_bm-cos(theta_Z)')
      CALL DHINIT(10,0.D0,1.D0,50, 0.D0,1.D0,50,'E_W-/E_bm-E_W+/E_bm ')
C--
C  That's it.
C--
      RETURN
      END
