 
      SUBROUTINE SGZZNP(RS,CSTH,SG)
 
      IMPLICIT   REAL*4  ( A-H, O-Z )
      REAL   *4  RS, CSTH, SG
C--
      REAL   *4  GAL(2), GAU(2), GAD(2), GWF(2), GZN(2), GZL(2), GZU(2),
     .           GZD(2), G1(2), GW, GWWZ, GWWA
      REAL   *4  PV(0:3,6)
      COMPLEX*8  SPINOR(4,2), ZVCT(0:3,2), AMP
      INTEGER*4  IHEL(4,18)
      DATA IHEL  / -1,+1,  -1, -1,
     .             -1,+1,  -1,  0,
     .             -1,+1,  -1, +1,
     .             -1,+1,   0, -1,
     .             -1,+1,   0,  0,
     .             -1,+1,   0, +1,
     .             -1,+1,  +1, -1,
     .             -1,+1,  +1,  0,
     .             -1,+1,  +1, +1,
     .             +1,-1,  -1, -1,
     .             +1,-1,  -1,  0,
     .             +1,-1,  -1, +1,
     .             +1,-1,   0, -1,
     .             +1,-1,   0,  0,
     .             +1,-1,   0, +1,
     .             +1,-1,  +1, -1,
     .             +1,-1,  +1,  0,
     .             +1,-1,  +1, +1 /
      DATA NCALL / 0 /
C--
      BETA(X1,X2) = SQRT( 1 - 2*( X1 + X2 ) + ( X1 - X2 )**2 )
C
C========< Entry Point >================================================
C
C--
C  Prepare coupling constants.
C--
      IF ( NCALL.EQ.0 ) THEN
         NCALL  = 1
         ALF    = 1/128.D0
         SN2W   = 0.23D0
         CS2W   = 1 - SN2W
         AMSE   = 0.511D-3
         GAME   = 0.100D-10
         AMSZ   = 91.17D0
         CALL UHCUPL(ALF,SN2W, GAL,GAU,GAD,GWF,GZN,GZL,GZU,GZD,G1,
     .               GW,GWWZ,GWWA)
         x2PI   = 2*ACOS(-1.D0)
         x4PI   = 2*x2PI
         xGV2PB = 3.893796623D8
         FACT   = xGV2PB*x2PI/(x4PI**3)/4
      ENDIF
C--
C  Prepare internal line 4-momenta.
C--
      EBM = RS/2
      CS  = 1
      FI  = 0
      CALL MOMNTx(EBM,AMSE,CS,FI,PV(0,1))
      CALL PMIRRx(PV(0,1),PV(0,2))
      BT1 = BETA( (AMSZ/RS)**2, (AMSZ/RS)**2 )
      CALL MOMNTx(EBM,AMSZ, CSTH,FI,PV(0,3))
      CALL PMIRRx(PV(0,3),PV(0,4))
      CALL PSUBxx(PV(0,1),PV(0,3),PV(0,5))
      CALL PSUBxx(PV(0,1),PV(0,4),PV(0,6))
C--
C  Sum over polarization states.
C--
      AMP2 = 0
      DO 100 IH = 1, 18
C--
C  Prepare spinors for external lines.
C--
         CALL IMxxxx( PV(0,1), IHEL(1,IH),  1, SPINOR(1,1) )
         CALL OMxxxx( PV(0,2), IHEL(2,IH), -1, SPINOR(1,2) )
C--
C  Prepare wave function for Z.
C--
         CALL VMxxxx( PV(0,3), IHEL(3,IH), 1, ZVCT(0,1) )
         CALL VMxxxx( PV(0,4), IHEL(4,IH), 1, ZVCT(0,2) )
C--
C  Calculate amplitude**2.
C--
         CALL AMPZZ (GZL, AMSE,GAME, PV(0,5), ZVCT,
     .               SPINOR(1,1), SPINOR(1,2), AMP)
         AMP2 = AMP2 + ABS(AMP)**2
100   CONTINUE
C--
C  Calculate differential cross section.
C--
      SG = FACT*AMP2*BT1/(2*RS*RS)
      SG = x2PI*SG
C--
C  That's it.
C--
      RETURN
      END
