C* (Update Record)
C*  95/03/12  K.Fujii	Converted to unix. This version
C*			uses the new INSMCN in xcxc_lib.
C*  95/03/21  K.Fujii	Now calls SPPARM.
C*

      SUBROUTINE USERIN
 
      IMPLICIT REAL*8 (A-H,O-Z)
C--
      PARAMETER (MXDIM = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,IG(MXDIM),NCALL
      COMMON /BPARM2/ ACC1,ACC2,ITMX1,ITMX2
C--
      INCLUDE 'ZZCNSF.inc'
      INCLUDE 'USRPRM.inc'
=EXPAND 'gen_lib/sm/USMPRM.inc'
=EXPAND 'gen_lib/sm/BEMCNS.inc'
=EXPAND 'BASESV51/BSITPR.inc'
=EXPAND 'BASESV51/BSHUFL.inc'
C--
C  Local R*4 variables used in subroutine calls.
C--
      REAL*4        ALF
C
C========< Entry Point >================================================
C
C--
C  Check if inputs from FT05 are consistent with those used in the
C  integration step, when NGETBS = 1. Otherwise, Write the inputs 
C  to 'BASES:Inputs'.
C--
      CALL SPPARM
C--
C  Initialize numerical constants and particle table.
C--
      ALF   = 1/ALFI
      CALL INSMCN(ALF,ALFS,AMSW,AMSZ,AMSH,AMST)
C--
C  Set user constants.
C--
      ROOTS  = SQRTS
      POLE   = POLEBM
      SGEBM  = SGMEBM
      ISRBM  = ISRB
      IMD1MN = IMD1LO
      IMD1MX = IMD1HI
      IMD2MN = IMD2LO
      IMD2MX = IMD2HI
      PRINT *, ' ******< Job constants >*********** '
      PRINT *, '  '
      PRINT *, '     ROOTS  = ', ROOTS
      PRINT *, '     POLE   = ', POLE
      PRINT *, '     SGEBM  = ', SGEBM
      PRINT *, '     ISRBM  = ', ISRBM
      PRINT *, '     IMD1MN = ', IMD1MN
      PRINT *, '     IMD1MX = ', IMD1MX
      PRINT *, '     IMD2MN = ', IMD2MN
      PRINT *, '     IMD2MX = ', IMD2MX
      PRINT *, '  '
      PRINT *, ' ********************************** '
C--
      IF ( ROOTS.LT.AMSZ+AMSZ ) THEN
         PRINT *, ' ROOTS is too small. '
         PRINT *, '    AMZ = ', AMSZ
      ENDIF
C--
C  Set BASES constants.
C--
      IF ( ISRBM.EQ.1 ) THEN
         NDIM   = 11
         NWILD  = 4
         IOFF   = 5
      ELSE IF ( ISRBM.EQ.2 ) THEN
         NDIM   = 12
         NWILD  = 5
         IOFF   = 4
      ELSE IF ( ISRBM.EQ.3 ) THEN
         NDIM   = 16
         NWILD  = 9
         IOFF   = 0
      ELSE
         PRINT *, ' >>> USERIN : Invalid ISRBM = ', ISRBM
         PRINT *, '   Will STOP immediately. '
         STOP
      ENDIF
C>>>
      NOIG = NWILD + 1
C      NOIG = 999
C>>>
C--
      NZZ  = NDIM
C--
      NCALL  = NCAL
      ITMX1  = ITM1
      ITMX2  = ITM2    
C--
C  Set lower and upper limits.
C--
      DO 100 IX = 1, NDIM
         XL(IX) = 0
         XU(IX) = 1
         IF ( IX.GE.NOIG ) IG(IX) = 0
         ISHUFL(IX) = IX + IOFF
100   CONTINUE
C--
C  Define hists. and plots.
C--
      CALL XHINIT( 1,  0.0D0, 1.0D0, 50,'rs/roots     ')
      CALL XHINIT( 2, 60.0D0,110.D0, 50,'m(Z)         ')
      CALL XHINIT( 3, 60.0D0,110.D0, 50,'m(Z)         ')
      CALL XHINIT( 4,  0.0D0, 1.0D0, 50,'miss/roots   ')
      CALL XHINIT( 5, -1.0D0, 1.0D0, 50,'cos(theta_Z) ')
      CALL XHINIT( 6,  0.0D0,360.D0, 50,'phi_Z        ')
      CALL XHINIT( 7, -1.0D0, 1.0D0, 50,'cos(theta_f1)')
      CALL XHINIT( 8,  0.0D0,360.D0, 50,'phi_f1       ')
      CALL XHINIT( 9, -1.0D0, 1.0D0, 50,'cos(theta_f2)')
      CALL XHINIT(10,  0.0D0,360.D0, 50,'phi_f2       ')
      CALL XHINIT(11,  1.0D0,  9.D0,  8,'helicity     ')
      CALL XHINIT(12,  1.0D0, 25.D0, 24,'Z decay modes')
C--
C  That's it.
C--
      RETURN
      END
